// Generated by LiveScript 1.3.1
(function(){
  var timeLimitedPromise, toString$ = {}.toString;
  QUnit.module('core-js');
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  test('delay', function(it){
    it.expect(3);
    ok(toString$.call(delay).slice(8, -1) === 'Function', 'is function');
    ok(delay(42) instanceof Promise, 'returns promises');
    timeLimitedPromise(1e3, function(res){
      delay(10).then(function(it){
        res(it);
      });
    }).then(function(it){
      return ok(it === true, 'resolves as `true`');
    })['catch'](function(){
      return ok(false, 'rejected');
    }).then(it.async());
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, keys, create, assign, from, global, toString$ = {}.toString;
  QUnit.module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  keys = Object.keys, create = Object.create, assign = Object.assign;
  from = Array.from;
  global = this;
  test('Dict', function(){
    var dict1, dict2, dict3, done, iter;
    ok(isFunction(global.Dict), 'Is function');
    dict1 = Dict();
    ok(!(dict1 instanceof Object));
    deepEqual(keys(dict1), []);
    dict2 = Dict({
      q: 1,
      w: 2
    });
    ok(!(dict2 instanceof Object));
    deepEqual(keys(dict2), ['q', 'w']);
    ok(dict2.q === 1);
    ok(dict2.w === 2);
    dict3 = Dict(new Set([1, 2]).entries());
    ok(!(dict3 instanceof Object));
    deepEqual(keys(dict3), ['1', '2']);
    ok(dict3[1] === 1);
    ok(dict3[2] === 2);
    done = false;
    iter = [null, 1, 2].values();
    iter['return'] = function(){
      return done = true;
    };
    try {
      new Dict(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
  });
  test('Dict.every', function(){
    var every, obj, ctx;
    every = Dict.every;
    ok(isFunction(every), 'Is function');
    every(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(every({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(!every({
      q: 1,
      w: '2',
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('Dict.filter', function(){
    var filter, obj, ctx;
    filter = Dict.filter;
    ok(isFunction(filter), 'Is function');
    filter(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    deepEqual(filter({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return it % 2;
    }), Dict({
      q: 1,
      e: 3
    }));
  });
  test('Dict.find', function(){
    var find, obj, ctx;
    find = Dict.find;
    ok(isFunction(find), 'Is function');
    find(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(find({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return !(it % 2);
    }) === 2);
  });
  test('Dict.findKey', function(){
    var findKey, obj, ctx;
    findKey = Dict.findKey;
    ok(isFunction(findKey), 'Is function');
    findKey(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(findKey({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return it === 2;
    }) === 'w');
  });
  test('Dict.forEach', function(){
    var forEach, obj, ctx, rez;
    forEach = Dict.forEach;
    ok(isFunction(forEach), 'Is function');
    forEach(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      ok(this === ctx);
    }, ctx = {});
    rez = {};
    forEach({
      q: 1,
      w: 2
    }, function(){
      rez[arguments[1]] = arguments[0] + this;
    }, '_');
    deepEqual(rez, {
      q: '1_',
      w: '2_'
    });
    rez = true;
    forEach(obj = {
      q: 1,
      w: 2
    }, function(){
      var rez;
      rez && (rez = obj === arguments[2]);
    });
    ok(rez);
    rez = {};
    forEach(Object.make({
      e: 3
    }, {
      q: 1,
      w: 2
    }), function(){
      rez[arguments[1]] = arguments[0];
    });
    ok(!('e' in rez));
    rez = {};
    forEach([1, 2], function(){
      rez[arguments[1]] = arguments[0];
    });
    ok(!('length' in rez));
    rez = {};
    forEach('123', function(){
      rez[arguments[1]] = arguments[0];
    });
    ok('2' in rez);
  });
  test('Dict.keyOf', function(){
    var keyOf;
    keyOf = Dict.keyOf;
    ok(isFunction(keyOf), 'Is function');
    ok(keyOf({
      q: 1,
      w: 2,
      e: 3
    }, 2) === 'w');
    ok(keyOf({
      q: 1,
      w: 2,
      e: 3
    }, 4) === void 8);
    ok(keyOf({
      q: 1,
      w: 2,
      e: NaN
    }, NaN) === void 8);
  });
  test('Dict.map', function(){
    var map, obj, ctx;
    map = Dict.map;
    ok(isFunction(map), 'Is function');
    map(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    deepEqual(map({
      q: 1,
      w: 2,
      e: 3
    }, (function(it){
      return Math.pow(it, 2);
    })), Dict({
      q: 1,
      w: 4,
      e: 9
    }));
  });
  test('Dict.mapPairs', function(){
    var mapPairs, obj, ctx;
    mapPairs = Dict.mapPairs;
    ok(isFunction(mapPairs), 'Is function');
    mapPairs(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    deepEqual(mapPairs({
      q: 1,
      w: 2,
      e: 3
    }, function(v, k){
      return v !== 2 && [k + k, v * v];
    }), Dict({
      qq: 1,
      ee: 9
    }));
  });
  test('Dict.reduce', function(){
    var reduce, obj, foo, memo;
    reduce = Dict.reduce;
    ok(isFunction(reduce), 'Is function');
    reduce(obj = {
      a: 1
    }, function(memo, val, key, that){
      ok(memo === foo);
      ok(val === 1);
      ok(key === 'a');
      return ok(that === obj);
    }, foo = {});
    reduce({
      a: 1,
      b: 2
    }, function(memo, val, key){
      ok(memo === 1);
      ok(val === 2);
      return ok(key === 'b');
    });
    reduce({
      q: 1,
      w: 2,
      e: 3
    }, function(that, it){
      that[it] = it;
      return that;
    }, memo = {});
    deepEqual(memo, {
      1: 1,
      2: 2,
      3: 3
    });
  });
  test('Dict.some', function(){
    var some, obj, ctx;
    some = Dict.some;
    ok(isFunction(some), 'Is function');
    some(obj = {
      q: 1
    }, function(val, key, that){
      ok(val === 1);
      ok(key === 'q');
      ok(that === obj);
      return ok(this === ctx);
    }, ctx = {});
    ok(!some({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(some({
      q: 1,
      w: '2',
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
  });
  test('Dict.includes', function(){
    var includes, dict, o;
    includes = Dict.includes;
    ok(isFunction(includes), 'Is function');
    dict = {
      q: 1,
      w: NaN,
      e: -0,
      r: o = {}
    };
    ok(includes(dict, 1));
    ok(includes(dict, -0));
    ok(includes(dict, 0));
    ok(includes(dict, NaN));
    ok(includes(dict, o));
    ok(!includes(dict, 4));
    ok(!includes(dict, -0.5));
    ok(!includes(dict, {}));
  });
  test('Dict.has', function(){
    var has;
    has = Dict.has;
    ok(isFunction(has), 'Is function');
    ok(has({
      q: 1
    }, 'q'));
    ok(!has({
      q: 1
    }, 'w'));
    ok(has([1], 0));
    ok(!has([], 0));
    ok(!has(clone$({
      q: 1
    }), 'q'));
    ok(!has({}, 'toString'));
  });
  test('Dict.get', function(){
    var get;
    get = Dict.get;
    ok(isFunction(get), 'Is function');
    ok(get({
      q: 1
    }, 'q') === 1);
    ok(get({
      q: 1
    }, 'w') === void 8);
    ok(get([1], 0) === 1);
    ok(get([], 0) === void 8);
    ok(get(clone$({
      q: 1
    }), 'q') === void 8);
    ok(get({}, 'toString') === void 8);
  });
  test('Dict.values', function(){
    var values, iter;
    values = Dict.values;
    ok(isFunction(values), 'Is function');
    iter = values({});
    ok(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    ok('next' in iter);
    deepEqual(from(values({
      q: 1,
      w: 2,
      e: 3
    })), [1, 2, 3]);
    deepEqual(from(values(new String('qwe'))), ['q', 'w', 'e']);
    deepEqual(from(values(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), [4, 5, 6]);
  });
  test('Dict.keys', function(){
    var keys, iter;
    keys = Dict.keys;
    ok(isFunction(keys), 'Is function');
    iter = keys({});
    ok(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    ok('next' in iter);
    deepEqual(from(keys({
      q: 1,
      w: 2,
      e: 3
    })), ['q', 'w', 'e']);
    deepEqual(from(keys(new String('qwe'))), ['0', '1', '2']);
    deepEqual(from(keys(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), ['a', 's', 'd']);
  });
  test('Dict.entries', function(){
    var entries, iter;
    entries = Dict.entries;
    ok(isFunction(entries), 'Is function');
    iter = entries({});
    ok(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    ok('next' in iter);
    deepEqual(from(entries({
      q: 1,
      w: 2,
      e: 3
    })), [['q', 1], ['w', 2], ['e', 3]]);
    deepEqual(from(entries(new String('qwe'))), [['0', 'q'], ['1', 'w'], ['2', 'e']]);
    deepEqual(from(entries(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), [['a', 4], ['s', 5], ['d', 6]]);
  });
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, toString$ = {}.toString;
  QUnit.module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Function#part', function(){
    var obj, $, fn, part;
    ok(isFunction(Function.prototype.part), 'Is function');
    ok(function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }.part('qwe')());
    obj = {
      a: 42
    };
    obj.fn = function(it){
      return this.a + it;
    }.part(21);
    ok(obj.fn() === 63);
    $ = _;
    fn = function(){
      return Array.prototype.map.call(arguments, String).join(' ');
    };
    part = fn.part($, 'Саша', $, 'шоссе', $, 'сосала');
    ok(isFunction(part), '.part with placeholders return function');
    ok(part('Шла', 'по') === 'Шла Саша по шоссе undefined сосала', '.part with placeholders: args < placeholders');
    ok(part('Шла', 'по', 'и') === 'Шла Саша по шоссе и сосала', '.part with placeholders: args == placeholders');
    ok(part('Шла', 'по', 'и', 'сушку') === 'Шла Саша по шоссе и сосала сушку', '.part with placeholders: args > placeholders');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var global, from;
  QUnit.module('core-js');
  global = Function('return this')();
  from = Array.from;
  test('core.getIteratorMethod', function(){
    var getIteratorMethod, iterFn, iter;
    getIteratorMethod = core.getIteratorMethod;
    ok(typeof getIteratorMethod === 'function', 'Is function');
    strictEqual(getIteratorMethod({}), void 8);
    iterFn = getIteratorMethod([]);
    ok(typeof iterFn === 'function');
    iter = iterFn.call([]);
    ok('next' in iter);
    iter = getIteratorMethod(function(){
      return arguments;
    }());
    ok(typeof iterFn === 'function');
    /*
    _Symbol = global.Symbol
    I = Math.random!
    O = {0: \a, 1: \b, 2: \c, length: 3}
    O[I] = Array::values
    strictEqual getIteratorMethod(O), void
    global.Symbol = {iterator: I}
    strictEqual getIteratorMethod(O), Array::values
    deepEqual from(getIteratorMethod(O).call O), <[a b c]>
    global.Symbol = _Symbol
    strictEqual getIteratorMethod(O), void
    */
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var global, from;
  QUnit.module('core-js');
  global = Function('return this')();
  from = Array.from;
  test('core.getIterator', function(){
    var getIterator, iter;
    getIterator = core.getIterator;
    ok(typeof getIterator === 'function', 'Is function');
    throws(function(){
      getIterator({});
    }, TypeError);
    iter = getIterator([]);
    ok('next' in iter);
    iter = getIterator(function(){
      return arguments;
    }());
    ok('next' in iter);
    /*
    _Symbol = global.Symbol
    I = Math.random!
    O = {0: \a, 1: \b, 2: \c, length: 3}
    O[I] = Array::values
    throws (!-> getIterator O), TypeError
    global.Symbol = {iterator: I}
    try
      getIterator O
      ok on
    catch => ok no
    deepEqual from(getIterator O), <[a b c]>
    global.Symbol = _Symbol
    throws (!-> getIterator O), TypeError
    */
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var global;
  QUnit.module('core-js');
  global = Function('return this')();
  test('core.isIterable', function(){
    var isIterable;
    isIterable = core.isIterable;
    ok(typeof isIterable === 'function', 'Is function');
    ok(!isIterable({}));
    ok(isIterable([]));
    ok(isIterable(function(){
      return arguments;
    }()));
    /*
    _Symbol = global.Symbol
    I = Math.random!
    o = {0: \a, 1: \b, 2: \c, length: 3}
    o[I] = Array::values
    ok !isIterable o
    global.Symbol = {iterator: I}
    ok isIterable o
    global.Symbol = _Symbol
    ok !isIterable o
    */
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, isObject, methods, toString$ = {}.toString;
  QUnit.module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isObject = function(it){
    return it === Object(it);
  };
  methods = ['assert', 'count', 'debug', 'dir', 'dirxml', 'error', 'exception', 'group', 'groupEnd', 'groupCollapsed', 'groupEnd', 'info', 'log', 'table', 'trace', 'warn', 'markTimeline', 'profile', 'profileEnd', 'time', 'timeEnd', 'timeStamp'];
  test('log is object', function(){
    ok(isObject(log), 'global.log is object');
  });
  test('log.{..} are functions', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFunction(log[x$]), "log." + x$ + " is function");
    }
  });
  test('call log.{..}', function(){
    var i$, ref$, len$, m;
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      m = ref$[i$];
      ok((fn$()), "call log." + m);
    }
    function fn$(){
      try {
        if (m === 'profileEnd') {
          log[m]();
        } else {
          log[m]('foo');
        }
        return true;
      } catch (e$) {}
    }
  });
  test('call unbound log.#{..}', function(){
    var i$, ref$, len$, m;
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      m = ref$[i$];
      ok((fn$()), "call unbound log." + m);
    }
    function fn$(){
      try {
        if (m === 'profileEnd') {
          log[m].call(void 8);
        } else {
          log[m].call(void 8, 'foo');
        }
        return true;
      } catch (e$) {}
    }
  });
  test('log.{enable, disable}', function(){
    var enable, disable;
    enable = log.enable, disable = log.disable;
    ok(isFunction(enable), 'log.enable is function');
    ok(isFunction(disable), 'log.disable is function');
    ok((function(){
      try {
        disable();
        return true;
      } catch (e$) {}
    }()), 'disable log');
    ok((function(){
      try {
        return log.log('call disabled log') === void 8;
      } catch (e$) {}
    }()), 'call disabled log');
    ok((function(){
      try {
        enable();
        return true;
      } catch (e$) {}
    }()), 'enable log');
  });
  test('log', function(){
    ok(isFunction(log), 'global.log is function');
    ok((function(){
      try {
        log(42);
        return true;
      } catch (e$) {}
    }()), 'call log');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Number#@@iterator', function(){
    var iterator, toStringTag, iter1, iter2, iter3, iter4, iter5, iter6;
    iterator = Symbol.iterator, toStringTag = Symbol.toStringTag;
    ok(toString$.call(Number.prototype[iterator]).slice(8, -1) === 'Function', 'Is function');
    iter1 = 2[iterator]();
    ok(iter1[toStringTag] === 'Number Iterator', '@@toStringTag');
    deepEqual(iter1.next(), {
      done: false,
      value: 0
    }, '2 #1');
    deepEqual(iter1.next(), {
      done: false,
      value: 1
    }, '2 #2');
    deepEqual(iter1.next(), {
      done: true,
      value: void 8
    }, '2 #3');
    iter2 = 1.5[iterator]();
    deepEqual(iter2.next(), {
      done: false,
      value: 0
    }, '1.5 #1');
    deepEqual(iter2.next(), {
      done: false,
      value: 1
    }, '1.5 #2');
    deepEqual(iter2.next(), {
      done: true,
      value: void 8
    }, '1.5 #3');
    iter3 = (-1)[iterator]();
    deepEqual(iter3.next(), {
      done: true,
      value: void 8
    }, '-1');
    iter4 = NaN[iterator]();
    deepEqual(iter4.next(), {
      done: true,
      value: void 8
    }, 'NaN');
    iter5 = Infinity[iterator]();
    deepEqual(iter5.next(), {
      done: false,
      value: 0
    }, 'Infinity #1');
    deepEqual(iter5.next(), {
      done: false,
      value: 1
    }, 'Infinity #1');
    deepEqual(iter5.next(), {
      done: false,
      value: 2
    }, 'Infinity #1');
    iter6 = (-Infinity)[iterator]();
    deepEqual(iter6.next(), {
      done: true,
      value: void 8
    }, '-Infinity');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.classof', function(){
    var classof, Class;
    classof = Object.classof;
    ok(toString$.call(classof).slice(8, -1) === 'Function', 'Is function');
    ok(classof(void 8) === 'Undefined', 'classof undefined is `Undefined`');
    ok(classof(null) === 'Null', 'classof null is `Null`');
    ok(classof(true) === 'Boolean', 'classof bool is `Boolean`');
    ok(classof('string') === 'String', 'classof string is `String`');
    ok(classof(7) === 'Number', 'classof number is `Number`');
    ok(classof(Symbol()) === 'Symbol', 'classof symbol is `Symbol`');
    ok(classof(new Boolean(false)) === 'Boolean', 'classof new Boolean is `Boolean`');
    ok(classof(new String('')) === 'String', 'classof new String is `String`');
    ok(classof(new Number(7)) === 'Number', 'classof new Number is `Number`');
    ok(classof({}) === 'Object', 'classof {} is `Object`');
    ok(classof([]) === 'Array', 'classof array is `Array`');
    ok(classof(function(){}) === 'Function', 'classof function is `Function`');
    ok(classof(/./) === 'RegExp', 'classof regexp is `Undefined`');
    ok(classof(TypeError()) === 'Error', 'classof new TypeError is `RegExp`');
    ok(classof(function(){
      return arguments;
    }()) === 'Arguments', 'classof arguments list is `Arguments`');
    ok(classof(new Set) === 'Set', 'classof undefined is `Map`');
    ok(classof(new Map) === 'Map', 'classof map is `Undefined`');
    ok(classof(new WeakSet) === 'WeakSet', 'classof weakset is `WeakSet`');
    ok(classof(new WeakMap) === 'WeakMap', 'classof weakmap is `WeakMap`');
    ok(classof(new Promise(function(){})) === 'Promise', 'classof promise is `Promise`');
    ok(classof(''[Symbol.iterator]()) === 'String Iterator', 'classof String Iterator is `String Iterator`');
    ok(classof([].entries()) === 'Array Iterator', 'classof Array Iterator is `Array Iterator`');
    ok(classof(new Set().entries()) === 'Set Iterator', 'classof Set Iterator is `Set Iterator`');
    ok(classof(new Map().entries()) === 'Map Iterator', 'classof Map Iterator is `Map Iterator`');
    ok(classof(Math) === 'Math', 'classof Math is `Math`');
    if (typeof JSON != 'undefined' && JSON !== null) {
      ok(classof(JSON) === 'JSON', 'classof JSON is `JSON`');
    }
    Class = (function(){
      Class.displayName = 'Class';
      var prototype = Class.prototype, constructor = Class;
      Class.prototype[Symbol.toStringTag] = 'Class';
      function Class(){}
      return Class;
    }());
    ok(classof(new Class) === 'Class', 'classof user class is [Symbol.toStringTag]');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.define', function(){
    var define, defineProperty, foo, foo2;
    define = Object.define, defineProperty = Object.defineProperty;
    ok(toString$.call(define).slice(8, -1) === 'Function', 'Is function');
    foo = {
      q: 1
    };
    ok(foo === define(foo, {
      w: 2
    }));
    ok(foo.w === 2);
    if (function(){
      try {
        return 2 === defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      foo = {
        q: 1
      };
      foo2 = defineProperty({}, 'w', {
        get: function(){
          return this.q + 1;
        }
      });
      define(foo, foo2);
      ok(foo.w === 2);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.isObject', function(){
    var isObject;
    isObject = Object.isObject;
    ok(toString$.call(isObject).slice(8, -1) === 'Function', 'Is function');
    ok(!isObject(void 8), 'isObject undefined return false');
    ok(!isObject(null), 'isObject null return false');
    ok(!isObject(1), 'isObject number return false');
    ok(!isObject(true), 'isObject bool return false');
    ok(!isObject('string'), 'isObject string return false');
    ok(isObject(new Number(1)), 'isObject new Number return true');
    ok(isObject(new Boolean(false)), 'isObject new Boolean return true');
    ok(isObject(new String(1)), 'isObject new String return true');
    ok(isObject({}), 'isObject object return true');
    ok(isObject([]), 'isObject array return true');
    ok(isObject(/./), 'isObject regexp return true');
    ok(isObject(function(){}), 'isObject function return true');
    ok(isObject(new function(){}), 'isObject constructor instance return true');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('core-js');
  test('Object.make', function(){
    var make, object, foo;
    make = Object.make;
    ok(toString$.call(make).slice(8, -1) === 'Function', 'Is function');
    object = make(foo = {
      q: 1
    }, {
      w: 2
    });
    ok(Object.getPrototypeOf(object) === foo);
    ok(object.w === 2);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('core-js');
  eq = strictEqual;
  test('String#escapeHTML', function(){
    ok(toString$.call(String.prototype.escapeHTML).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(String.prototype.escapeHTML), 'looks like native');
    eq(String.prototype.escapeHTML.length, 0, 'arity is 0');
    if ('name' in String.prototype.escapeHTML) {
      eq(String.prototype.escapeHTML.name, 'escapeHTML', 'name is "escapeHTML"');
    }
    eq('qwe, asd'.escapeHTML(), 'qwe, asd');
    eq('<div>qwe</div>'.escapeHTML(), '&lt;div&gt;qwe&lt;/div&gt;');
    eq("&<>\"'".escapeHTML(), '&amp;&lt;&gt;&quot;&apos;');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('core-js');
  eq = strictEqual;
  test('String#unescapeHTML', function(){
    ok(toString$.call(String.prototype.unescapeHTML).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(String.prototype.unescapeHTML), 'looks like native');
    eq(String.prototype.unescapeHTML.length, 0, 'arity is 0');
    if ('name' in String.prototype.unescapeHTML) {
      eq(String.prototype.unescapeHTML.name, 'unescapeHTML', 'name is "unescapeHTML"');
    }
    eq('qwe, asd'.unescapeHTML(), 'qwe, asd');
    eq('&lt;div&gt;qwe&lt;/div&gt;'.unescapeHTML(), '<div>qwe</div>');
    eq('&amp;&lt;&gt;&quot;&apos;'.unescapeHTML(), "&<>\"'");
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, eq, deq, toString$ = {}.toString;
  QUnit.module('ES5');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  eq = strictEqual;
  deq = deepEqual;
  test('Object.getOwnPropertyDescriptor', function(){
    var getOwnPropertyDescriptor;
    getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
    ok(isFunction(getOwnPropertyDescriptor), 'Is function');
    deepEqual(getOwnPropertyDescriptor({
      q: 42
    }, 'q'), {
      writable: true,
      enumerable: true,
      configurable: true,
      value: 42
    });
    ok(getOwnPropertyDescriptor({}, 'toString') === void 8);
  });
  test('Object.defineProperty', function(){
    var defineProperty, rez, src;
    defineProperty = Object.defineProperty;
    ok(isFunction(defineProperty), 'Is function');
    ok((rez = defineProperty(src = {}, 'q', {
      value: 42
    })) === src);
    ok(rez.q === 42);
  });
  test('Object.defineProperties', function(){
    var defineProperties, rez, src;
    defineProperties = Object.defineProperties;
    ok(isFunction(defineProperties), 'Is function');
    ok((rez = defineProperties(src = {}, {
      q: {
        value: 42
      },
      w: {
        value: 33
      }
    })) === src);
    ok(rez.q === 42) && rez.w === 33;
  });
  test('Object.getPrototypeOf', function(){
    var create, getPrototypeOf, fn, obj, foo, bar;
    create = Object.create, getPrototypeOf = Object.getPrototypeOf;
    ok(isFunction(getPrototypeOf), 'Is function');
    ok(getPrototypeOf({}) === Object.prototype);
    ok(getPrototypeOf([]) === Array.prototype);
    ok(getPrototypeOf(new (fn = (function(){
      fn.displayName = 'fn';
      var prototype = fn.prototype, constructor = fn;
      function fn(){}
      return fn;
    }()))) === fn.prototype);
    ok(getPrototypeOf(create(obj = {
      q: 1
    })) === obj);
    ok(getPrototypeOf(create(null)) === null);
    ok(getPrototypeOf(getPrototypeOf({})) === null);
    foo = function(){};
    foo.prototype.foo = 'foo';
    bar = function(){};
    bar.prototype = create(foo.prototype);
    bar.prototype.constructor = bar;
    eq(getPrototypeOf(bar.prototype).foo, 'foo');
  });
  test('Object.getOwnPropertyNames', function(){
    var getOwnPropertyNames, fn1, fn2;
    getOwnPropertyNames = Object.getOwnPropertyNames;
    ok(isFunction(getOwnPropertyNames), 'Is function');
    fn1 = function(w){
      this.w = w != null ? w : 2;
    };
    fn2 = function(toString){
      this.toString = toString != null ? toString : 2;
    };
    fn1.prototype.q = fn2.prototype.q = 1;
    deq(getOwnPropertyNames([1, 2, 3]), ['0', '1', '2', 'length']);
    deq(getOwnPropertyNames(new fn1(1)), ['w']);
    deq(getOwnPropertyNames(new fn2(1)), ['toString']);
    ok(in$('toString', getOwnPropertyNames(Array.prototype)));
    ok(in$('toString', getOwnPropertyNames(Object.prototype)));
    ok(in$('constructor', getOwnPropertyNames(Object.prototype)));
  });
  test('Object.create', function(){
    var create, getPrototypeOf, getOwnPropertyNames, isObject, isPrototype, getPropertyNames, obj, fn;
    create = Object.create, getPrototypeOf = Object.getPrototypeOf, getOwnPropertyNames = Object.getOwnPropertyNames;
    isObject = function(it){
      return it === Object(it);
    };
    isPrototype = function(a, b){
      return {}.isPrototypeOf.call(a, b);
    };
    getPropertyNames = function(object){
      var result, i$, x$, ref$, len$;
      result = getOwnPropertyNames(object);
      while (object = getPrototypeOf(object)) {
        for (i$ = 0, len$ = (ref$ = getOwnPropertyNames(object)).length; i$ < len$; ++i$) {
          x$ = ref$[i$];
          in$(x$, result) || result.push(x$);
        }
      }
      return result;
    };
    ok(isFunction(create), 'Is function');
    ok(isPrototype(obj = {
      q: 1
    }, create(obj)));
    ok(create(obj).q === 1);
    fn = function(){
      return this.a = 1;
    };
    ok(create(new fn) instanceof fn);
    ok(fn.prototype === getPrototypeOf(getPrototypeOf(create(new fn))));
    ok(create(new fn).a === 1);
    ok(create({}, {
      a: {
        value: 42
      }
    }).a === 42);
    ok(isObject(obj = create(null, {
      w: {
        value: 2
      }
    })));
    ok(!('toString' in obj));
    ok(obj.w === 2);
    deq(getPropertyNames(create(null)), []);
  });
  test('Object.keys', function(){
    var keys, fn1, fn2;
    keys = Object.keys;
    ok(isFunction(keys), 'Is function');
    fn1 = function(w){
      this.w = w != null ? w : 2;
    };
    fn2 = function(toString){
      this.toString = toString != null ? toString : 2;
    };
    fn1.prototype.q = fn2.prototype.q = 1;
    deq(keys([1, 2, 3]), ['0', '1', '2']);
    deq(keys(new fn1(1)), ['w']);
    deq(keys(new fn2(1)), ['toString']);
    ok(!in$('push', keys(Array.prototype)));
  });
  test('Object.seal', function(){
    var seal, a;
    seal = Object.seal;
    ok(isFunction(seal), 'Is function');
    eq(seal(a = {}), a);
  });
  test('Object.freeze', function(){
    var freeze, a;
    freeze = Object.freeze;
    ok(isFunction(freeze), 'Is function');
    eq(freeze(a = {}), a);
  });
  test('Object.preventExtensions', function(){
    var preventExtensions, a;
    preventExtensions = Object.preventExtensions;
    ok(isFunction(preventExtensions), 'Is function');
    eq(preventExtensions(a = {}), a);
  });
  test('Object.isSealed', function(){
    var isSealed;
    isSealed = Object.isSealed;
    ok(isFunction(isSealed), 'Is function');
    eq(isSealed({}), false);
  });
  test('Object.isFrozen', function(){
    var isFrozen;
    isFrozen = Object.isFrozen;
    ok(isFunction(isFrozen), 'Is function');
    eq(isFrozen({}), false);
  });
  test('Object.isExtensible', function(){
    var isExtensible;
    isExtensible = Object.isExtensible;
    ok(isFunction(isExtensible), 'Is function');
    eq(isExtensible({}), true);
  });
  test('Function#bind', function(){
    var obj, fn, inst, F, date;
    ok(isFunction(Function.prototype.bind), 'Is function');
    obj = {
      a: 42
    };
    ok(42 === function(){
      return this.a;
    }.bind(obj)());
    ok(void 8 === new (function(){}.bind(obj))().a);
    fn = function(a, b){
      this.a = a;
      this.b = b;
    };
    inst = new (fn.bind(null, 1))(2);
    ok(inst instanceof fn);
    eq(inst.a, 1);
    eq(inst.b, 2);
    ok(42 === function(it){
      return it;
    }.bind(null, 42)());
    fn = RegExp.prototype.test.bind(/a/);
    ok(fn('a'));
    F = Date.bind(null, 2015);
    date = new F(6);
    ok(date instanceof Date);
    eq(date.getFullYear(), 2015);
    eq(date.getMonth(), 6);
  });
  test('Array.isArray', function(){
    var isArray;
    isArray = Array.isArray;
    ok(isFunction(isArray), 'Is function');
    ok(!isArray({}));
    ok(!isArray(function(){
      return arguments;
    }()));
    ok(isArray([]));
  });
  test('ES5 Array prototype methods are functions', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = ['indexOf', 'lastIndexOf', 'every', 'some', 'forEach', 'map', 'filter', 'reduce', 'reduceRight']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFunction(Array.prototype[x$]), "Array::" + x$ + " is function");
    }
  });
  test('Array#slice', function(){
    var slice, arr, str, list, ref$, e;
    slice = Array.prototype.slice;
    arr = ['1', '2', '3', '4', '5'];
    deq(arr.slice(), arr);
    deq(arr.slice(1, 3), ['2', '3']);
    deq(arr.slice(1, void 8), ['2', '3', '4', '5']);
    deq(arr.slice(1, -1), ['2', '3', '4']);
    deq(arr.slice(-2, -1), ['4']);
    deq(arr.slice(-2, -3), []);
    str = '12345';
    deq(slice.call(str), arr);
    deq(slice.call(str, 1, 3), ['2', '3']);
    deq(slice.call(str, 1, void 8), ['2', '3', '4', '5']);
    deq(slice.call(str, 1, -1), ['2', '3', '4']);
    deq(slice.call(str, -2, -1), ['4']);
    deq(slice.call(str, -2, -3), []);
    if (list = typeof document != 'undefined' && document !== null ? (ref$ = document.body) != null ? ref$.childNodes : void 8 : void 8) {
      try {
        eq(toString$.call(slice.call(list)).slice(8, -1), 'Array');
      } catch (e$) {
        e = e$;
        ok(false);
      }
    }
  });
  test('Array#join', function(){
    eq(Array.prototype.join.call('123'), '1,2,3');
    eq(Array.prototype.join.call('123', '|'), '1|2|3');
  });
  test('Array#indexOf', function(){
    ok(0 === [1, 1, 1].indexOf(1));
    ok(-1 === [1, 2, 3].indexOf(1, 1));
    ok(1 === [1, 2, 3].indexOf(2, 1));
    ok(-1 === [NaN].indexOf(NaN));
    ok(3 === Array(2).concat([1, 2, 3]).indexOf(2));
    ok(-1 === Array(1).indexOf(void 8));
  });
  test('Array#lastIndexOf', function(){
    eq(2, [1, 1, 1].lastIndexOf(1));
    eq(-1, [1, 2, 3].lastIndexOf(3, 1));
    eq(1, [1, 2, 3].lastIndexOf(2, 1));
    eq(-1, [NaN].lastIndexOf(NaN));
    eq(1, [1, 2, 3].concat(Array(2)).lastIndexOf(2));
  });
  test('Array#every', function(){
    var a, ctx, rez, arr;
    (a = [1]).every(function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    ok([1, 2, 3].every(function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok([1, 2, 3].every((function(it){
      return it < 4;
    })));
    ok(![1, 2, 3].every((function(it){
      return it < 3;
    })));
    ok(![1, 2, 3].every(function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok([1, 2, 3].every(function(){
      return +this === 1;
    }, 1));
    rez = '';
    [1, 2, 3].every(function(){
      return rez += arguments[1];
    });
    ok(rez === '012');
    ok((arr = [1, 2, 3]).every(function(){
      return arguments[2] === arr;
    }));
  });
  test('Array#some', function(){
    var a, ctx, rez, arr;
    (a = [1]).some(function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    ok([1, '2', 3].some(function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok([1, 2, 3].some((function(it){
      return it < 3;
    })));
    ok(![1, 2, 3].some((function(it){
      return it < 0;
    })));
    ok(![1, 2, 3].some(function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(![1, 2, 3].some(function(){
      return +this !== 1;
    }, 1));
    rez = '';
    [1, 2, 3].some(function(){
      rez += arguments[1];
      return false;
    });
    ok(rez === '012');
    ok(!(arr = [1, 2, 3]).some(function(){
      return arguments[2] !== arr;
    }));
  });
  test('Array#forEach', function(){
    var a, ctx, rez, arr;
    (a = [1]).forEach(function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      ok(this === ctx);
    }, ctx = {});
    rez = '';
    [1, 2, 3].forEach(function(it){
      rez += it;
    });
    ok(rez === '123');
    rez = '';
    [1, 2, 3].forEach(function(){
      rez += arguments[1];
    });
    ok(rez === '012');
    rez = '';
    [1, 2, 3].forEach(function(){
      rez += arguments[2];
    });
    ok(rez === '1,2,31,2,31,2,3');
    rez = '';
    [1, 2, 3].forEach(function(){
      rez += this;
    }, 1);
    ok(rez === '111');
    rez = '';
    arr = [];
    arr[5] = '';
    arr.forEach(function(arg$, k){
      rez += k;
    });
    ok(rez === '5');
  });
  test('Array#map', function(){
    var a, ctx;
    (a = [1]).map(function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    deq([2, 3, 4], [1, 2, 3].map((function(it){
      return it + 1;
    })));
    deq([1, 3, 5], [1, 2, 3].map(curry$(function(x$, y$){
      return x$ + y$;
    })));
    deq([2, 2, 2], [1, 2, 3].map(function(){
      return +this;
    }, 2));
  });
  test('Array#filter', function(){
    var a, ctx;
    (a = [1]).filter(function(val, key, that){
      ok(val === 1);
      ok(key === 0);
      ok(that === a);
      return ok(this === ctx);
    }, ctx = {});
    deq([1, 2, 3, 4, 5], [1, 2, 3, 'q', {}, 4, true, 5].filter(function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('Array#reduce', function(){
    var a;
    ok(-5 === [5, 4, 3, 2, 1].reduce(curry$(function(x$, y$){
      return x$ - y$;
    })));
    (a = [1]).reduce(function(memo, val, key, that){
      ok(memo === 42);
      ok(val === 1);
      ok(key === 0);
      return ok(that === a);
    }, 42);
    [42, 43].reduce(function(it){
      return ok(it === 42);
    });
  });
  test('Array#reduceRight', function(){
    var a;
    ok(-5 === [1, 2, 3, 4, 5].reduceRight(curry$(function(x$, y$){
      return x$ - y$;
    })));
    (a = [1]).reduceRight(function(memo, val, key, that){
      ok(memo === 42);
      ok(val === 1);
      ok(key === 0);
      return ok(that === a);
    }, 42);
    [42, 43].reduceRight(function(it){
      return ok(it === 43);
    });
  });
  test('Date.now', function(){
    var now;
    now = Date.now;
    ok(isFunction(now), 'Is function');
    ok(+new Date - now() < 10, 'Date.now() ~ +new Date');
  });
  test('Date#toISOString', function(){
    var ft, bc;
    ok(isFunction(Date.prototype.toISOString), 'Is function');
    eq(new Date(0).toISOString(), '1970-01-01T00:00:00.000Z');
    eq(new Date(1e12 + 1).toISOString(), '2001-09-09T01:46:40.001Z');
    eq(new Date(-5e13 - 1).toISOString(), '0385-07-25T07:06:39.999Z');
    ft = new Date(1e15 + 1).toISOString();
    ok(ft === '+033658-09-27T01:46:40.001Z' || ft === '33658-09-27T01:46:40.001Z');
    bc = new Date(-1e15 + 1).toISOString();
    ok(bc === '-029719-04-05T22:13:20.001Z' || bc === '-29719-04-05T22:13:20.001Z');
    throws(function(){
      return new Date(NaN).toISOString();
    }, RangeError);
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var deq, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  deq = deepEqual;
  eq = strictEqual;
  test('Array#copyWithin', function(){
    var a;
    ok(toString$.call(Array.prototype.copyWithin).slice(8, -1) === 'Function', 'Is function');
    eq(Array.prototype.copyWithin.length, 2, 'length is 2');
    ok(/native code/.test(Array.prototype.copyWithin), 'looks like native');
    if ('name' in Array.prototype.copyWithin) {
      eq(Array.prototype.copyWithin.name, 'copyWithin', 'name is "copyWithin"');
    }
    strictEqual(a = [1].copyWithin(0), a);
    deq([1, 2, 3, 4, 5].copyWithin(0, 3), [4, 5, 3, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(1, 3), [1, 4, 5, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(1, 2), [1, 3, 4, 5, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(2, 2), [1, 2, 3, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(0, 3, 4), [4, 2, 3, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(1, 3, 4), [1, 4, 3, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(1, 2, 4), [1, 3, 4, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(0, -2), [4, 5, 3, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(0, -2, -1), [4, 2, 3, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(-4, -3, -2), [1, 3, 3, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(-4, -3, -1), [1, 3, 4, 4, 5]);
    deq([1, 2, 3, 4, 5].copyWithin(-4, -3), [1, 3, 4, 5, 5]);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return Array.prototype.copyWithin.call(null, 0);
      }, TypeError);
      throws(function(){
        return Array.prototype.copyWithin.call(void 8, 0);
      }, TypeError);
    }
    ok('copyWithin' in Array.prototype[Symbol.unscopables], 'In Array#@@unscopables');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var deq, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  deq = deepEqual;
  eq = strictEqual;
  test('Array#fill', function(){
    var a;
    ok(toString$.call(Array.prototype.fill).slice(8, -1) === 'Function', 'Is function');
    eq(Array.prototype.fill.length, 1, 'length is 1');
    ok(/native code/.test(Array.prototype.fill), 'looks like native');
    if ('name' in Array.prototype.fill) {
      eq(Array.prototype.fill.name, 'fill', 'name is "fill"');
    }
    strictEqual(a = Array(5).fill(5), a);
    deq(Array(5).fill(5), [5, 5, 5, 5, 5]);
    deq(Array(5).fill(5, 1), [void 8, 5, 5, 5, 5]);
    deq(Array(5).fill(5, 1, 4), [void 8, 5, 5, 5, void 8]);
    deq(Array(5).fill(5, 6, 1), [void 8, void 8, void 8, void 8, void 8]);
    deq(Array(5).fill(5, -3, 4), [void 8, void 8, 5, 5, void 8]);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return Array.prototype.fill.call(null, 0);
      }, TypeError);
      throws(function(){
        return Array.prototype.fill.call(void 8, 0);
      }, TypeError);
    }
    ok('fill' in Array.prototype[Symbol.unscopables], 'In Array#@@unscopables');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Array#findIndex', function(){
    var arr, ctx;
    ok(toString$.call(Array.prototype.findIndex).slice(8, -1) === 'Function', 'Is function');
    eq(Array.prototype.findIndex.length, 1, 'length is 1');
    ok(/native code/.test(Array.prototype.findIndex), 'looks like native');
    if ('name' in Array.prototype.findIndex) {
      eq(Array.prototype.findIndex.name, 'findIndex', 'name is "findIndex"');
    }
    (arr = [1]).findIndex(function(val, key, that){
      eq(this, ctx);
      eq(val, 1);
      eq(key, 0);
      return eq(that, arr);
    }, ctx = {});
    eq([1, 3, NaN, 42, {}].findIndex((function(it){
      return it === 42;
    })), 3);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return Array.prototype.findIndex.call(null, 0);
      }, TypeError);
      throws(function(){
        return Array.prototype.findIndex.call(void 8, 0);
      }, TypeError);
    }
    ok('findIndex' in Array.prototype[Symbol.unscopables], 'In Array#@@unscopables');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Array#find', function(){
    var arr, ctx;
    ok(toString$.call(Array.prototype.find).slice(8, -1) === 'Function', 'Is function');
    eq(Array.prototype.find.length, 1, 'length is 1');
    ok(/native code/.test(Array.prototype.find), 'looks like native');
    if ('name' in Array.prototype.find) {
      eq(Array.prototype.find.name, 'find', 'name is "find"');
    }
    (arr = [1]).find(function(val, key, that){
      eq(this, ctx);
      eq(val, 1);
      eq(key, 0);
      return eq(that, arr);
    }, ctx = {});
    eq([1, 3, NaN, 42, {}].find((function(it){
      return it === 42;
    })), 42);
    eq([1, 3, NaN, 42, {}].find((function(it){
      return it === 43;
    })), void 8);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return Array.prototype.find.call(null, 0);
      }, TypeError);
      throws(function(){
        return Array.prototype.find.call(void 8, 0);
      }, TypeError);
    }
    ok('find' in Array.prototype[Symbol.unscopables], 'In Array#@@unscopables');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  test('Array.from', function(){
    var from, iterator, al, ctx, done, iter, F, inst, a;
    from = Array.from;
    iterator = Symbol.iterator;
    ok(toString$.call(from).slice(8, -1) === 'Function', 'Is function');
    eq(Array.from.length, 1, 'length is 1');
    ok(/native code/.test(Array.from), 'looks like native');
    if ('name' in Array.from) {
      eq(Array.from.name, 'from', 'name is "from"');
    }
    deq(from('123'), ['1', '2', '3']);
    deq(from({
      length: 3,
      0: 1,
      1: 2,
      2: 3
    }), [1, 2, 3]);
    from(al = function(){
      return arguments;
    }(1), function(val, key){
      eq(this, ctx);
      eq(val, 1);
      return eq(key, 0);
    }, ctx = {});
    from([1], function(val, key){
      eq(this, ctx);
      eq(val, 1);
      return eq(key, 0);
    }, ctx = {});
    deq(from({
      length: 3,
      0: 1,
      1: 2,
      2: 3
    }, (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
    deq(from(new Set([1, 2, 3, 2, 1])), [1, 2, 3], 'Works with iterators');
    throws(function(){
      return from(null);
    }, TypeError);
    throws(function(){
      return from(void 8);
    }, TypeError);
    done = true;
    iter = [1, 2, 3].values();
    iter['return'] = function(){
      return done = false;
    };
    from(iter, function(){
      return false;
    });
    ok(done, '.return #default');
    done = false;
    iter = [1, 2, 3].values();
    iter['return'] = function(){
      return done = true;
    };
    try {
      from(iter, function(){
        throw 42;
      });
    } catch (e$) {}
    ok(done, '.return #throw');
    F = function(){};
    inst = from.call(F, [1, 2]);
    ok(inst instanceof F);
    eq(inst[0], 1);
    eq(inst[1], 2);
    eq(inst.length, 2);
    inst = from.call(F, {
      0: 1,
      1: 2,
      length: 2
    });
    ok(inst instanceof F);
    eq(inst[0], 1);
    eq(inst[1], 2);
    eq(inst.length, 2);
    a = [1, 2, 3];
    done = false;
    a[iterator] = function(){
      done = true;
      return [][iterator].call(this);
    };
    deq(from(a), [1, 2, 3]);
    ok(done);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, isFunction, isIterator, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  test('Array#keys', function(){
    var iter;
    ok(isFunction(Array.prototype.keys), 'Is function');
    ok(/native code/.test(Array.prototype.keys), 'looks like native');
    iter = ['q', 'w', 'e'].keys();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: 0,
      done: false
    });
    deq(iter.next(), {
      value: 1,
      done: false
    });
    deq(iter.next(), {
      value: 2,
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
    ok('keys' in Array.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.unscopables : void 8], 'In Array#@@unscopables');
  });
  test('Array#values', function(){
    var iter;
    ok(isFunction(Array.prototype.values), 'Is function');
    ok(/native code/.test(Array.prototype.values), 'looks like native');
    iter = ['q', 'w', 'e'].values();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
    ok('values' in Array.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.unscopables : void 8], 'In Array#@@unscopables');
  });
  test('Array#entries', function(){
    var iter;
    ok(isFunction(Array.prototype.entries), 'Is function');
    ok(/native code/.test(Array.prototype.entries), 'looks like native');
    iter = ['q', 'w', 'e'].entries();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: [0, 'q'],
      done: false
    });
    deq(iter.next(), {
      value: [1, 'w'],
      done: false
    });
    deq(iter.next(), {
      value: [2, 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
    ok('entries' in Array.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.unscopables : void 8], 'In Array#@@unscopables');
  });
  test('Array#@@iterator', function(){
    var iter;
    ok(isFunction(Array.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]), 'Is function');
    ok(/native code/.test(Array.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]), 'looks like native');
    eq(Array.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8], Array.prototype.values);
    iter = ['q', 'w', 'e'][typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Array Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var deq, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  deq = deepEqual;
  eq = strictEqual;
  test('Array.of', function(){
    var F, inst;
    ok(toString$.call(Array.of).slice(8, -1) === 'Function', 'Is function');
    eq(Array.of.length, 0, 'length is 0');
    ok(/native code/.test(Array.of), 'looks like native');
    if ('name' in Array.of) {
      eq(Array.of.name, 'of', 'name is "of"');
    }
    deq(Array.of(1), [1]);
    deq(Array.of(1, 2, 3), [1, 2, 3]);
    F = function(){};
    inst = Array.of.call(F, 1, 2);
    ok(inst instanceof F);
    eq(inst[0], 1);
    eq(inst[1], 2);
    eq(inst.length, 2);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  QUnit.module('ES6');
  test('Function#@@hasInstance', function(){
    ok(Symbol.hasInstance in Function.prototype);
    ok(Function[Symbol.hasInstance](function(){}));
    ok(!Function[Symbol.hasInstance]({}));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq;
  eq = strictEqual;
  if (function(){
    try {
      return 2 === Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }()) {
    QUnit.module('ES6');
    test('Function#name', function(){
      ok('name' in Function.prototype);
      eq((function(){
        function foo(it){
          return it;
        }
        return foo;
      }()).name, 'foo');
      eq(function(){}.name, '');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, isIterator, same, getOwnPropertyDescriptor, freeze, iterator, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  same = function(a, b){
    if (a === b) {
      return a !== 0 || 1 / a === 1 / b;
    } else {
      return a != a && b != b;
    }
  };
  getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor, freeze = Object.freeze;
  iterator = Symbol.iterator;
  eq = strictEqual;
  deq = deepEqual;
  test('Map', function(){
    var done, iter, a;
    ok(isFunction(Map), 'Is function');
    ok(/native code/.test(Map), 'looks like native');
    if ('name' in Map) {
      eq(Map.name, 'Map', 'name is "Map"');
    }
    eq(Map.length, 0, 'length is 0');
    ok('clear' in Map.prototype, 'clear in Map.prototype');
    ok('delete' in Map.prototype, 'delete in Map.prototype');
    ok('forEach' in Map.prototype, 'forEach in Map.prototype');
    ok('get' in Map.prototype, 'get in Map.prototype');
    ok('has' in Map.prototype, 'has in Map.prototype');
    ok('set' in Map.prototype, 'set in Map.prototype');
    ok(new Map instanceof Map, 'new Map instanceof Map');
    eq(new Map([1, 2, 3].entries()).size, 3, 'Init from iterator #1');
    eq(new Map(new Map([1, 2, 3].entries())).size, 3, 'Init from iterator #2');
    eq(new Map([[freeze({}), 1], [2, 3]]).size, 2, 'Support frozen objects');
    done = false;
    iter = [null, 1, 2].values();
    iter['return'] = function(){
      return done = true;
    };
    try {
      new Map(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
    a = [];
    done = false;
    a[iterator] = function(){
      done = true;
      return [][iterator].call(this);
    };
    new Map(a);
    ok(done);
  });
  test('Map#clear', function(){
    var M, f;
    ok(isFunction(Map.prototype.clear), 'Is function');
    ok(/native code/.test(Map.prototype.clear), 'looks like native');
    M = new Map;
    M.clear();
    eq(M.size, 0);
    M = new Map().set(1, 2).set(2, 3).set(1, 4);
    M.clear();
    eq(M.size, 0);
    ok(!M.has(1));
    ok(!M.has(2));
    M = new Map().set(1, 2).set(f = freeze({}), 3);
    M.clear();
    eq(M.size, 0, 'Support frozen objects');
    ok(!M.has(1));
    ok(!M.has(f));
  });
  test('Map#delete', function(){
    var a, M, f;
    ok(isFunction(Map.prototype['delete']), 'Is function');
    ok(/native code/.test(Map.prototype['delete']), 'looks like native');
    a = [];
    M = new Map().set(NaN, 1).set(2, 1).set(3, 1).set(2, 5).set(1, 4).set(a, {});
    eq(M.size, 5);
    ok(M['delete'](NaN));
    eq(M.size, 4);
    ok(!M['delete'](4));
    eq(M.size, 4);
    M['delete']([]);
    eq(M.size, 4);
    M['delete'](a);
    eq(M.size, 3);
    M.set(freeze(f = {}), 42);
    eq(M.size, 4);
    M['delete'](f);
    eq(M.size, 3);
  });
  test('Map#forEach', function(){
    var r, T, count, M, a, map, s;
    ok(isFunction(Map.prototype.forEach), 'Is function');
    ok(/native code/.test(Map.prototype.forEach), 'looks like native');
    r = {};
    count = 0;
    M = new Map().set(NaN, 1).set(2, 1).set(3, 7).set(2, 5).set(1, 4).set(a = {}, 9);
    M.forEach(function(value, key){
      count++;
      r[value] = key;
    });
    eq(count, 5);
    deq(r, {
      1: NaN,
      7: 3,
      5: 2,
      4: 1,
      9: a
    });
    map = new Map([['0', 9], ['1', 9], ['2', 9], ['3', 9]]);
    s = "";
    map.forEach(function(value, key){
      s += key;
      if (key === '2') {
        map['delete']('2');
        map['delete']('3');
        map['delete']('1');
        return map.set('4', 9);
      }
    });
    eq(s, '0124');
    map = new Map([['0', 1]]);
    s = "";
    map.forEach(function(it){
      map['delete']('0');
      if (s !== '') {
        throw '!!!';
      }
      return s += it;
    });
    eq(s, '1');
  });
  test('Map#get', function(){
    var o, f, M;
    ok(isFunction(Map.prototype.get), 'Is function');
    ok(/native code/.test(Map.prototype.get), 'looks like native');
    o = {};
    f = freeze({});
    M = new Map([[NaN, 1], [2, 1], [3, 1], [2, 5], [1, 4], [f, 42], [o, o]]);
    eq(M.get(NaN), 1);
    eq(M.get(4), void 8);
    eq(M.get({}), void 8);
    eq(M.get(o), o);
    eq(M.get(f), 42);
    eq(M.get(2), 5);
  });
  test('Map#has', function(){
    var o, f, M;
    ok(isFunction(Map.prototype.has), 'Is function');
    ok(/native code/.test(Map.prototype.has), 'looks like native');
    o = {};
    f = freeze({});
    M = new Map([[NaN, 1], [2, 1], [3, 1], [2, 5], [1, 4], [f, 42], [o, o]]);
    ok(M.has(NaN));
    ok(M.has(o));
    ok(M.has(2));
    ok(M.has(f));
    ok(!M.has(4));
    ok(!M.has({}));
  });
  test('Map#set', function(){
    var o, M, chain, f;
    ok(isFunction(Map.prototype.set), 'Is function');
    ok(/native code/.test(Map.prototype.set), 'looks like native');
    o = {};
    M = new Map().set(NaN, 1).set(2, 1).set(3, 1).set(2, 5).set(1, 4).set(o, o);
    ok(M.size === 5);
    chain = M.set(7, 2);
    eq(chain, M);
    M.set(7, 2);
    eq(M.size, 6);
    eq(M.get(7), 2);
    eq(M.get(NaN), 1);
    M.set(NaN, 42);
    eq(M.size, 6);
    eq(M.get(NaN), 42);
    M.set({}, 11);
    eq(M.size, 7);
    eq(M.get(o), o);
    M.set(o, 27);
    eq(M.size, 7);
    eq(M.get(o), 27);
    eq(new Map().set(NaN, 2).set(NaN, 3).set(NaN, 4).size, 1);
    M = new Map().set(freeze(f = {}), 42);
    eq(M.get(f), 42);
  });
  test('Map#size', function(){
    var size, sizeDesc;
    size = new Map().set(2, 1).size;
    eq(typeof size, 'number', 'size is number');
    eq(size, 1, 'size is correct');
    if (function(){
      try {
        return 2 === Object.defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      sizeDesc = getOwnPropertyDescriptor(Map.prototype, 'size');
      ok(sizeDesc && sizeDesc.get, 'size is getter');
      ok(sizeDesc && !sizeDesc.set, 'size isnt setter');
      throws(function(){
        return Map.prototype.size;
      }, TypeError);
    }
  });
  test('Map & -0', function(){
    var map;
    map = new Map;
    map.set(-0, 1);
    eq(map.size, 1);
    ok(map.has(0));
    ok(map.has(-0));
    eq(map.get(0), 1);
    eq(map.get(-0), 1);
    map.forEach(function(val, key){
      return ok(!same(key, -0));
    });
    map['delete'](-0);
    eq(map.size, 0);
    map = new Map([[-0, 1]]);
    map.forEach(function(val, key){
      return ok(!same(key, -0));
    });
  });
  test('Map#@@toStringTag', function(){
    eq(Map.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Map', 'Map::@@toStringTag is `Map`');
  });
  test('Map Iterator', function(){
    var map, keys, iterator;
    map = new Map([['a', 1], ['b', 2], ['c', 3], ['d', 4]]);
    keys = [];
    iterator = map.keys();
    keys.push(iterator.next().value);
    ok(map['delete']('a'));
    ok(map['delete']('b'));
    ok(map['delete']('c'));
    map.set('e');
    keys.push(iterator.next().value);
    keys.push(iterator.next().value);
    ok(iterator.next().done);
    map.set('f');
    ok(iterator.next().done);
    deq(keys, ['a', 'd', 'e']);
  });
  test('Map#keys', function(){
    var iter;
    ok(typeof Map.prototype.keys === 'function', 'Is function');
    ok(/native code/.test(Map.prototype.keys), 'looks like native');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).keys();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: 'a',
      done: false
    });
    deq(iter.next(), {
      value: 's',
      done: false
    });
    deq(iter.next(), {
      value: 'd',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#values', function(){
    var iter;
    ok(typeof Map.prototype.values === 'function', 'Is function');
    ok(/native code/.test(Map.prototype.values), 'looks like native');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).values();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#entries', function(){
    var iter;
    ok(typeof Map.prototype.entries === 'function', 'Is function');
    ok(/native code/.test(Map.prototype.entries), 'looks like native');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).entries();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: ['a', 'q'],
      done: false
    });
    deq(iter.next(), {
      value: ['s', 'w'],
      done: false
    });
    deq(iter.next(), {
      value: ['d', 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#@@iterator', function(){
    var iter;
    ok(typeof Map.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8] === 'function', 'Is function');
    ok(/native code/.test(Map.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]), 'looks like native');
    eq(Map.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8], Map.prototype.entries);
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']])[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Map Iterator');
    deq(iter.next(), {
      value: ['a', 'q'],
      done: false
    });
    deq(iter.next(), {
      value: ['s', 'w'],
      done: false
    });
    deq(iter.next(), {
      value: ['d', 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.acosh', function(){
    var acosh;
    acosh = Math.acosh;
    ok(isFunction(acosh), 'Is function');
    ok(/native code/.test(acosh), 'looks like native');
    sameEq(acosh(NaN), NaN);
    sameEq(acosh(0.5), NaN);
    sameEq(acosh(-1), NaN);
    sameEq(acosh(-1e300), NaN);
    sameEq(acosh(1), 0);
    eq(acosh(Infinity), Infinity);
    ok(epsilon(acosh(1234), 7.811163220849231));
    ok(epsilon(acosh(8.88), 2.8737631531629235));
    ok(epsilon(acosh(1e+160), 369.10676205960726));
    ok(epsilon(acosh(Number.MAX_VALUE), 710.475860073944));
    ok(epsilon(acosh(1 + Number.EPSILON), 2.1073424255447017e-8));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.asinh', function(){
    var asinh;
    asinh = Math.asinh;
    ok(isFunction(asinh), 'Is function');
    ok(/native code/.test(asinh), 'looks like native');
    sameEq(asinh(NaN), NaN);
    sameEq(asinh(0), 0);
    sameEq(asinh(-0), -0);
    eq(asinh(Infinity), Infinity);
    eq(asinh(-Infinity), -Infinity);
    ok(epsilon(asinh(1234), 7.811163549201245));
    ok(epsilon(asinh(9.99), 2.997227420191335));
    ok(epsilon(asinh(1e150), 346.0809111296668));
    ok(epsilon(asinh(1e7), 16.811242831518268));
    ok(epsilon(asinh(-1e7), -16.811242831518268));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.atanh', function(){
    var atanh;
    atanh = Math.atanh;
    ok(isFunction(atanh), 'Is function');
    ok(/native code/.test(atanh), 'looks like native');
    sameEq(atanh(NaN), NaN);
    sameEq(atanh(-2), NaN);
    sameEq(atanh(-1.5), NaN);
    sameEq(atanh(2), NaN);
    sameEq(atanh(1.5), NaN);
    eq(atanh(-1), -Infinity);
    eq(atanh(1), Infinity);
    sameEq(atanh(0), 0);
    sameEq(atanh(-0), -0);
    sameEq(atanh(-1e300), NaN);
    sameEq(atanh(1e300), NaN);
    ok(epsilon(atanh(0.5), 0.5493061443340549));
    ok(epsilon(atanh(-0.5), -0.5493061443340549));
    ok(epsilon(atanh(0.444), 0.47720201260109457));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.cbrt', function(){
    var cbrt;
    cbrt = Math.cbrt;
    ok(isFunction(cbrt), 'Is function');
    ok(/native code/.test(cbrt), 'looks like native');
    sameEq(cbrt(NaN), NaN);
    sameEq(cbrt(0), 0);
    sameEq(cbrt(-0), -0);
    eq(cbrt(Infinity), Infinity);
    eq(cbrt(-Infinity), -Infinity);
    eq(cbrt(-8), -2);
    eq(cbrt(8), 2);
    ok(epsilon(cbrt(-1000), -10));
    ok(epsilon(cbrt(1000), 10));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.clz32', function(){
    var clz32;
    clz32 = Math.clz32;
    ok(isFunction(clz32), 'Is function');
    ok(/native code/.test(clz32), 'looks like native');
    eq(clz32(0), 32);
    eq(clz32(1), 31);
    sameEq(clz32(-1), 0);
    eq(clz32(0.6), 32);
    sameEq(clz32(Math.pow(2, 32) - 1), 0);
    eq(clz32(Math.pow(2, 32)), 32);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.cosh', function(){
    var cosh;
    cosh = Math.cosh;
    ok(isFunction(cosh), 'Is function');
    ok(/native code/.test(cosh), 'looks like native');
    sameEq(cosh(NaN), NaN);
    eq(cosh(0), 1);
    eq(cosh(-0), 1);
    eq(cosh(Infinity), Infinity);
    eq(cosh(-Infinity), Infinity);
    ok(epsilon(cosh(12), 81377.39571257407, 3e-11));
    ok(epsilon(cosh(22), 1792456423.065795780980053377, 1e-5));
    ok(epsilon(cosh(-10), 11013.23292010332313972137));
    ok(epsilon(cosh(-23), 4872401723.1244513000, 1e-5));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.expm1', function(){
    var expm1;
    expm1 = Math.expm1;
    ok(isFunction(expm1), 'Is function');
    ok(/native code/.test(expm1), 'looks like native');
    sameEq(expm1(NaN), NaN);
    sameEq(expm1(0), 0);
    sameEq(expm1(-0), -0);
    eq(expm1(Infinity), Infinity);
    eq(expm1(-Infinity), -1);
    ok(epsilon(expm1(10), 22025.465794806718, ok(epsilon(expm1(-10), -0.9999546000702375))));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.fround', function(){
    var fround, maxFloat32, minFloat32;
    fround = Math.fround;
    ok(isFunction(fround), 'Is function');
    ok(/native code/.test(fround), 'looks like native');
    sameEq(fround(void 8), NaN);
    sameEq(fround(NaN), NaN);
    sameEq(fround(0), 0);
    sameEq(fround(-0), -0);
    sameEq(fround(Number.MIN_VALUE), 0);
    sameEq(fround(-Number.MIN_VALUE), -0);
    eq(fround(Infinity), Infinity);
    eq(fround(-Infinity), -Infinity);
    eq(fround(1.7976931348623157e+308), Infinity);
    eq(fround(-1.7976931348623157e+308), -Infinity);
    eq(fround(3.4028235677973366e+38), Infinity);
    eq(fround(3), 3);
    eq(fround(-3), -3);
    maxFloat32 = 3.4028234663852886e+38;
    minFloat32 = 1.401298464324817e-45;
    eq(fround(maxFloat32), maxFloat32);
    eq(fround(-maxFloat32), -maxFloat32);
    eq(fround(maxFloat32 + Math.pow(2, Math.pow(2, 8 - 1) - 1 - 23 - 2)), maxFloat32);
    eq(fround(minFloat32), minFloat32);
    eq(fround(-minFloat32), -minFloat32);
    sameEq(fround(minFloat32 / 2), 0);
    sameEq(fround(-minFloat32 / 2), -0);
    eq(fround(minFloat32 / 2 + Math.pow(2, -202)), minFloat32);
    eq(fround(-minFloat32 / 2 - Math.pow(2, -202)), -minFloat32);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.hypot', function(){
    var hypot, sqrt;
    hypot = Math.hypot, sqrt = Math.sqrt;
    ok(isFunction(hypot), 'Is function');
    ok(/native code/.test(hypot), 'looks like native');
    eq(hypot(), 0);
    eq(hypot(1), 1);
    sameEq(hypot('', 0), 0);
    sameEq(hypot(0, ''), 0);
    eq(hypot(Infinity, 0), Infinity);
    eq(hypot(-Infinity, 0), Infinity);
    eq(hypot(0, Infinity), Infinity);
    eq(hypot(0, -Infinity), Infinity);
    eq(hypot(Infinity, NaN), Infinity);
    eq(hypot(NaN, -Infinity), Infinity);
    sameEq(hypot(NaN, 0), NaN);
    sameEq(hypot(0, NaN), NaN);
    sameEq(hypot(0, -0), 0);
    sameEq(hypot(0, 0), 0);
    sameEq(hypot(-0, -0), 0);
    sameEq(hypot(-0, 0), 0);
    eq(hypot(0, 1), 1);
    eq(hypot(0, -1), 1);
    eq(hypot(-0, 1), 1);
    eq(hypot(-0, -1), 1);
    sameEq(hypot(0), 0);
    eq(hypot(1), 1);
    eq(hypot(2), 2);
    eq(hypot(0, 0, 1), 1);
    eq(hypot(0, 1, 0), 1);
    eq(hypot(1, 0, 0), 1);
    eq(hypot(2, 3, 4), sqrt(2 * 2 + 3 * 3 + 4 * 4));
    eq(hypot(2, 3, 4, 5), sqrt(2 * 2 + 3 * 3 + 4 * 4 + 5 * 5));
    ok(epsilon(hypot(66, 66), 93.33809511662427));
    ok(epsilon(hypot(0.1, 100), 100.0000499999875));
    eq(hypot(1e+300, 1e+300), 1.4142135623730952e+300);
    eq(hypot(1e-300, 1e-300), 1.4142135623730952e-300);
    eq(hypot(1e+300, 1e+300, 2, 3), 1.4142135623730952e+300);
    eq(hypot(-3, 4), 5);
    eq(hypot(3, -4), 5);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.imul', function(){
    var imul;
    imul = Math.imul;
    ok(isFunction(imul), 'Is function');
    ok(/native code/.test(imul), 'looks like native');
    sameEq(imul(0, 0), 0);
    eq(imul(123, 456), 56088);
    eq(imul(-123, 456), -56088);
    eq(imul(123, -456), -56088);
    eq(imul(19088743, 4275878552), 602016552);
    sameEq(imul(false, 7), 0);
    sameEq(imul(7, false), 0);
    sameEq(imul(false, false), 0);
    eq(imul(true, 7), 7);
    eq(imul(7, true), 7);
    eq(imul(true, true), 1);
    sameEq(imul(void 8, 7), 0);
    sameEq(imul(7, void 8), 0);
    sameEq(imul(void 8, void 8), 0);
    sameEq(imul('str', 7), 0);
    sameEq(imul(7, 'str'), 0);
    sameEq(imul({}, 7), 0);
    sameEq(imul(7, {}), 0);
    sameEq(imul([], 7), 0);
    sameEq(imul(7, []), 0);
    eq(imul(0xffffffff, 5), -5);
    eq(imul(0xfffffffe, 5), -10);
    eq(imul(2, 4), 8);
    eq(imul(-1, 8), -8);
    eq(imul(-2, -2), 4);
    sameEq(imul(-0, 7), 0);
    sameEq(imul(7, -0), 0);
    sameEq(imul(0.1, 7), 0);
    sameEq(imul(7, 0.1), 0);
    sameEq(imul(0.9, 7), 0);
    sameEq(imul(7, 0.9), 0);
    eq(imul(1.1, 7), 7);
    eq(imul(7, 1.1), 7);
    eq(imul(1.9, 7), 7);
    eq(imul(7, 1.9), 7);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.log10', function(){
    var log10;
    log10 = Math.log10;
    ok(isFunction(log10), 'Is function');
    ok(/native code/.test(log10), 'looks like native');
    sameEq(log10(''), log10(0));
    sameEq(log10(NaN), NaN);
    sameEq(log10(-1), NaN);
    sameEq(log10(0), -Infinity);
    sameEq(log10(-0), -Infinity);
    sameEq(log10(1), 0);
    sameEq(log10(Infinity), Infinity);
    ok(epsilon(log10(0.1), -1));
    ok(epsilon(log10(0.5), -0.3010299956639812));
    ok(epsilon(log10(1.5), 0.17609125905568124));
    ok(epsilon(log10(5), 0.6989700043360189));
    ok(epsilon(log10(50), 1.6989700043360187));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.log1p', function(){
    var log1p;
    log1p = Math.log1p;
    ok(isFunction(log1p), 'Is function');
    ok(/native code/.test(log1p), 'looks like native');
    sameEq(log1p(''), log1p(0));
    sameEq(log1p(NaN), NaN);
    sameEq(log1p(-2), NaN);
    sameEq(log1p(-1), -Infinity);
    sameEq(log1p(0), 0);
    sameEq(log1p(-0), -0);
    sameEq(log1p(Infinity), Infinity);
    ok(epsilon(log1p(5), 1.791759469228055));
    ok(epsilon(log1p(50), 3.9318256327243257));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.log2', function(){
    var log2;
    log2 = Math.log2;
    ok(isFunction(log2), 'Is function');
    ok(/native code/.test(log2), 'looks like native');
    sameEq(log2(''), log2(0));
    sameEq(log2(NaN), NaN);
    sameEq(log2(-1), NaN);
    sameEq(log2(0), -Infinity);
    sameEq(log2(-0), -Infinity);
    sameEq(log2(1), 0);
    sameEq(log2(Infinity), Infinity);
    sameEq(log2(0.5), -1);
    sameEq(log2(32), 5);
    ok(epsilon(log2(5), 2.321928094887362));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.sign', function(){
    var sign;
    sign = Math.sign;
    ok(isFunction(sign), 'Is function');
    ok(/native code/.test(sign), 'looks like native');
    sameEq(sign(NaN), NaN);
    sameEq(sign(), NaN);
    sameEq(sign(-0), -0);
    sameEq(sign(0), 0);
    eq(sign(Infinity), 1);
    eq(sign(-Infinity), -1);
    eq(sign(13510798882111488), 1);
    eq(sign(-13510798882111488), -1);
    eq(sign(42.5), 1);
    eq(sign(-42.5), -1);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.sinh', function(){
    var sinh;
    sinh = Math.sinh;
    ok(isFunction(sinh), 'Is function');
    ok(/native code/.test(sinh), 'looks like native');
    sameEq(sinh(NaN), NaN);
    sameEq(sinh(0), 0);
    sameEq(sinh(-0), -0);
    eq(sinh(Infinity), Infinity);
    eq(sinh(-Infinity), -Infinity);
    ok(epsilon(sinh(-5), -74.20321057778875));
    ok(epsilon(sinh(2), 3.6268604078470186));
    eq(sinh(-2e-17), -2e-17);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, epsilon, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  epsilon = function(a, b, E){
    return Math.abs(a - b) <= (E != null ? E : 1e-11);
  };
  test('Math.tanh', function(){
    var tanh;
    tanh = Math.tanh;
    ok(isFunction(tanh), 'Is function');
    ok(/native code/.test(tanh), 'looks like native');
    sameEq(tanh(NaN), NaN);
    sameEq(tanh(0), 0);
    sameEq(tanh(-0), -0);
    eq(tanh(Infinity), 1);
    eq(tanh(90), 1);
    ok(epsilon(tanh(10), 0.9999999958776927));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, isFunction, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Math.trunc', function(){
    var trunc;
    trunc = Math.trunc;
    ok(isFunction(trunc), 'Is function');
    ok(/native code/.test(trunc), 'looks like native');
    sameEq(trunc(NaN), NaN, 'NaN -> NaN');
    sameEq(trunc(-0), -0, '-0 -> -0');
    sameEq(trunc(0), 0, '0 -> 0');
    sameEq(trunc(Infinity), Infinity, 'Infinity -> Infinity');
    sameEq(trunc(-Infinity), -Infinity, '-Infinity -> -Infinity');
    sameEq(trunc(null), 0, 'null -> 0');
    sameEq(trunc({}), NaN, '{} -> NaN');
    eq(trunc([]), 0, '[] -> 0');
    eq(trunc(1.01), 1, '1.01 -> 0');
    eq(trunc(1.99), 1, '1.99 -> 0');
    eq(trunc(-1), -1, '-1 -> -1');
    eq(trunc(-1.99), -1, '-1.99 -> -1');
    eq(trunc(-555.555), -555, '-555.555 -> -555');
    eq(trunc(0x20000000000001), 0x20000000000001, '0x20000000000001 -> 0x20000000000001');
    eq(trunc(-0x20000000000001), -0x20000000000001, '-0x20000000000001 -> -0x20000000000001');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, sameEq, check, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  sameEq = function(a, b, c){
    return ok(a === b
      ? a !== 0 || 1 / a === 1 / b
      : a != a && b != b, c);
  };
  check = function(a, b){
    var x;
    sameEq(Number(a), b, "Number " + typeof a + " " + a + " -> " + b);
    x = new Number(a);
    ok(x === Object(x), "new Number " + typeof a + " " + a + " is object");
    eq(toString$.call(x).slice(8, -1), 'Number', "classof new Number " + typeof a + " " + a + " is Number");
    return sameEq(x.valueOf(), b, "new Number(" + typeof a + " " + a + ").valueOf() -> " + b);
  };
  test('Number constructor: regression', function(){
    var i, i$, x$, ref$, len$, n;
    ok(toString$.call(Number).slice(8, -1) === 'Function', 'Number is function');
    eq(Number.length, 1, 'Number.length is 1');
    ok(/native code/.test(Number), 'looks like native');
    if ('name' in Number) {
      eq(Number.name, 'Number', 'Number.name is "Number" (can fail if compressed)');
    }
    check(42, 42);
    check(42.42, 42.42);
    check(new Number(42), 42);
    check(new Number(42.42), 42.42);
    check('42', 42);
    check('42.42', 42.42);
    check('0x42', 66);
    check('0X42', 66);
    check('0xzzz', NaN);
    check(new String('42'), 42);
    check(new String('42.42'), 42.42);
    check(new String('0x42'), 66);
    check(null, 0);
    check(void 8, NaN);
    check(false, 0);
    check(true, 1);
    check(new Boolean(false), 0);
    check(new Boolean(true), 1);
    check({
      valueOf: function(){
        return 42;
      }
    }, 42);
    check({
      valueOf: function(){
        return '42';
      }
    }, 42);
    check({
      valueOf: function(){
        return null;
      }
    }, 0);
    check({
      toString: function(){
        return 42;
      }
    }, 42);
    check({
      toString: function(){
        return '42';
      }
    }, 42);
    check({
      valueOf: function(){
        return 1;
      },
      toString: function(){
        return 2;
      }
    }, 1);
    check({
      valueOf: 1,
      toString: function(){
        return 2;
      }
    }, 2);
    i = 1;
    eq(Number({
      valueOf: function(){
        return ++i;
      }
    }), 2, 'Number call valueOf only once #1');
    eq(i, 2, 'Number call valueOf only once #2');
    i = 1;
    eq(Number({
      toString: function(){
        return ++i;
      }
    }), 2, 'Number call toString only once #1');
    eq(i, 2, 'Number call toString only once #2');
    i = 1;
    eq(new Number({
      valueOf: function(){
        return ++i;
      }
    }).valueOf(), 2, 'new Number call valueOf only once #1');
    eq(i, 2, 'new Number call valueOf only once #2');
    i = 1;
    eq(new Number({
      toString: function(){
        return ++i;
      }
    }).valueOf(), 2, 'new Number call toString only once #1');
    eq(i, 2, 'new Number call toString only once #2');
    throws(function(){
      return Number(Object.create(null));
    }, TypeError, 'Number throws on object w/o valueOf and toString');
    throws(function(){
      return Number({
        valueOf: 1,
        toString: 2
      });
    }, TypeError, 'Number throws on object then valueOf and toString are not functions');
    throws(function(){
      return new Number(Object.create(null));
    }, TypeError, 'new Number throws on object w/o valueOf and toString');
    throws(function(){
      return new Number({
        valueOf: 1,
        toString: 2
      });
    }, TypeError, 'new Number throws on object then valueOf and toString are not functions');
    for (i$ = 0, len$ = (ref$ = ['MAX_VALUE', 'MIN_VALUE', 'NaN', 'NEGATIVE_INFINITY', 'POSITIVE_INFINITY']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(x$ in Number, x$ + " in Number");
    }
    n = new Number(42);
    eq(typeof n.constructor(n), 'number');
  });
  test('Number constructor: binary', function(){
    check('0b1', 1);
    check('0B1', 1);
    check('0b234', NaN);
    check({
      valueOf: function(){
        return '0b11';
      }
    }, 3);
    check({
      toString: function(){
        return '0b111';
      }
    }, 7);
  });
  test('Number constructor: octal', function(){
    check('0o7', 7);
    check('0O7', 7);
    check('0o89a', NaN);
    check({
      valueOf: function(){
        return '0o77';
      }
    }, 63);
    check({
      toString: function(){
        return '0o777';
      }
    }, 511);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Number.EPSILON', function(){
    var EPSILON;
    EPSILON = Number.EPSILON;
    ok('EPSILON' in Number, 'EPSILON in Number');
    eq(EPSILON, Math.pow(2, -52), 'Is 2^-52');
    ok(1 !== 1 + EPSILON, '1 isnt 1 + EPSILON');
    eq(1, 1 + EPSILON / 2, '1 is 1 + EPSILON / 2');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isFinite', function(){
    var isFinite, create, i$, x$, ref$, len$, y$, e;
    isFinite = Number.isFinite;
    create = Object.create;
    ok(toString$.call(isFinite).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(isFinite), 'looks like native');
    for (i$ = 0, len$ = (ref$ = [1, 0.1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFinite(x$), "isFinite " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [NaN, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      ok(!isFinite(y$), "not isFinite " + typeof y$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isInteger', function(){
    var isInteger, create, i$, x$, ref$, len$, y$, e;
    isInteger = Number.isInteger;
    create = Object.create;
    ok(toString$.call(isInteger).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(isInteger), 'looks like native');
    for (i$ = 0, len$ = (ref$ = [1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isInteger(x$), "isInteger " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [NaN, 0.1, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      ok(!isInteger(y$), "not isInteger " + typeof y$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isNaN', function(){
    var isNaN, create, i$, x$, ref$, len$, e;
    isNaN = Number.isNaN;
    create = Object.create;
    ok(toString$.call(isNaN).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(isNaN), 'looks like native');
    ok(isNaN(NaN), 'Number.isNaN NaN');
    for (i$ = 0, len$ = (ref$ = [1, 0.1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(!isNaN(x$), "not Number.isNaN " + typeof x$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(x$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.isSafeInteger', function(){
    var isSafeInteger, create, i$, x$, ref$, len$, y$, e;
    isSafeInteger = Number.isSafeInteger;
    create = Object.create;
    ok(toString$.call(isSafeInteger).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(isSafeInteger), 'looks like native');
    for (i$ = 0, len$ = (ref$ = [1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0, 9007199254740991, -9007199254740991]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isSafeInteger(x$), "isSafeInteger " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [9007199254740992, -9007199254740992, NaN, 0.1, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      ok(!isSafeInteger(y$), "not isSafeInteger " + typeof y$ + " " + (fn1$()));
    }
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  QUnit.module('ES6');
  test('Number.MAX_SAFE_INTEGER', function(){
    strictEqual(Number.MAX_SAFE_INTEGER, Math.pow(2, 53) - 1, 'Is 2^53 - 1');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  QUnit.module('ES6');
  test('Number.MIN_SAFE_INTEGER', function(){
    strictEqual(Number.MIN_SAFE_INTEGER, -Math.pow(2, 53) + 1, 'Is -2^53 + 1');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.parseFloat', function(){
    ok(toString$.call(Number.parseFloat).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(Number.parseFloat), 'looks like native');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Number.parseInt', function(){
    ok(toString$.call(Number.parseInt).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(Number.parseInt), 'looks like native');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var descriptors, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  descriptors = function(){
    try {
      return 2 === Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  deq = deepEqual;
  test('Object.assign', function(){
    var assign, defineProperty, foo, str, c, d, D, ref$, O;
    assign = Object.assign, defineProperty = Object.defineProperty;
    ok(toString$.call(assign).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(assign), 'looks like native');
    foo = {
      q: 1
    };
    eq(foo, assign(foo, {
      bar: 2
    }), 'assign return target');
    eq(foo.bar, 2, 'assign define properties');
    deq(assign({}, {
      q: 1
    }, {
      w: 2
    }), {
      q: 1,
      w: 2
    });
    deq(assign({}, 'qwe'), {
      0: 'q',
      1: 'w',
      2: 'e'
    });
    throws(function(){
      return assign(null, {
        q: 1
      });
    }, TypeError);
    throws(function(){
      return assign(void 8, {
        q: 1
      });
    }, TypeError);
    str = assign('qwe', {
      q: 1
    });
    eq(typeof str, 'object');
    eq(String(str), 'qwe');
    eq(str.q, 1);
    if (descriptors) {
      foo = {
        baz: 1
      };
      assign(foo, defineProperty({}, 'bar', {
        get: function(){
          return this.baz + 1;
        }
      }));
      ok(foo.bar === void 8, "assign don't copy descriptors");
      c = Symbol('c');
      d = Symbol('d');
      D = (ref$ = {
        a: 'a'
      }, ref$[c] = 'c', ref$);
      defineProperty(D, 'b', {
        value: 'b'
      });
      defineProperty(D, d, {
        value: 'd'
      });
      O = assign({}, D);
      eq(O.a, 'a', 'a');
      eq(O.b, void 8, 'b');
      eq(O[c], 'c', 'c');
      eq(O[d], void 8, 'd');
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES6');
  test('Object.is', function(){
    var same;
    same = Object.is;
    ok(toString$.call(same).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(same), 'looks like native');
    ok(same(1, 1), '1 is 1');
    ok(same(NaN, NaN), '1 is 1');
    ok(!same(0, -0), '0 isnt -0');
    ok(!same({}, {}), '{} isnt {}');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  if (Object.setPrototypeOf || '__proto__' in Object.prototype) {
    QUnit.module('ES6');
    eq = strictEqual;
    test('Object.setPrototypeOf', function(){
      var setPrototypeOf, tmp;
      setPrototypeOf = Object.setPrototypeOf;
      ok(toString$.call(setPrototypeOf).slice(8, -1) === 'Function', 'Is function');
      ok(/native code/.test(setPrototypeOf), 'looks like native');
      ok('apply' in setPrototypeOf({}, Function.prototype), 'Parent properties in target');
      eq(setPrototypeOf({
        a: 2
      }, {
        b: function(){
          return Math.pow(this.a, 2);
        }
      }).b(), 4, 'Child and parent properties in target');
      eq(setPrototypeOf(tmp = {}, {
        a: 1
      }), tmp, 'setPrototypeOf return target');
      ok(!('toString' in setPrototypeOf({}, null)), 'Can set null as prototype');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Object static methods accept primitives', function(){
    var i$, ref$, len$, method, j$, ref1$, len1$, value;
    for (i$ = 0, len$ = (ref$ = ['freeze', 'seal', 'preventExtensions', 'getOwnPropertyDescriptor', 'getPrototypeOf', 'isExtensible', 'isSealed', 'isFrozen', 'keys', 'getOwnPropertyNames']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      ok(/native code/.test(Object[method]), "Object." + method + " looks like native");
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        ok((fn$()), "Object." + method + " accept " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = ['freeze', 'seal', 'preventExtensions']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false, null, void 8, {}]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        eq(Object[method](value), value, "Object." + method + " returns target on " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = ['isSealed', 'isFrozen']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false, null, void 8]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        eq(Object[method](value), true, "Object." + method + " returns true on " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = [42, 'foo', false, null, void 8]).length; i$ < len$; ++i$) {
      value = ref$[i$];
      eq(Object.isExtensible(value), false, "Object.isExtensible returns false on " + toString$.call(value).slice(8, -1));
    }
    for (i$ = 0, len$ = (ref$ = ['getOwnPropertyDescriptor', 'getPrototypeOf', 'keys', 'getOwnPropertyNames']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [null, void 8]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        throws(fn1$, TypeError, "Object." + method + " throws on " + value);
      }
    }
    eq(Object.getPrototypeOf('foo'), String.prototype);
    function fn$(){
      try {
        Object[method](value);
        return true;
      } catch (e$) {}
    }
    function fn1$(){
      return Object[method](value);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Object#toString', function(){
    var toString, Class;
    ok(/native code/.test(Object.prototype.toString), 'looks like native');
    toString = Object.prototype.toString;
    if (!function(){
      return this;
    }()) {
      eq(toString.call(null), '[object Null]', 'classof null is `Null`');
      eq(toString.call(void 8), '[object Undefined]', 'classof void is `Undefined`');
    }
    eq(toString.call(true), '[object Boolean]', 'classof bool is `Boolean`');
    eq(toString.call('string'), '[object String]', 'classof string is `String`');
    eq(toString.call(7), '[object Number]', 'classof number is `Number`');
    eq(toString.call(Symbol()), '[object Symbol]', 'classof symbol is `Symbol`');
    eq(toString.call(new Boolean(false)), '[object Boolean]', 'classof new Boolean is `Boolean`');
    eq(toString.call(new String('')), '[object String]', 'classof new String is `String`');
    eq(toString.call(new Number(7)), '[object Number]', 'classof new Number is `Number`');
    eq('' + {}, '[object Object]', 'classof {} is `Object`');
    eq(toString.call([]), '[object Array]', 'classof array is `Array`');
    eq(toString.call(function(){}), '[object Function]', 'classof function is `Function`');
    eq(toString.call(/./), '[object RegExp]', 'classof regexp is `Undefined`');
    eq(toString.call(TypeError()), '[object Error]', 'classof new TypeError is `RegExp`');
    eq(toString.call(function(){
      return arguments;
    }()), '[object Arguments]', 'classof arguments list is `Arguments`');
    eq('' + new Set, '[object Set]', 'classof undefined is `Map`');
    eq('' + new Map, '[object Map]', 'classof map is `Undefined`');
    eq('' + new WeakSet, '[object WeakSet]', 'classof weakset is `WeakSet`');
    eq('' + new WeakMap, '[object WeakMap]', 'classof weakmap is `WeakMap`');
    eq('' + new Promise(function(){}), '[object Promise]', 'classof promise is `Promise`');
    eq('' + ''[Symbol.iterator](), '[object String Iterator]', 'classof String Iterator is `String Iterator`');
    eq('' + [].entries(), '[object Array Iterator]', 'classof Array Iterator is `Array Iterator`');
    eq('' + new Set().entries(), '[object Set Iterator]', 'classof Set Iterator is `Set Iterator`');
    eq('' + new Map().entries(), '[object Map Iterator]', 'classof Map Iterator is `Map Iterator`');
    eq('' + Math, '[object Math]', 'classof Math is `Math`');
    if (typeof JSON != 'undefined' && JSON !== null) {
      eq(toString.call(JSON), '[object JSON]', 'classof JSON is `JSON`');
    }
    Class = (function(){
      Class.displayName = 'Class';
      var prototype = Class.prototype, constructor = Class;
      Class.prototype[Symbol.toStringTag] = 'Class';
      function Class(){}
      return Class;
    }());
    eq('' + new Class, '[object Class]', 'classof user class is [Symbol.toStringTag]');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, iterator, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  iterator = Symbol.iterator;
  test('Promise', function(){
    ok(isFunction(((typeof global != 'undefined' && global !== null) && global || window).Promise), 'Is function');
    ok(/native code/.test(Promise), 'looks like native');
  });
  test('Promise#then', function(){
    ok(isFunction(Promise.prototype.then), 'Is function');
    ok(/native code/.test(Promise.prototype.then), 'looks like native');
  });
  test('Promise#catch', function(){
    ok(isFunction(Promise.prototype['catch']), 'Is function');
  });
  test('Promise#@@toStringTag', function(){
    ok(Promise.prototype[Symbol.toStringTag] === 'Promise', 'Promise::@@toStringTag is `Promise`');
  });
  test('Promise.all', function(){
    var passed, iter, next, a, done;
    ok(isFunction(Promise.all), 'Is function');
    ok(/native code/.test(Promise.all), 'looks like native');
    passed = false;
    iter = [1, 2, 3].values();
    next = bind$(iter, 'next');
    iter.next = function(){
      passed = true;
      return next();
    };
    Promise.all(iter)['catch'](function(){});
    ok(passed, 'works with iterables');
    a = [];
    done = false;
    a[iterator] = function(){
      done = true;
      return [][iterator].call(this);
    };
    Promise.all(a);
    ok(done);
  });
  test('Promise.race', function(){
    var passed, iter, next, a, done;
    ok(isFunction(Promise.race), 'Is function');
    ok(/native code/.test(Promise.race), 'looks like native');
    passed = false;
    iter = [1, 2, 3].values();
    next = bind$(iter, 'next');
    iter.next = function(){
      passed = true;
      return next();
    };
    Promise.race(iter)['catch'](function(){});
    ok(passed, 'works with iterables');
    a = [];
    done = false;
    a[iterator] = function(){
      done = true;
      return [][iterator].call(this);
    };
    Promise.race(a);
    ok(done);
  });
  test('Promise.resolve', function(){
    ok(isFunction(Promise.resolve), 'Is function');
    ok(/native code/.test(Promise.resolve), 'looks like native');
  });
  test('Promise.reject', function(){
    ok(isFunction(Promise.reject), 'Is function');
    ok(/native code/.test(Promise.reject), 'looks like native');
  });
  if (Object.setPrototypeOf) {
    test('Promise subclassing', function(it){
      var SubPromise, p1, p2, p3;
      SubPromise = function(x){
        var self;
        self = new Promise(x);
        Object.setPrototypeOf(self, SubPromise.prototype);
        self.mine = 'subclass';
        return self;
      };
      Object.setPrototypeOf(SubPromise, Promise);
      SubPromise.prototype = Object.create(Promise.prototype);
      SubPromise.prototype.constructor = SubPromise;
      p1 = SubPromise.resolve(5);
      strictEqual(p1.mine, 'subclass');
      p1 = p1.then(function(x){
        return strictEqual(x, 5);
      });
      strictEqual(p1.mine, 'subclass');
      p2 = new SubPromise(function(r){
        return r(6);
      });
      strictEqual(p2.mine, 'subclass');
      p2 = p2.then(function(x){
        return strictEqual(x, 6);
      });
      strictEqual(p2.mine, 'subclass');
      p3 = SubPromise.all([p1, p2]);
      strictEqual(p3.mine, 'subclass');
      ok(p3 instanceof Promise);
      ok(p3 instanceof SubPromise);
      p3.then(it.async(), function(e){
        return ok(false, e);
      });
    });
  }
  function bind$(obj, key, target){
    return function(){ return (target || obj)[key].apply(obj, arguments) };
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.apply', function(){
    var apply, C;
    apply = Reflect.apply;
    ok(toString$.call(apply).slice(8, -1) === 'Function', 'Reflect.apply is function');
    eq(apply.length, 3, 'arity is 3');
    ok(/native code/.test(apply), 'looks like native');
    if ('name' in apply) {
      eq(apply.name, 'apply', 'name is "apply"');
    }
    eq(apply(Array.prototype.push, [1, 2], [3, 4, 5]), 5);
    C = function(a, b, c){
      return a + b + c;
    };
    C.apply = 42;
    eq(apply(C, null, ['foo', 'bar', 'baz']), 'foobarbaz', 'works with redefined apply');
    throws(function(){
      return apply(42, null, []);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var getPrototypeOf, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  getPrototypeOf = Object.getPrototypeOf;
  eq = strictEqual;
  test('Reflect.construct', function(){
    var construct, C, inst, f, e;
    construct = Reflect.construct;
    ok(toString$.call(construct).slice(8, -1) === 'Function', 'Reflect.construct is function');
    eq(construct.length, 2, 'arity is 2');
    ok(/native code/.test(construct), 'looks like native');
    if ('name' in construct) {
      eq(construct.name, 'construct', 'name is "construct"');
    }
    C = function(a, b, c){
      return this.qux = a + b + c;
    };
    eq(construct(C, ['foo', 'bar', 'baz']).qux, 'foobarbaz', 'basic');
    C.apply = 42;
    eq(construct(C, ['foo', 'bar', 'baz']).qux, 'foobarbaz', 'works with redefined apply');
    inst = construct(function(){
      return this.x = 42;
    }, [], Array);
    eq(inst.x, 42, 'constructor with newTarget');
    ok(inst instanceof Array, 'prototype with newTarget');
    throws(function(){
      return construct(42, []);
    }, TypeError, 'throws on primitive');
    f = function(){};
    f.prototype = 42;
    ok((function(){
      try {
        return getPrototypeOf(construct(f, [])) === Object.prototype;
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    eq(construct(Set, [[1, 2, 3, 2, 1]]).size, 3, 'works with native constructors');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, getOwnPropertyDescriptor, MODERN, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty, getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  deq = deepEqual;
  test('Reflect.defineProperty', function(){
    var defineProperty, O;
    defineProperty = Reflect.defineProperty;
    ok(toString$.call(defineProperty).slice(8, -1) === 'Function', 'Reflect.defineProperty is function');
    eq(defineProperty.length, 3, 'arity is 3');
    ok(/native code/.test(defineProperty), 'looks like native');
    if ('name' in defineProperty) {
      eq(defineProperty.name, 'defineProperty', 'name is "defineProperty"');
    }
    O = {};
    eq(defineProperty(O, 'foo', {
      value: 123
    }), true);
    eq(O.foo, 123);
    if (MODERN) {
      O = {};
      defineProperty(O, 'foo', {
        value: 123,
        enumerable: true
      });
      deq(getOwnPropertyDescriptor(O, 'foo'), {
        value: 123,
        enumerable: true,
        configurable: false,
        writable: false
      });
      eq(defineProperty(O, 'foo', {
        value: 42
      }), false);
    }
    throws(function(){
      return defineProperty(42, 'foo', {
        value: 42
      });
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.deleteProperty', function(){
    var deleteProperty, O;
    deleteProperty = Reflect.deleteProperty;
    ok(toString$.call(deleteProperty).slice(8, -1) === 'Function', 'Reflect.deleteProperty is function');
    eq(deleteProperty.length, 2, 'arity is 2');
    ok(/native code/.test(deleteProperty), 'looks like native');
    if ('name' in deleteProperty) {
      eq(deleteProperty.name, 'deleteProperty', 'name is "deleteProperty"');
    }
    O = {
      bar: 456
    };
    eq(deleteProperty(O, 'bar'), true);
    ok(!in$('bar', O));
    if (MODERN) {
      eq(deleteProperty(defineProperty({}, 'foo', {
        value: 42
      }), 'foo'), false);
    }
    throws(function(){
      return deleteProperty(42, 'foo');
    }, TypeError, 'throws on primitive');
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, from, MODERN, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty;
  from = Array.from;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  deq = deepEqual;
  test('Reflect.enumerate', function(){
    var enumerate, iterator, obj, i, ref$;
    enumerate = Reflect.enumerate;
    iterator = Symbol.iterator;
    ok(toString$.call(enumerate).slice(8, -1) === 'Function', 'Reflect.enumerate is function');
    eq(enumerate.length, 1, 'arity is 1');
    ok(/native code/.test(enumerate), 'looks like native');
    if ('name' in enumerate) {
      eq(enumerate.name, 'enumerate', 'name is "enumerate"');
    }
    obj = {
      foo: 1,
      bar: 2
    };
    i = enumerate(obj);
    ok(iterator in i, 'returns iterator');
    deq(from(i), ['foo', 'bar'], 'bisic');
    obj = {
      q: 1,
      w: 2,
      e: 3
    };
    i = enumerate(obj);
    delete obj.w;
    deq(from(i), ['q', 'e'], 'ignore holes');
    obj = (ref$ = clone$({
      q: 1,
      w: 2,
      e: 3
    }), ref$.a = 4, ref$.s = 5, ref$.d = 6, ref$);
    deq(from(enumerate(obj)).sort(), ['a', 'd', 'e', 'q', 's', 'w'], 'works with prototype');
    throws(function(){
      return enumerate(42);
    }, TypeError, 'throws on primitive');
  });
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.getOwnPropertyDescriptor', function(){
    var getOwnPropertyDescriptor, obj, desc;
    getOwnPropertyDescriptor = Reflect.getOwnPropertyDescriptor;
    ok(toString$.call(getOwnPropertyDescriptor).slice(8, -1) === 'Function', 'Reflect.getOwnPropertyDescriptor is function');
    eq(getOwnPropertyDescriptor.length, 2, 'arity is 2');
    ok(/native code/.test(getOwnPropertyDescriptor), 'looks like native');
    if ('name' in getOwnPropertyDescriptor) {
      eq(getOwnPropertyDescriptor.name, 'getOwnPropertyDescriptor', 'name is "getOwnPropertyDescriptor"');
    }
    obj = {
      baz: 789
    };
    desc = getOwnPropertyDescriptor(obj, 'baz');
    eq(desc.value, 789);
    throws(function(){
      return getOwnPropertyDescriptor(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.getPrototypeOf', function(){
    var getPrototypeOf;
    getPrototypeOf = Reflect.getPrototypeOf;
    ok(toString$.call(getPrototypeOf).slice(8, -1) === 'Function', 'Reflect.getPrototypeOf is function');
    eq(getPrototypeOf.length, 1, 'arity is 1');
    ok(/native code/.test(getPrototypeOf), 'looks like native');
    if ('name' in getPrototypeOf) {
      eq(getPrototypeOf.name, 'getPrototypeOf', 'name is "getPrototypeOf"');
    }
    eq(getPrototypeOf([]), Array.prototype);
    throws(function(){
      return getPrototypeOf(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, create, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty, create = Object.create;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.get', function(){
    var get, target, receiver;
    get = Reflect.get;
    ok(toString$.call(get).slice(8, -1) === 'Function', 'Reflect.get is function');
    ok(/native code/.test(get), 'looks like native');
    if ('name' in get) {
      eq(get.name, 'get', 'name is "get"');
    }
    eq(get({
      qux: 987
    }, 'qux'), 987);
    if (MODERN) {
      target = create(defineProperty({
        z: 3
      }, 'w', {
        get: function(){
          return this;
        }
      }), {
        x: {
          value: 1
        },
        y: {
          get: function(){
            return this;
          }
        }
      });
      receiver = {};
      eq(get(target, 'x', receiver), 1, 'get x');
      eq(get(target, 'y', receiver), receiver, 'get y');
      eq(get(target, 'z', receiver), 3, 'get z');
      eq(get(target, 'w', receiver), receiver, 'get w');
      eq(get(target, 'u', receiver), void 8, 'get u');
    }
    throws(function(){
      return get(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('Reflect.has', function(){
    var has, O;
    has = Reflect.has;
    ok(toString$.call(has).slice(8, -1) === 'Function', 'Reflect.has is function');
    eq(has.length, 2, 'arity is 2');
    ok(/native code/.test(has), 'looks like native');
    if ('name' in has) {
      eq(has.name, 'has', 'name is "has"');
    }
    O = {
      qux: 987
    };
    eq(has(O, 'qux'), true);
    eq(has(O, 'qwe'), false);
    eq(has(O, 'toString'), true);
    throws(function(){
      return has(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, preventExtensions, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty, preventExtensions = Object.preventExtensions;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.isExtensible', function(){
    var isExtensible;
    isExtensible = Reflect.isExtensible;
    ok(toString$.call(isExtensible).slice(8, -1) === 'Function', 'Reflect.isExtensible is function');
    eq(isExtensible.length, 1, 'arity is 1');
    ok(/native code/.test(isExtensible), 'looks like native');
    if ('name' in isExtensible) {
      eq(isExtensible.name, 'isExtensible', 'name is "isExtensible"');
    }
    ok(isExtensible({}));
    if (MODERN) {
      ok(!isExtensible(preventExtensions({})));
    }
    throws(function(){
      return isExtensible(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty;
  eq = strictEqual;
  test('Reflect.ownKeys', function(){
    var ownKeys, sym, O1, keys, O2;
    ownKeys = Reflect.ownKeys;
    sym = Symbol('c');
    ok(toString$.call(ownKeys).slice(8, -1) === 'Function', 'Reflect.ownKeys is function');
    eq(ownKeys.length, 1, 'arity is 1');
    ok(/native code/.test(ownKeys), 'looks like native');
    if ('name' in ownKeys) {
      eq(ownKeys.name, 'ownKeys', 'name is "ownKeys"');
    }
    O1 = {
      a: 1
    };
    defineProperty(O1, 'b', {
      value: 2
    });
    O1[sym] = 3;
    keys = ownKeys(O1);
    eq(keys.length, 3, 'ownKeys return all own keys');
    eq(O1[keys[0]], 1, 'ownKeys return all own keys: simple');
    eq(O1[keys[1]], 2, 'ownKeys return all own keys: hidden');
    eq(O1[keys[2]], 3, 'ownKeys return all own keys: symbol');
    O2 = clone$(O1);
    keys = ownKeys(O2);
    eq(keys.length, 0, 'ownKeys return only own keys');
    throws(function(){
      return ownKeys(42);
    }, TypeError, 'throws on primitive');
  });
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, isExtensible, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty, isExtensible = Object.isExtensible;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.preventExtensions', function(){
    var preventExtensions, obj;
    preventExtensions = Reflect.preventExtensions;
    ok(toString$.call(preventExtensions).slice(8, -1) === 'Function', 'Reflect.preventExtensions is function');
    eq(preventExtensions.length, 1, 'arity is 1');
    ok(/native code/.test(preventExtensions), 'looks like native');
    if ('name' in preventExtensions) {
      eq(preventExtensions.name, 'preventExtensions', 'name is "preventExtensions"');
    }
    obj = {};
    ok(preventExtensions(obj), true);
    if (MODERN) {
      ok(!isExtensible(obj));
    }
    throws(function(){
      return preventExtensions(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  if (Object.setPrototypeOf || '__proto__' in {}) {
    QUnit.module('ES6');
    eq = strictEqual;
    test('Reflect.setPrototypeOf', function(){
      var setPrototypeOf, obj, o;
      setPrototypeOf = Reflect.setPrototypeOf;
      ok(toString$.call(setPrototypeOf).slice(8, -1) === 'Function', 'Reflect.setPrototypeOf is function');
      ok(/native code/.test(setPrototypeOf), 'looks like native');
      if ('name' in setPrototypeOf) {
        eq(setPrototypeOf.name, 'setPrototypeOf', 'name is "setPrototypeOf"');
      }
      obj = {};
      ok(setPrototypeOf(obj, Array.prototype), true);
      ok(obj instanceof Array);
      throws(function(){
        return setPrototypeOf({}, 42);
      }, TypeError);
      throws(function(){
        return setPrototypeOf(42, {});
      }, TypeError, 'throws on primitive');
      ok(setPrototypeOf(o = {}, o) === false, 'false on recursive __proto__');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var defineProperty, getOwnPropertyDescriptor, create, MODERN, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  defineProperty = Object.defineProperty, getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor, create = Object.create;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  test('Reflect.set', function(){
    var set, obj, target, receiver, out;
    set = Reflect.set;
    ok(toString$.call(set).slice(8, -1) === 'Function', 'Reflect.set is function');
    ok(/native code/.test(set), 'looks like native');
    if ('name' in set) {
      eq(set.name, 'set', 'name is "set"');
    }
    obj = {};
    ok(set(obj, 'quux', 654), true);
    eq(obj.quux, 654);
    target = {};
    receiver = {};
    set(target, 'foo', 1, receiver);
    eq(target.foo, void 8, 'target.foo === undefined');
    eq(receiver.foo, 1, 'receiver.foo === 1');
    if (MODERN) {
      defineProperty(receiver, 'bar', {
        value: 0,
        writable: true,
        enumerable: false,
        configurable: true
      });
      set(target, 'bar', 1, receiver);
      eq(receiver.bar, 1, 'receiver.bar === 1');
      eq(getOwnPropertyDescriptor(receiver, 'bar').enumerable, false, 'enumerability not overridden');
      target = create(defineProperty({
        z: 3
      }, 'w', {
        set: function(v){
          return out = this;
        }
      }), {
        x: {
          value: 1,
          writable: true,
          configurable: true
        },
        y: {
          set: function(v){
            out = this;
          }
        },
        c: {
          value: 1,
          writable: false,
          configurable: false
        }
      });
      eq(set(target, 'x', 2, target), true, 'set x');
      eq(target.x, 2, 'set x');
      out = null;
      eq(set(target, 'y', 2, target), true, 'set y');
      eq(out, target, 'set y');
      eq(set(target, 'z', 4, target), true);
      eq(target.z, 4, 'set z');
      out = null;
      eq(set(target, 'w', 1, target), true, 'set w');
      eq(out, target, 'set w');
      eq(set(target, 'u', 0, target), true, 'set u');
      eq(target.u, 0, 'set u');
      eq(set(target, 'c', 2, target), false, 'set c');
      eq(target.c, 1, 'set c');
    }
    throws(function(){
      return set(42, 'q', 42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  if (function(){
    try {
      return 2 === Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }()) {
    test('RegExp constructor', function(){
      var a, b, c, i$, len$, index, val;
      ok(toString$.call(RegExp).slice(8, -1) === 'Function', 'RegExp is function');
      eq(RegExp.length, 2, 'RegExp.length is 2');
      ok(/native code/.test(RegExp), 'looks like native');
      if ('name' in RegExp) {
        eq(RegExp.name, 'RegExp', 'RegExp.name is "RegExp" (can fail if compressed)');
      }
      a = /a/g;
      ok(toString$.call(RegExp()).slice(8, -1) === 'RegExp');
      ok(toString$.call(new RegExp()).slice(8, -1) === 'RegExp');
      b = new RegExp(a);
      ok(a !== b, 'a isnt b');
      c = RegExp(a);
      ok(a === c, 'a is c');
      eq(String(b), '/a/g', 'b is /a/g');
      eq(String(new RegExp(/a/g, 'mi')), '/a/im', 'Allows a regex with flags');
      ok(new RegExp(/a/g, 'im') instanceof RegExp, 'Works with instanceof');
      eq(new RegExp(/a/g, 'im').constructor, RegExp, 'Has the right constructor');
      /(b)(c)(d)(e)(f)(g)(h)(i)(j)(k)(l)(m)(n)(o)(p)/.exec('abcdefghijklmnopq');
      for (i$ = 0, len$ = 'bcdefghij'.length; i$ < len$; ++i$) {
        index = i$;
        val = 'bcdefghij'[i$];
        eq(RegExp["$" + (index + 1)], val, "Updates RegExp globals $" + (index + 1));
      }
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq;
  QUnit.module('ES6');
  eq = strictEqual;
  if (function(){
    try {
      return 2 === Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }()) {
    test('RegExp#flags', function(){
      eq(/./g.flags, 'g', '/./g.flags is "g"');
      eq(/./.flags, '', '/./.flags is ""');
      eq(RegExp('.', 'gim').flags, 'gim', 'RegExp(".", "gim").flags is "gim"');
      eq(RegExp('.').flags, '', 'RegExp(".").flags is ""');
      eq(/./gim.flags, 'gim', '/./gim.flags is "gim"');
      eq(/./gmi.flags, 'gim', '/./gmi.flags is "gim"');
      eq(/./mig.flags, 'gim', '/./mig.flags is "gim"');
      eq(/./mgi.flags, 'gim', '/./mgi.flags is "gim"');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, global, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  global = Function('return this')();
  test('String#match regression', function(){
    var instance, matched, expected, obj, str, x, e, reg, string, matches, i$, len$, i, re, num;
    ok(toString$.call(''.match).slice(8, -1) === 'Function', 'String#match is function');
    eq(''.match.length, 1, 'String#match length is 1');
    ok(/native code/.test(''.match), 'looks like native');
    if ('name' in ''.match) {
      eq(''.match.name, 'match', 'String#match is "match" (can fail if compressed)');
    }
    instance = Object(true);
    instance.match = String.prototype.match;
    eq(instance.match(true)[0], 'true', 'S15.5.4.10_A1_T1');
    instance = Object(false);
    instance.match = String.prototype.match;
    eq(instance.match(function(){
      return false;
    }())[0], 'false', 'S15.5.4.10_A1_T2');
    matched = ''.match();
    expected = RegExp().exec('');
    eq(matched.length, expected.length, 'S15.5.4.10_A1_T4 #1');
    eq(matched.index, expected.index, 'S15.5.4.10_A1_T4 #2');
    eq(matched.input, expected.input, 'S15.5.4.10_A1_T4 #3');
    eq('gnulluna'.match(null)[0], 'null', 'S15.5.4.10_A1_T5');
    matched = Object('undefined').match(x);
    expected = RegExp(x).exec('undefined');
    eq(matched.length, expected.length, 'S15.5.4.10_A1_T6 #1');
    eq(matched.index, expected.index, 'S15.5.4.10_A1_T6 #2');
    eq(matched.input, expected.input, 'S15.5.4.10_A1_T6 #3');
    matched = String('undefined').match(undefined);
    expected = RegExp(undefined).exec('undefined');
    eq(matched.length, expected.length, 'S15.5.4.10_A1_T7 #1');
    eq(matched.index, expected.index, 'S15.5.4.10_A1_T7 #2');
    eq(matched.input, expected.input, 'S15.5.4.10_A1_T7 #3');
    obj = {
      toString: function(){}
    };
    matched = String(obj).match(void 8);
    expected = RegExp(void 8).exec('undefined');
    eq(matched.length, expected.length, 'S15.5.4.10_A1_T8 #1');
    eq(matched.index, expected.index, 'S15.5.4.10_A1_T8 #2');
    eq(matched.input, expected.input, 'S15.5.4.10_A1_T8 #3');
    obj = {
      toString: function(){
        return '\u0041B';
      }
    };
    str = 'ABB\u0041BABAB';
    eq(str.match(obj)[0], 'AB', 'S15.5.4.10_A1_T10');
    obj = {
      toString: function(){
        throw 'intostr';
      }
    };
    str = 'ABB\u0041BABAB';
    try {
      x = str.match(obj);
      ok(false, 'S15.5.4.10_A1_T11 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      eq(e, 'intostr', 'S15.5.4.10_A1_T11 #1.1: Exception === "intostr". Actual: ' + e);
    }
    obj = {
      toString: function(){
        return {};
      },
      valueOf: function(){
        throw 'intostr';
      }
    };
    str = 'ABB\u0041BABAB';
    try {
      x = str.match(obj);
      ok(false, 'S15.5.4.10_A1_T12 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      eq(e, 'intostr', 'S15.5.4.10_A1_T12 #1.1: Exception === "intostr". Actual: ' + e);
    }
    obj = {
      toString: function(){
        return {};
      },
      valueOf: function(){
        return 1;
      }
    };
    eq('ABB\u0041B\u0031ABAB\u0031BBAA'.match(obj)[0], '1', 'S15.5.4.10_A1_T13 #1');
    eq('ABB\u0041B\u0031ABAB\u0031BBAA'.match(obj).length, 1, 'S15.5.4.10_A1_T13 #2');
    reg = RegExp('77');
    eq('ABB\u0041BABAB\u0037\u0037BBAA'.match(reg)[0], '77', 'S15.5.4.10_A1_T14');
    string = '1234567890';
    eq(string.match(3)[0], '3', 'S15.5.4.10_A2_T1 #1');
    eq(string.match(3).length, 1, 'S15.5.4.10_A2_T1 #2');
    eq(string.match(3).index, 2, 'S15.5.4.10_A2_T1 #3');
    eq(string.match(3).input, string, 'S15.5.4.10_A2_T1 #4');
    matches = ['34', '34', '34'];
    string = '343443444';
    eq(string.match(/34/g).length, 3, 'S15.5.4.10_A2_T2 #1');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(/34/g)[i], matches[i], "S15.5.4.10_A2_T2 #2");
    }
    matches = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
    string = '123456abcde7890';
    eq(string.match(/\d{1}/g).length, 10, 'S15.5.4.10_A2_T3 #1');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(/\d{1}/g)[i], matches[i], "S15.5.4.10_A2_T3 #2");
    }
    matches = ['12', '34', '56', '78', '90'];
    string = '123456abcde7890';
    eq(string.match(/\d{2}/g).length, 5, 'S15.5.4.10_A2_T4 #1');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(/\d{2}/g)[i], matches[i], "S15.5.4.10_A2_T4 #2");
    }
    matches = ['ab', 'cd'];
    string = '123456abcde7890';
    eq(string.match(/\D{2}/g).length, 2, 'S15.5.4.10_A2_T5 #1');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(/\D{2}/g)[i], matches[i], "S15.5.4.10_A2_T5 #2");
    }
    string = "Boston, Mass. 02134";
    eq(string.match(/([\d]{5})([-\ ]?[\d]{4})?$/)[0], '02134', 'S15.5.4.10_A2_T6 #1');
    eq(string.match(/([\d]{5})([-\ ]?[\d]{4})?$/)[1], '02134', 'S15.5.4.10_A2_T6 #2');
    eq(string.match(/([\d]{5})([-\ ]?[\d]{4})?$/).length, 3, 'S15.5.4.10_A2_T6 #4');
    eq(string.match(/([\d]{5})([-\ ]?[\d]{4})?$/).index, 14, 'S15.5.4.10_A2_T6 #5');
    eq(string.match(/([\d]{5})([-\ ]?[\d]{4})?$/).input, string, 'S15.5.4.10_A2_T6 #6');
    string = "Boston, Mass. 02134";
    eq(string.match(/([\d]{5})([-\ ]?[\d]{4})?$/g).length, 1, 'S15.5.4.10_A2_T7 #1');
    eq(string.match(/([\d]{5})([-\ ]?[\d]{4})?$/g)[0], '02134', 'S15.5.4.10_A2_T7 #2');
    matches = ['02134', '02134', 'undefined'];
    string = "Boston, MA 02134";
    re = /([\d]{5})([-\ ]?[\d]{4})?$/;
    re.lastIndex = 0;
    eq(string.match(re).length, 3, 'S15.5.4.10_A2_T8 #1');
    eq(string.match(re).index, string.lastIndexOf('0'), 'S15.5.4.10_A2_T8 #2');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(re)[i], matches[i], "S15.5.4.10_A2_T8 #3");
    }
    string = "Boston, MA 02134";
    matches = ['02134', '02134', void 8];
    re = /([\d]{5})([-\ ]?[\d]{4})?$/;
    re.lastIndex = string.length;
    eq(string.match(re).length, 3, 'S15.5.4.10_A2_T9 #1');
    eq(string.match(re).index, string.lastIndexOf('0'), 'S15.5.4.10_A2_T9 #2');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(re)[i], matches[i], "S15.5.4.10_A2_T9 #3");
    }
    string = "Boston, MA 02134";
    matches = ['02134', '02134', void 8];
    re = /([\d]{5})([-\ ]?[\d]{4})?$/;
    re.lastIndex = string.lastIndexOf('0');
    eq(string.match(re).length, 3, 'S15.5.4.10_A2_T10 #1');
    eq(string.match(re).index, string.lastIndexOf('0'), 'S15.5.4.10_A2_T10 #2');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(re)[i], matches[i], "S15.5.4.10_A2_T10 #3");
    }
    string = "Boston, MA 02134";
    matches = ['02134', '02134', void 8];
    re = /([\d]{5})([-\ ]?[\d]{4})?$/;
    re.lastIndex = string.lastIndexOf('0') + 1;
    eq(string.match(re).length, 3, 'S15.5.4.10_A2_T11 #1');
    eq(string.match(re).index, string.lastIndexOf('0'), 'S15.5.4.10_A2_T11 #2');
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(string.match(re)[i], matches[i], "S15.5.4.10_A2_T11 #3");
    }
    string = "Boston, MA 02134";
    re = /([\d]{5})([-\ ]?[\d]{4})?$/g;
    eq(string.match(re).length, 1, 'S15.5.4.10_A2_T12 #1');
    eq(string.match(re)[0], '02134', 'S15.5.4.10_A2_T12 #2');
    re = /([\d]{5})([-\ ]?[\d]{4})?$/g;
    re.lastIndex = 0;
    string = "Boston, MA 02134";
    eq(string.match(re).length, 1, 'S15.5.4.10_A2_T13 #1');
    eq(string.match(re)[0], '02134', 'S15.5.4.10_A2_T13 #2');
    string = "Boston, MA 02134";
    re = /([\d]{5})([-\ ]?[\d]{4})?$/g;
    re.lastIndex = string.length;
    eq(string.match(re).length, 1, 'S15.5.4.10_A2_T14 #1');
    eq(string.match(re)[0], '02134', 'S15.5.4.10_A2_T14 #2');
    string = "Boston, MA 02134";
    re = /([\d]{5})([-\ ]?[\d]{4})?$/g;
    re.lastIndex = string.lastIndexOf('0');
    eq(string.match(re).length, 1, 'S15.5.4.10_A2_T15 #1');
    eq(string.match(re)[0], '02134', 'S15.5.4.10_A2_T15 #2');
    string = "Boston, MA 02134";
    re = /([\d]{5})([-\ ]?[\d]{4})?$/g;
    re.lastIndex = string.lastIndexOf('0') + 1;
    eq(string.match(re).length, 1, 'S15.5.4.10_A2_T16 #1');
    eq(string.match(re)[0], '02134', 'S15.5.4.10_A2_T16 #2');
    re = /0./;
    num = 10203040506070809000;
    eq(''.match.call(num, re)[0], '02', 'S15.5.4.10_A2_T17 #1');
    eq(''.match.call(num, re).length, 1, 'S15.5.4.10_A2_T17 #2');
    eq(''.match.call(num, re).index, 1, 'S15.5.4.10_A2_T17 #3');
    eq(''.match.call(num, re).input, String(num), 'S15.5.4.10_A2_T17 #4');
    re = /0./;
    re.lastIndex = 0;
    num = 10203040506070809000;
    eq(''.match.call(num, re)[0], '02', 'S15.5.4.10_A2_T18 #1');
    eq(''.match.call(num, re).length, 1, 'S15.5.4.10_A2_T18 #2');
    eq(''.match.call(num, re).index, 1, 'S15.5.4.10_A2_T18 #3');
    eq(''.match.call(num, re).input, String(num), 'S15.5.4.10_A2_T18 #4');
  });
  test('RegExp#@@match', function(){
    var string, matches, i$, len$, i;
    ok(toString$.call(/./[Symbol.match]).slice(8, -1) === 'Function', 'RegExp#@@match is function');
    eq(/./[Symbol.match].length, 1, 'RegExp#@@match length is 1');
    string = "Boston, MA 02134";
    matches = ['02134', '02134', void 8];
    eq(/([\d]{5})([-\ ]?[\d]{4})?$/[Symbol.match](string).length, 3);
    eq(/([\d]{5})([-\ ]?[\d]{4})?$/[Symbol.match](string).index, string.lastIndexOf('0'));
    for (i$ = 0, len$ = matches.length; i$ < len$; ++i$) {
      i = matches[i$];
      eq(/([\d]{5})([-\ ]?[\d]{4})?$/[Symbol.match](string)[i], matches[i]);
    }
  });
  test('@@match logic', function(){
    'use strict';
    var strict, str, num, O, ref$, re;
    strict = !function(){
      return this;
    }();
    str = strict
      ? 'qwe'
      : Object('qwe');
    num = strict
      ? 123
      : Object(123);
    O = (ref$ = {}, ref$[Symbol.match] = function(it){
      return {
        value: it
      };
    }, ref$);
    eq(str.match(O).value, str);
    eq(''.match.call(num, O).value, num);
    re = /./;
    re[Symbol.match] = function(it){
      return {
        value: it
      };
    };
    eq(str.match(re).value, str);
    eq(''.match.call(num, re).value, num);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#replace regression', function(){
    var instance, e;
    ok(toString$.call(''.replace).slice(8, -1) === 'Function', 'String#replace is function');
    eq(''.replace.length, 2, 'String#replace length is 2');
    ok(/native code/.test(''.replace), 'looks like native');
    if ('name' in ''.replace) {
      eq(''.replace.name, 'replace', 'String#replace is "replace" (can fail if compressed)');
    }
    instance = Object(true);
    instance.replace = String.prototype.replace;
    eq(instance.replace(true, 1), '1', 'S15.5.4.11_A1_T1');
    instance = Object(false);
    instance.replace = String.prototype.replace;
    eq(instance.replace(false, void 8), 'undefined', 'S15.5.4.11_A1_T2');
    eq('gnulluna'.replace(null, function(a1, a2, a3){
      return a2 + '';
    }), 'g1una', 'S15.5.4.11_A1_T4');
    eq('gnulluna'.replace(null, function(){}), 'gundefineduna', 'S15.5.4.11_A1_T5');
    eq(Object('undefined').replace(void 8, function(){
      return arguments[1] + 42;
    }), '42', 'S15.5.4.11_A1_T6');
    eq('undefined'.replace('e', void 8), 'undundefinedfined', 'S15.5.4.11_A1_T7');
    eq(String({
      toString: function(){}
    }).replace(/e/g, void 8), 'undundefinedfinundefinedd', 'S15.5.4.11_A1_T8');
    eq(new String({
      valueOf: function(){},
      toString: void 8
    }).replace(function(){}(), function(a1, a2, a3){
      return a1 + a2 + a3;
    }), 'undefined0undefined', 'S15.5.4.11_A1_T9');
    eq('ABB\u0041BABAB'.replace({
      toString: function(){
        return '\u0041B';
      }
    }, function(){}), 'undefinedBABABAB', 'S15.5.4.11_A1_T10');
    /* wrong order in some old environments
    try
      'ABB\u0041BABAB'replace {toString: -> throw \insearchValue}, {toString: -> throw \inreplaceValue}
      ok no, 'S15.5.4.11_A1_T11 #1 lead to throwing exception'
    catch e
      eq e, \insearchValue, 'S15.5.4.11_A1_T11 #2'
    try
      Object('ABB\u0041BABAB')replace {toString: (->{}), valueOf: -> throw \insearchValue}, {toString: -> throw \inreplaceValue}
      ok no, 'S15.5.4.11_A1_T12 #1 lead to throwing exception'
    catch e
      eq e, \insearchValue, 'S15.5.4.11_A1_T12 #2'
    */
    try {
      'ABB\u0041BABAB\u0031BBAA'.replace({
        toString: function(){
          return {};
        },
        valueOf: function(){
          throw 'insearchValue';
        }
      }, {
        toString: function(){
          return 1;
        }
      });
      ok(false, 'S15.5.4.11_A1_T13 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      eq(e, 'insearchValue', 'S15.5.4.11_A1_T13 #2');
    }
    eq('ABB\u0041BABAB\u0037\u0037BBAA'.replace(new RegExp('77'), 1), 'ABBABABAB\u0031BBAA', 'S15.5.4.11_A1_T14');
    instance = Object(1100.00777001);
    instance.replace = String.prototype.replace;
    try {
      instance.replace({
        toString: function(){
          return /77/;
        }
      }, 1);
      ok(false, 'S15.5.4.11_A1_T15 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      ok(e instanceof TypeError, 'S15.5.4.11_A1_T15 #2');
    }
    instance = Object(1100.00777001);
    instance.replace = String.prototype.replace;
    try {
      instance.replace(/77/, {
        toString: function(){
          return function(a1, a2, a3){
            return a2 + 'z';
          };
        }
      });
      ok(false, 'S15.5.4.11_A1_T16 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      ok(e instanceof TypeError, 'S15.5.4.11_A1_T16 #2');
    }
    eq('asdf'.replace(RegExp('', 'g'), '1'), '1a1s1d1f1', 'S15.5.4.11_A1_T17');
    eq('She sells seashells by the seashore.'.replace(/sh/g, 'sch'), 'She sells seaschells by the seaschore.', 'S15.5.4.11_A2_T1');
    eq('She sells seashells by the seashore.'.replace(/sh/g, '$$sch'), 'She sells sea$schells by the sea$schore.', 'S15.5.4.11_A2_T2');
    eq('She sells seashells by the seashore.'.replace(/sh/g, '$&sch'), 'She sells seashschells by the seashschore.', 'S15.5.4.11_A2_T3');
    eq('She sells seashells by the seashore.'.replace(/sh/g, '$`sch'), 'She sells seaShe sells seaschells by the seaShe sells seashells by the seaschore.', 'S15.5.4.11_A2_T4');
    eq('She sells seashells by the seashore.'.replace(/sh/g, "$'sch"), 'She sells seaells by the seashore.schells by the seaore.schore.', 'S15.5.4.11_A2_T5');
    eq('She sells seashells by the seashore.'.replace(/sh/, 'sch'), 'She sells seaschells by the seashore.', 'S15.5.4.11_A2_T6');
    eq('She sells seashells by the seashore.'.replace(/sh/, '$$sch'), 'She sells sea$schells by the seashore.', 'S15.5.4.11_A2_T7');
    eq('She sells seashells by the seashore.'.replace(/sh/, '$&sch'), 'She sells seashschells by the seashore.', 'S15.5.4.11_A2_T8');
    eq('She sells seashells by the seashore.'.replace(/sh/, '$`sch'), 'She sells seaShe sells seaschells by the seashore.', 'S15.5.4.11_A2_T9');
    eq('She sells seashells by the seashore.'.replace(/sh/, "$'sch"), 'She sells seaells by the seashore.schells by the seashore.', 'S15.5.4.11_A2_T10');
    eq('uid=31'.replace(/(uid=)(\d+)/, '$1115'), 'uid=115', 'S15.5.4.11_A3_T1');
    eq('uid=31'.replace(/(uid=)(\d+)/, '$11A15'), 'uid=1A15', 'S15.5.4.11_A3_T3');
    eq('abc12 def34'.replace(/([a-z]+)([0-9]+)/, function(){
      return arguments[2] + arguments[1];
    }), '12abc def34', 'S15.5.4.11_A4_T1');
    eq('aaaaaaaaaa,aaaaaaaaaaaaaaa'.replace(/^(a+)\1*,\1+$/, '$1'), 'aaaaa', 'S15.5.4.11_A5_T1');
  });
  test('RegExp#@@replace', function(){
    ok(toString$.call(/./[Symbol.replace]).slice(8, -1) === 'Function', 'RegExp#@@replace is function');
    eq(/./[Symbol.replace].length, 2, 'RegExp#@@replace length is 2');
    eq(/([a-z]+)([0-9]+)/[Symbol.replace]('abc12 def34', function(){
      return arguments[2] + arguments[1];
    }), '12abc def34');
  });
  test('@@replace logic', function(){
    'use strict';
    var strict, str, num, O, ref$, re;
    strict = !function(){
      return this;
    }();
    str = strict
      ? 'qwe'
      : Object('qwe');
    num = strict
      ? 123
      : Object(123);
    O = (ref$ = {}, ref$[Symbol.replace] = function(a, b){
      return {
        a: a,
        b: b
      };
    }, ref$);
    eq(str.replace(O, 42).a, str);
    eq(str.replace(O, 42).b, 42);
    eq(''.replace.call(num, O, 42).a, num);
    eq(''.replace.call(num, O, 42).b, 42);
    re = /./;
    re[Symbol.replace] = function(a, b){
      return {
        a: a,
        b: b
      };
    };
    eq(str.replace(re, 42).a, str);
    eq(str.replace(re, 42).b, 42);
    eq(''.replace.call(num, re, 42).a, num);
    eq(''.replace.call(num, re, 42).b, 42);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#search regression', function(){
    var instance, e, aString;
    ok(toString$.call(''.search).slice(8, -1) === 'Function', 'String#search is function');
    eq(''.search.length, 1, 'String#search length is 1');
    ok(/native code/.test(''.search), 'looks like native');
    if ('name' in ''.search) {
      eq(''.search.name, 'search', 'String#search is "search" (can fail if compressed)');
    }
    instance = Object(true);
    instance.search = String.prototype.search;
    eq(instance.search(true), 0, 'S15.5.4.12_A1_T1');
    instance = Object(false);
    instance.search = String.prototype.search;
    eq(instance.search(false), 0, 'S15.5.4.12_A1_T2');
    eq(''.search(), 0, 'S15.5.4.12_A1_T4 #1');
    eq('--undefined--'.search(), 0, 'S15.5.4.12_A1_T4 #2');
    eq('gnulluna'.search(null), 1, 'S15.5.4.12_A1_T5');
    eq(Object('undefined').search(void 8), 0, 'S15.5.4.12_A1_T6');
    eq('undefined'.search(void 8), 0, 'S15.5.4.12_A1_T7');
    eq(String({
      toString: function(){}
    }).search(void 8), 0, 'S15.5.4.12_A1_T8');
    eq('ssABB\u0041BABAB'.search({
      toString: function(){
        return '\u0041B';
      }
    }), 2, 'S15.5.4.12_A1_T10');
    try {
      'ABB\u0041BABAB'.search({
        toString: function(){
          throw 'intostr';
        }
      });
      ok(false, 'S15.5.4.12_A1_T11 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      eq(e, 'intostr', 'S15.5.4.12_A1_T11 #2');
    }
    try {
      Object('ABB\u0041BABAB').search({
        toString: function(){
          return {};
        },
        valueOf: function(){
          throw 'intostr';
        }
      });
      ok(false, 'S15.5.4.12_A1_T12 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      eq(e, 'intostr', 'S15.5.4.12_A1_T12 #2');
    }
    eq('ABB\u0041B\u0031ABAB\u0031BBAA'.search({
      toString: function(){
        return {};
      },
      valueOf: function(){
        return 1;
      }
    }), 5, 'S15.5.4.12_A1_T13');
    eq('ABB\u0041BABAB\u0037\u0037BBAA'.search(RegExp('77')), 9, 'S15.5.4.12_A1_T14');
    eq(Object('test string').search('string'), 5, 'S15.5.4.12_A2_T1');
    eq(Object('test string').search('String'), -1, 'S15.5.4.12_A2_T2');
    eq(Object('test string').search(/String/i), 5, 'S15.5.4.12_A2_T3');
    eq(Object('test string').search(/Four/), -1, 'S15.5.4.12_A2_T4');
    eq(Object('one two three four five').search(/four/), 14, 'S15.5.4.12_A2_T5');
    eq(Object('test string').search('notexist'), -1, 'S15.5.4.12_A2_T6');
    eq(Object('test string probe').search('string pro'), 5, 'S15.5.4.12_A2_T7');
    aString = Object('power of the power of the power of the power of the power of the power of the great sword');
    eq(aString.search(/the/), aString.search(/the/g), 'S15.5.4.12_A3_T1');
    aString = Object('power \u006F\u0066 the power of the power \u006F\u0066 the power of the power \u006F\u0066 the power of the great sword');
    eq(aString.search(/of/), aString.search(/of/g), 'S15.5.4.12_A3_T2');
  });
  test('RegExp#@@search', function(){
    ok(toString$.call(/./[Symbol.search]).slice(8, -1) === 'Function', 'RegExp#@@search is function');
    eq(/./[Symbol.search].length, 1, 'RegExp#@@search length is 1');
    eq(/four/[Symbol.search]('one two three four five'), 14);
    eq(/Four/[Symbol.search]('one two three four five'), -1);
  });
  test('@@search logic', function(){
    'use strict';
    var strict, str, num, O, ref$, re;
    strict = !function(){
      return this;
    }();
    str = strict
      ? 'qwe'
      : Object('qwe');
    num = strict
      ? 123
      : Object(123);
    O = (ref$ = {}, ref$[Symbol.search] = function(it){
      return {
        value: it
      };
    }, ref$);
    eq(str.search(O).value, str);
    eq(''.search.call(num, O).value, num);
    re = /./;
    re[Symbol.search] = function(it){
      return {
        value: it
      };
    };
    eq(str.search(re).value, str);
    eq(''.search.call(num, re).value, num);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#split regression', function(){
    var instance, split, e, string, i$, to$, i, expected;
    ok(toString$.call(''.split).slice(8, -1) === 'Function', 'String#split is function');
    eq(''.split.length, 2, 'String#split length is 2');
    ok(/native code/.test(''.split), 'looks like native');
    if ('name' in ''.split) {
      eq(''.split.name, 'split', 'String#split is "split" (can fail if compressed)');
    }
    instance = Object(true);
    instance.split = String.prototype.split;
    split = instance.split(true, false);
    eq(typeof split, 'object', 'S15.5.4.14_A1_T1 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T1 #2');
    eq(split.length, 0, 'S15.5.4.14_A1_T1 #3');
    instance = Object(false);
    instance.split = String.prototype.split;
    split = instance.split(false, 0, null);
    eq(typeof split, 'object', 'S15.5.4.14_A1_T2 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T2 #2');
    eq(split.length, 0, 'S15.5.4.14_A1_T2 #3');
    split = ''.split();
    eq(typeof split, 'object', 'S15.5.4.14_A1_T4 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T4 #2');
    eq(split.length, 1, 'S15.5.4.14_A1_T4 #3');
    eq(split[0], '', 'S15.5.4.14_A1_T4 #4');
    split = 'gnulluna'.split(null);
    eq(typeof split, 'object', 'S15.5.4.14_A1_T5 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T5 #2');
    eq(split.length, 2, 'S15.5.4.14_A1_T5 #3');
    eq(split[0], 'g', 'S15.5.4.14_A1_T5 #4');
    eq(split[1], 'una', 'S15.5.4.14_A1_T5 #5');
    /* wrong behavior in some old browsers
    split = Object(\1undefined)split void
    eq typeof split, \object, 'S15.5.4.14_A1_T6 #1'
    eq split@@, Array, 'S15.5.4.14_A1_T6 #2'
    eq split.length, 1, 'S15.5.4.14_A1_T6 #3'
    eq split.0, \1undefined, 'S15.5.4.14_A1_T6 #4'
    split = 'undefinedd'split void
    eq typeof split, \object, 'S15.5.4.14_A1_T7 #1'
    eq split@@, Array, 'S15.5.4.14_A1_T7 #2'
    eq split.length, 1, 'S15.5.4.14_A1_T7 #3'
    eq split.0, \undefinedd, 'S15.5.4.14_A1_T7 #4'
    split = String({toString: ->})split void
    eq typeof split, \object, 'S15.5.4.14_A1_T8 #1'
    eq split@@, Array, 'S15.5.4.14_A1_T8 #2'
    eq split.length, 1, 'S15.5.4.14_A1_T8 #3'
    eq split.0, \undefined, 'S15.5.4.14_A1_T8 #4'
    */
    split = new String({
      valueOf: function(){},
      toString: void 8
    }).split(function(){});
    eq(typeof split, 'object', 'S15.5.4.14_A1_T9 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T9 #2');
    eq(split.length, 1, 'S15.5.4.14_A1_T9 #3');
    eq(split[0], 'undefined', 'S15.5.4.14_A1_T9 #4');
    split = 'ABB\u0041BABAB'.split({
      toString: function(){
        return '\u0042B';
      }
    }, {
      valueOf: function(){
        return true;
      }
    });
    eq(typeof split, 'object', 'S15.5.4.14_A1_T10 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T10 #2');
    eq(split.length, 1, 'S15.5.4.14_A1_T10 #3');
    eq(split[0], 'A', 'S15.5.4.14_A1_T10 #4');
    try {
      'ABB\u0041BABAB'.split({
        toString: function(){
          return '\u0041B';
        }
      }, {
        valueOf: (function(){
          throw 'intointeger';
        }())
      });
      ok(false, 'S15.5.4.14_A1_T11 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      eq(e, 'intointeger', 'S15.5.4.14_A1_T11 #2');
    }
    /* wrong behavior in old IE
    try
      new String('ABB\u0041BABAB')split {toString: -> '\u0041B'}, {valueOf: (-> {}), toString: -> throw \intointeger}
      ok no, 'S15.5.4.14_A1_T12 #1 lead to throwing exception'
    catch e
      eq e, \intointeger, 'S15.5.4.14_A1_T12 #2'
    */
    split = 'ABB\u0041BABAB\u0042cc^^\u0042Bvv%%B\u0042xxx'.split({
      toString: function(){
        return '\u0042\u0042';
      }
    }, {
      valueOf: function(){
        return {};
      },
      toString: function(){
        return '2';
      }
    });
    eq(typeof split, 'object', 'S15.5.4.14_A1_T13 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T13 #2');
    eq(split.length, 2, 'S15.5.4.14_A1_T13 #3');
    eq(split[0], 'A', 'S15.5.4.14_A1_T13 #4');
    eq(split[1], 'ABABA', 'S15.5.4.14_A1_T13 #5');
    /* wrong behavior in old IE
    try
      instance = Object 10001.10001
      instance.split = String::split
      instance.split {toString: -> throw \intostr}, {valueOf: -> throw \intoint}
      ok no, 'S15.5.4.14_A1_T14 #1 lead to throwing exception'
    catch e
      eq e, \intoint, 'S15.5.4.14_A1_T14 #2'
    try
      class F
        costructor: (@value)->
        valueOf: -> ''+@value
        toString: -> new Number
        split: String::split
      new F!split {toString: (-> {}), valueOf: -> throw \intostr}, {valueOf: -> throw \intoint}
      ok no, 'S15.5.4.14_A1_T15 #1 lead to throwing exception'
    catch e
      eq e, \intoint, 'S15.5.4.14_A1_T15 #2'
    */
    try {
      String.prototype.split.call(6776767677.006771122677555, {
        toString: function(){
          return /\u0037\u0037/g;
        }
      });
      ok(false, 'S15.5.4.14_A1_T16 #1 lead to throwing exception');
    } catch (e$) {
      e = e$;
      ok(e instanceof TypeError, 'S15.5.4.14_A1_T16 #2');
    }
    split = String.prototype.split.call(6776767677.006771122677555, /\u0037\u0037/g);
    eq(typeof split, 'object', 'S15.5.4.14_A1_T17 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T17 #2');
    eq(split.length, 4, 'S15.5.4.14_A1_T17 #3');
    eq(split[0], '6', 'S15.5.4.14_A1_T17 #4');
    eq(split[1], '67676', 'S15.5.4.14_A1_T17 #5');
    eq(split[2], '.006', 'S15.5.4.14_A1_T17 #6');
    eq(split[3], '1', 'S15.5.4.14_A1_T17 #7');
    split = String.prototype.split.call(6776767677.006771122677555, /00/, 1);
    eq(typeof split, 'object', 'S15.5.4.14_A1_T18 #1');
    eq(split.constructor, Array, 'S15.5.4.14_A1_T18 #2');
    eq(split.length, 1, 'S15.5.4.14_A1_T18 #3');
    eq(split[0], '6776767677.', 'S15.5.4.14_A1_T18 #4');
    split = Object('one,two,three,four,five').split(',');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T1 #1');
    eq(split.length, 5, 'S15.5.4.14_A2_T1 #2');
    eq(split[0], 'one', 'S15.5.4.14_A2_T1 #3');
    eq(split[1], 'two', 'S15.5.4.14_A2_T1 #4');
    eq(split[2], 'three', 'S15.5.4.14_A2_T1 #5');
    eq(split[3], 'four', 'S15.5.4.14_A2_T1 #6');
    eq(split[4], 'five', 'S15.5.4.14_A2_T1 #7');
    split = Object('one two three four five').split(' ');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T2 #1');
    eq(split.length, 5, 'S15.5.4.14_A2_T2 #2');
    eq(split[0], 'one', 'S15.5.4.14_A2_T2 #3');
    eq(split[1], 'two', 'S15.5.4.14_A2_T2 #4');
    eq(split[2], 'three', 'S15.5.4.14_A2_T2 #5');
    eq(split[3], 'four', 'S15.5.4.14_A2_T2 #6');
    eq(split[4], 'five', 'S15.5.4.14_A2_T2 #7');
    split = Object('one two three four five').split(RegExp(' '), 2);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T3 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T3 #2');
    eq(split[0], 'one', 'S15.5.4.14_A2_T3 #3');
    eq(split[1], 'two', 'S15.5.4.14_A2_T3 #4');
    split = Object('one two three').split('');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T4 #1');
    eq(split.length, 'one two three'.length, 'S15.5.4.14_A2_T4 #2');
    eq(split[0], 'o', 'S15.5.4.14_A2_T4 #3');
    eq(split[1], 'n', 'S15.5.4.14_A2_T4 #4');
    eq(split[11], 'e', 'S15.5.4.14_A2_T4 #5');
    eq(split[12], 'e', 'S15.5.4.14_A2_T4 #6');
    split = Object('one-1,two-2,four-4').split(/,/);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T5 #1');
    eq(split.length, 3, 'S15.5.4.14_A2_T5 #2');
    eq(split[0], 'one-1', 'S15.5.4.14_A2_T5 #3');
    eq(split[1], 'two-2', 'S15.5.4.14_A2_T5 #4');
    eq(split[2], 'four-4', 'S15.5.4.14_A2_T5 #5');
    string = Object('one-1 two-2 three-3');
    split = string.split('');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T6 #1');
    eq(split.length, string.length, 'S15.5.4.14_A2_T6 #2');
    for (i$ = 0, to$ = split.length; i$ < to$; ++i$) {
      i = i$;
      eq(split[i], string.charAt(i), "S15.5.4.14_A2_T6 #" + (i + 3));
    }
    /* wrong behavior in some old browsers
    string = 'thisundefinedisundefinedaundefinedstringundefinedobject'
    split = string.split void
    eq split@@, Array, 'S15.5.4.14_A2_T7 #1'
    eq split.length, 1, 'S15.5.4.14_A2_T7 #2'
    eq split.0, string, 'S15.5.4.14_A2_T7 #3'
    */
    string = 'thisnullisnullanullstringnullobject';
    expected = ['this', 'is', 'a', 'string', 'object'];
    split = string.split(null);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T8 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T8 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T8 #" + (i + 3));
    }
    string = 'thistrueistrueatruestringtrueobject';
    expected = ['this', 'is', 'a', 'string', 'object'];
    split = string.split(true);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T9 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T9 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T9 #" + (i + 3));
    }
    string = 'this123is123a123string123object';
    expected = ['this', 'is', 'a', 'string', 'object'];
    split = string.split(123);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T10 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T10 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T10 #" + (i + 3));
    }
    split = Object('one-1,two-2,four-4').split(':');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T11 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T11 #2');
    eq(split[0], 'one-1,two-2,four-4', 'S15.5.4.14_A2_T11 #3');
    split = Object('one-1 two-2 four-4').split('r-42');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T12 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T12 #2');
    eq(split[0], 'one-1 two-2 four-4', 'S15.5.4.14_A2_T12 #3');
    split = Object('one-1 two-2 four-4').split('-4');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T13 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T13 #2');
    eq(split[0], 'one-1 two-2 four', 'S15.5.4.14_A2_T13 #3');
    eq(split[1], '', 'S15.5.4.14_A2_T13 #4');
    split = Object('one-1 two-2 four-4').split('on');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T14 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T14 #2');
    eq(split[0], '', 'S15.5.4.14_A2_T14 #3');
    eq(split[1], 'e-1 two-2 four-4', 'S15.5.4.14_A2_T14 #4');
    split = new String().split('');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T15 #1');
    eq(split.length, 0, 'S15.5.4.14_A2_T15 #2');
    eq(split[0], void 8, 'S15.5.4.14_A2_T15 #3');
    split = new String().split(' ');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T16 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T16 #2');
    eq(split[0], '', 'S15.5.4.14_A2_T16 #3');
    split = Object(' ').split('');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T18 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T18 #2');
    eq(split[0], ' ', 'S15.5.4.14_A2_T18 #3');
    split = Object(' ').split(' ');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T19 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T19 #2');
    eq(split[0], '', 'S15.5.4.14_A2_T19 #3');
    eq(split[1], '', 'S15.5.4.14_A2_T19 #4');
    split = ''.split('x');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T19 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T19 #2');
    eq(split[0], '', 'S15.5.4.14_A2_T19 #3');
    string = Object('one-1 two-2 three-3');
    split = string.split(new RegExp);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T20 #1');
    eq(split.length, string.length, 'S15.5.4.14_A2_T20 #2');
    for (i$ = 0, to$ = split.length; i$ < to$; ++i$) {
      i = i$;
      eq(split[i], string.charAt(i), "S15.5.4.14_A2_T20 #" + (i + 3));
    }
    split = Object('hello').split('ll');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T21 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T21 #2');
    eq(split[0], 'he', 'S15.5.4.14_A2_T21 #3');
    eq(split[1], 'o', 'S15.5.4.14_A2_T21 #4');
    split = Object('hello').split('l');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T22 #1');
    eq(split.length, 3, 'S15.5.4.14_A2_T22 #2');
    eq(split[0], 'he', 'S15.5.4.14_A2_T22 #3');
    eq(split[1], '', 'S15.5.4.14_A2_T22 #4');
    eq(split[2], 'o', 'S15.5.4.14_A2_T22 #5');
    split = Object('hello').split('x');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T23 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T23 #2');
    eq(split[0], 'hello', 'S15.5.4.14_A2_T23 #3');
    split = Object('hello').split('h');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T24 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T24 #2');
    eq(split[0], '', 'S15.5.4.14_A2_T24 #3');
    eq(split[1], 'ello', 'S15.5.4.14_A2_T24 #4');
    split = Object('hello').split('o');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T25 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T25 #2');
    eq(split[0], 'hell', 'S15.5.4.14_A2_T25 #3');
    eq(split[1], '', 'S15.5.4.14_A2_T25 #4');
    split = Object('hello').split('hello');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T26 #1');
    eq(split.length, 2, 'S15.5.4.14_A2_T26 #2');
    eq(split[0], '', 'S15.5.4.14_A2_T26 #3');
    eq(split[1], '', 'S15.5.4.14_A2_T26 #4');
    split = Object('hello').split(void 8);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T27 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T27 #2');
    eq(split[0], 'hello', 'S15.5.4.14_A2_T27 #3');
    split = Object('hello').split('hellothere');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T28 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T28 #2');
    eq(split[0], 'hello', 'S15.5.4.14_A2_T28 #3');
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1);
    expected = ['', '00', '', '', '', '22', '33', '44', '60'];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T29 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T29 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T29 #" + (i + 3));
    }
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, 1);
    expected = [''];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T30 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T30 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T30 #" + (i + 3));
    }
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, 2);
    expected = ['', '00'];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T31 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T31 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T31 #" + (i + 3));
    }
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, 0);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T32 #1');
    eq(split.length, 0, 'S15.5.4.14_A2_T32 #2');
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, 100);
    expected = ['', '00', '', '', '', '22', '33', '44', '60'];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T33 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T33 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T33 #" + (i + 3));
    }
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, void 8);
    expected = ['', '00', '', '', '', '22', '33', '44', '60'];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T34 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T34 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T34 #" + (i + 3));
    }
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, Math.pow(2, 32) - 1);
    expected = ['', '00', '', '', '', '22', '33', '44', '60'];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T35 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T35 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T35 #" + (i + 3));
    }
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, 'boo');
    eq(split.constructor, Array, 'S15.5.4.14_A2_T36 #1');
    eq(split.length, 0, 'S15.5.4.14_A2_T36 #2');
    /* wrong behavior in most browsers
    instance = Object 100111122133144155
    instance.split = String::split
    split = instance.split 1, -Math.pow(2 32) + 1
    eq split@@, Array, 'S15.5.4.14_A2_T37 #1'
    eq split.length, 0, 'S15.5.4.14_A2_T37 #2'
    */
    instance = Object(100111122133144155);
    instance.split = String.prototype.split;
    split = instance.split(1, NaN);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T38 #1');
    eq(split.length, 0, 'S15.5.4.14_A2_T38 #2');
    instance = Object('hello').split('l', 0);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T39 #1');
    eq(split.length, 0, 'S15.5.4.14_A2_T39 #2');
    split = Object('hello').split('l', 1);
    eq(split.constructor, Array, 'S15.5.4.14_A2_T40 #1');
    eq(split.length, 1, 'S15.5.4.14_A2_T40 #2');
    eq(split[0], 'he', 'S15.5.4.14_A2_T40 #3');
    split = Object('hello').split('l', 2);
    expected = ['he', ''];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T41 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T41 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T41 #" + (i + 3));
    }
    split = Object('hello').split('l', 3);
    expected = ['he', '', 'o'];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T42 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T42 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T42 #" + (i + 3));
    }
    split = Object('hello').split('l', 4);
    expected = ['he', '', 'o'];
    eq(split.constructor, Array, 'S15.5.4.14_A2_T43 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A2_T43 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A2_T43 #" + (i + 3));
    }
    split = Object('one,two,three,four,five').split();
    eq(split.constructor, Array, 'S15.5.4.14_A3_T1 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T1 #2');
    eq(split[0], 'one,two,three,four,five', 'S15.5.4.14_A3_T1 #3');
    split = String.prototype.split.call({});
    eq(split.constructor, Array, 'S15.5.4.14_A3_T2 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T2 #2');
    eq(split[0], '[object Object]', 'S15.5.4.14_A3_T2 #3');
    split = String.prototype.split.call({
      toString: function(){
        return 'function(){}';
      }
    });
    eq(split.constructor, Array, 'S15.5.4.14_A3_T3 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T3 #2');
    eq(split[0], 'function(){}', 'S15.5.4.14_A3_T3 #3');
    split = String.prototype.split.call(Object(NaN));
    eq(split.constructor, Array, 'S15.5.4.14_A3_T4 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T4 #2');
    eq(split[0], 'NaN', 'S15.5.4.14_A3_T4 #3');
    split = String.prototype.split.call(Object(-1234567890));
    eq(split.constructor, Array, 'S15.5.4.14_A3_T5 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T5 #2');
    eq(split[0], '-1234567890', 'S15.5.4.14_A3_T5 #3');
    instance = Object(-1e21);
    split = String.prototype.split.call(instance);
    eq(split.constructor, Array, 'S15.5.4.14_A3_T6 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T6 #2');
    eq(split[0], instance.toString(), 'S15.5.4.14_A3_T6 #3');
    split = String.prototype.split.call(Math);
    eq(split.constructor, Array, 'S15.5.4.14_A3_T7 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T7 #2');
    eq(split[0], '[object Math]', 'S15.5.4.14_A3_T7 #3');
    split = String.prototype.split.call([1, 2, 3, 4, 5]);
    eq(split.constructor, Array, 'S15.5.4.14_A3_T8 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T8 #2');
    eq(split[0], '1,2,3,4,5', 'S15.5.4.14_A3_T8 #3');
    split = String.prototype.split.call(Object(false));
    eq(split.constructor, Array, 'S15.5.4.14_A3_T9 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T9 #2');
    eq(split[0], 'false', 'S15.5.4.14_A3_T9 #3');
    split = String.prototype.split.call(new String);
    eq(split.constructor, Array, 'S15.5.4.14_A3_T10 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T10 #2');
    eq(split[0], '', 'S15.5.4.14_A3_T10 #3');
    split = String.prototype.split.call(Object(' '));
    eq(split.constructor, Array, 'S15.5.4.14_A3_T11 #1');
    eq(split.length, 1, 'S15.5.4.14_A3_T11 #2');
    eq(split[0], ' ', 'S15.5.4.14_A3_T11 #3');
    /* wrong behavior in old IE
    split = Object(\hello)split /l/
    eq split@@, Array, 'S15.5.4.14_A4_T1 #1'
    eq split.length, 3, 'S15.5.4.14_A4_T1 #2'
    eq split.0, 'he', 'S15.5.4.14_A4_T1 #3'
    eq split.1, '', 'S15.5.4.14_A4_T1 #4'
    eq split.2, 'o', 'S15.5.4.14_A4_T1 #5'
    */
    split = Object('hello').split(/l/, 0);
    eq(split.constructor, Array, 'S15.5.4.14_A4_T2 #1');
    eq(split.length, 0, 'S15.5.4.14_A4_T2 #2');
    split = Object('hello').split(/l/, 1);
    eq(split.constructor, Array, 'S15.5.4.14_A4_T3 #1');
    eq(split.length, 1, 'S15.5.4.14_A4_T3 #2');
    eq(split[0], 'he', 'S15.5.4.14_A4_T3 #3');
    /* wrong behavior in old IE
    split = Object(\hello)split /l/, 2
    eq split@@, Array, 'S15.5.4.14_A4_T4 #1'
    eq split.length, 2, 'S15.5.4.14_A4_T4 #2'
    eq split.0, 'he', 'S15.5.4.14_A4_T4 #3'
    eq split.1, '', 'S15.5.4.14_A4_T4 #4'
    split = Object(\hello)split /l/, 3
    eq split@@, Array, 'S15.5.4.14_A4_T5 #1'
    eq split.length, 3, 'S15.5.4.14_A4_T5 #2'
    eq split.0, 'he', 'S15.5.4.14_A4_T5 #3'
    eq split.1, '', 'S15.5.4.14_A4_T5 #4'
    eq split.2, 'o', 'S15.5.4.14_A4_T5 #5'
    split = Object(\hello)split /l/, 4
    eq split@@, Array, 'S15.5.4.14_A4_T6 #1'
    eq split.length, 3, 'S15.5.4.14_A4_T6 #2'
    eq split.0, 'he', 'S15.5.4.14_A4_T6 #3'
    eq split.1, '', 'S15.5.4.14_A4_T6 #4'
    eq split.2, 'o', 'S15.5.4.14_A4_T6 #5'
    split = Object(\hello)split /l/, void
    eq split@@, Array, 'S15.5.4.14_A4_T7 #1'
    eq split.length, 3, 'S15.5.4.14_A4_T7 #2'
    eq split.0, 'he', 'S15.5.4.14_A4_T7 #3'
    eq split.1, '', 'S15.5.4.14_A4_T7 #4'
    eq split.2, 'o', 'S15.5.4.14_A4_T7 #5'
    */
    split = Object('hello').split(/l/, 'hi');
    eq(split.constructor, Array, 'S15.5.4.14_A4_T8 #1');
    eq(split.length, 0, 'S15.5.4.14_A4_T8 #2');
    split = Object('hello').split(new RegExp);
    expected = ['h', 'e', 'l', 'l', 'o'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T10 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T10 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T10 #" + (i + 3));
    }
    split = Object('hello').split(new RegExp(), 0);
    eq(split.constructor, Array, 'S15.5.4.14_A4_T11 #1');
    eq(split.length, 0, 'S15.5.4.14_A4_T11 #2');
    split = Object('hello').split(new RegExp(), 1);
    eq(split.constructor, Array, 'S15.5.4.14_A4_T12 #1');
    eq(split.length, 1, 'S15.5.4.14_A4_T12 #2');
    eq(split[0], 'h', 'S15.5.4.14_A4_T12 #3');
    split = Object('hello').split(new RegExp(), 2);
    expected = ['h', 'e'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T13 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T13 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T13 #" + (i + 3));
    }
    split = Object('hello').split(new RegExp(), 3);
    expected = ['h', 'e', 'l'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T14 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T14 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T14 #" + (i + 3));
    }
    split = Object('hello').split(new RegExp(), 4);
    expected = ['h', 'e', 'l', 'l'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T15 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T15 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T15 #" + (i + 3));
    }
    split = Object('hello').split(new RegExp(), void 8);
    expected = ['h', 'e', 'l', 'l', 'o'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T16 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T16 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T16 #" + (i + 3));
    }
    split = Object('hello').split(new RegExp(), 'hi');
    eq(split.constructor, Array, 'S15.5.4.14_A4_T18 #1');
    eq(split.length, 0, 'S15.5.4.14_A4_T18 #2');
    split = Object('a b c de f').split(/\s/);
    expected = ['a', 'b', 'c', 'de', 'f'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T19 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T19 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T19 #" + (i + 3));
    }
    split = Object('a b c de f').split(/\s/, 3);
    expected = ['a', 'b', 'c'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T20 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T20 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T20 #" + (i + 3));
    }
    split = Object('a b c de f').split(/X/);
    eq(split.constructor, Array, 'S15.5.4.14_A4_T21 #1');
    eq(split.length, 1, 'S15.5.4.14_A4_T21 #2');
    eq(split[0], 'a b c de f', "S15.5.4.14_A4_T21 #3");
    split = Object('dfe23iu 34 =+65--').split(/\d+/);
    expected = ['dfe', 'iu ', ' =+', '--'];
    eq(split.constructor, Array, 'S15.5.4.14_A4_T22 #1');
    eq(split.length, expected.length, 'S15.5.4.14_A4_T22 #2');
    for (i$ = 0, to$ = expected.length; i$ < to$; ++i$) {
      i = i$;
      eq(expected[i], split[i], "S15.5.4.14_A4_T22 #" + (i + 3));
    }
    /* wrong behavior in old IE
    split = Object(\abc)split /[a-z]/
    expected = ['' '' '' '']
    eq split@@, Array, 'S15.5.4.14_A4_T24 #1'
    eq split.length, expected.length, 'S15.5.4.14_A4_T24 #2'
    for i til expected.length
      eq expected[i], split[i], "S15.5.4.14_A4_T24 #" + (i + 3)
    */
  });
  test('RegExp#@@split', function(){
    ok(toString$.call(/./[Symbol.split]).slice(8, -1) === 'Function', 'RegExp#@@split is function');
    eq(/./[Symbol.split].length, 2, 'RegExp#@@split length is 2');
    eq(/\s/[Symbol.split]('a b c de f').length, 5);
    eq(/\s/[Symbol.split]('a b c de f', void 8).length, 5);
    eq(/\s/[Symbol.split]('a b c de f', 1).length, 1);
    eq(/\s/[Symbol.split]('a b c de f', 10).length, 5);
  });
  test('@@split logic', function(){
    'use strict';
    var strict, str, num, O, ref$, re;
    strict = !function(){
      return this;
    }();
    str = strict
      ? 'qwe'
      : Object('qwe');
    num = strict
      ? 123
      : Object(123);
    O = (ref$ = {}, ref$[Symbol.split] = function(a, b){
      return {
        a: a,
        b: b
      };
    }, ref$);
    eq(str.split(O, 42).a, str);
    eq(str.split(O, 42).b, 42);
    eq(''.split.call(num, O, 42).a, num);
    eq(''.split.call(num, O, 42).b, 42);
    re = /./;
    re[Symbol.split] = function(a, b){
      return {
        a: a,
        b: b
      };
    };
    eq(str.split(re, 42).a, str);
    eq(str.split(re, 42).b, 42);
    eq(''.split.call(num, re, 42).a, num);
    eq(''.split.call(num, re, 42).b, 42);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, isIterator, same, getOwnPropertyDescriptor, freeze, iterator, eq, deq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  same = function(a, b){
    if (a === b) {
      return a !== 0 || 1 / a === 1 / b;
    } else {
      return a != a && b != b;
    }
  };
  getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor, freeze = Object.freeze;
  iterator = Symbol.iterator;
  eq = strictEqual;
  deq = deepEqual;
  test('Set', function(){
    var S, r, done, iter, _add, a;
    ok(isFunction(Set), 'Is function');
    ok(/native code/.test(Set), 'looks like native');
    if ('name' in Set) {
      eq(Set.name, 'Set', 'name is "Set"');
    }
    eq(Set.length, 0, 'length is 0');
    ok('add' in Set.prototype, 'add in Set.prototype');
    ok('clear' in Set.prototype, 'clear in Set.prototype');
    ok('delete' in Set.prototype, 'delete in Set.prototype');
    ok('forEach' in Set.prototype, 'forEach in Set.prototype');
    ok('has' in Set.prototype, 'has in Set.prototype');
    ok(new Set instanceof Set, 'new Set instanceof Set');
    eq(new Set([1, 2, 3, 2, 1].values()).size, 3, 'Init from iterator #1');
    eq(new Set([1, 2, 3, 2, 1]).size, 3, 'Init Set from iterator #2');
    eq(new Set([freeze({}), 1]).size, 2, 'Support frozen objects');
    S = new Set([1, 2, 3, 2, 1]);
    eq(S.size, 3);
    r = [];
    S.forEach(function(v){
      return r.push(v);
    });
    deq(r, [1, 2, 3]);
    eq(new Set([NaN, NaN, NaN]).size, 1);
    if (Array.from) {
      deq(Array.from(new Set([3, 4]).add(2).add(1)), [3, 4, 2, 1]);
    }
    done = false;
    iter = [null, 1, 2].values();
    iter['return'] = function(){
      return done = true;
    };
    _add = Set.prototype.add;
    Set.prototype.add = function(){
      throw 42;
    };
    try {
      new Set(iter);
    } catch (e$) {}
    Set.prototype.add = _add;
    ok(done, '.return #throw');
    a = [];
    done = false;
    a[iterator] = function(){
      done = true;
      return [][iterator].call(this);
    };
    new Set(a);
    ok(done);
  });
  test('Set#add', function(){
    var a, S, chain, f;
    ok(isFunction(Set.prototype.add), 'Is function');
    ok(/native code/.test(Set.prototype.add), 'looks like native');
    a = [];
    S = new Set([NaN, 2, 3, 2, 1, a]);
    eq(S.size, 5);
    chain = S.add(NaN);
    eq(chain, S);
    eq(S.size, 5);
    S.add(2);
    eq(S.size, 5);
    S.add(a);
    eq(S.size, 5);
    S.add([]);
    eq(S.size, 6);
    S.add(4);
    eq(S.size, 7);
    S = new Set().add(freeze(f = {}));
    ok(S.has(f));
  });
  test('Set#clear', function(){
    var S, f;
    ok(isFunction(Set.prototype.clear), 'Is function');
    ok(/native code/.test(Set.prototype.clear), 'looks like native');
    S = new Set;
    S.clear();
    eq(S.size, 0);
    S = new Set([1, 2, 3, 2, 1]);
    S.clear();
    eq(S.size, 0);
    ok(!S.has(1));
    ok(!S.has(2));
    ok(!S.has(3));
    S = new Set([1, f = freeze({})]);
    S.clear();
    eq(S.size, 0, 'Support frozen objects');
    ok(!S.has(1));
    ok(!S.has(f));
  });
  test('Set#delete', function(){
    var a, S, f;
    ok(isFunction(Set.prototype['delete']), 'Is function');
    ok(/native code/.test(Set.prototype['delete']), 'looks like native');
    a = [];
    S = new Set([NaN, 2, 3, 2, 1, a]);
    eq(S.size, 5);
    eq(S['delete'](NaN), true);
    eq(S.size, 4);
    eq(S['delete'](4), false);
    eq(S.size, 4);
    S['delete']([]);
    eq(S.size, 4);
    S['delete'](a);
    eq(S.size, 3);
    S.add(freeze(f = {}));
    eq(S.size, 4);
    S['delete'](f);
    eq(S.size, 3);
  });
  test('Set#forEach', function(){
    var r, count, S, set, s;
    ok(isFunction(Set.prototype.forEach), 'Is function');
    ok(/native code/.test(Set.prototype.forEach), 'looks like native');
    r = [];
    count = 0;
    S = new Set([1, 2, 3, 2, 1]);
    S.forEach(function(value){
      count++;
      r.push(value);
    });
    eq(count, 3);
    deq(r, [1, 2, 3]);
    set = new Set(['0', '1', '2', '3']);
    s = "";
    set.forEach(function(it){
      s += it;
      if (it === '2') {
        set['delete']('2');
        set['delete']('3');
        set['delete']('1');
        return set.add('4');
      }
    });
    eq(s, '0124');
    set = new Set(['0']);
    s = "";
    set.forEach(function(it){
      set['delete']('0');
      if (s !== '') {
        throw '!!!';
      }
      return s += it;
    });
    eq(s, '0');
  });
  test('Set#has', function(){
    var a, f, S;
    ok(isFunction(Set.prototype.has), 'Is function');
    ok(/native code/.test(Set.prototype.has), 'looks like native');
    a = [];
    f = freeze({});
    S = new Set([NaN, 2, 3, 2, 1, f, a]);
    ok(S.has(NaN));
    ok(S.has(a));
    ok(S.has(f));
    ok(S.has(2));
    ok(!S.has(4));
    ok(!S.has([]));
  });
  test('Set#size', function(){
    var size, sizeDesc;
    size = new Set([1]).size;
    eq(typeof size, 'number', 'size is number');
    eq(size, 1, 'size is correct');
    if (function(){
      try {
        return 2 === Object.defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      sizeDesc = getOwnPropertyDescriptor(Set.prototype, 'size');
      ok(sizeDesc && sizeDesc.get, 'size is getter');
      ok(sizeDesc && !sizeDesc.set, 'size isnt setter');
      throws(function(){
        return Set.prototype.size;
      }, TypeError);
    }
  });
  test('Set & -0', function(){
    var set;
    set = new Set;
    set.add(-0);
    eq(set.size, 1);
    ok(set.has(0));
    ok(set.has(-0));
    set.forEach(function(it){
      return ok(!same(it, -0));
    });
    set['delete'](-0);
    eq(set.size, 0);
    set = new Set([-0]);
    set.forEach(function(key){
      return ok(!same(key, -0));
    });
  });
  test('Set#@@toStringTag', function(){
    eq(Set.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Set', 'Set::@@toStringTag is `Set`');
  });
  test('Set Iterator', function(){
    var set, keys, iterator;
    set = new Set(['a', 'b', 'c', 'd']);
    keys = [];
    iterator = set.keys();
    keys.push(iterator.next().value);
    ok(set['delete']('a'));
    ok(set['delete']('b'));
    ok(set['delete']('c'));
    set.add('e');
    keys.push(iterator.next().value);
    keys.push(iterator.next().value);
    ok(iterator.next().done);
    set.add('f');
    ok(iterator.next().done);
    deq(keys, ['a', 'd', 'e']);
  });
  test('Set#keys', function(){
    var iter;
    ok(typeof Set.prototype.keys === 'function', 'Is function');
    ok(/native code/.test(Set.prototype.keys), 'looks like native');
    eq(Set.prototype.keys, Set.prototype.values);
    iter = new Set(['q', 'w', 'e']).keys();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#values', function(){
    var iter;
    ok(typeof Set.prototype.values === 'function', 'Is function');
    ok(/native code/.test(Set.prototype.values), 'looks like native');
    iter = new Set(['q', 'w', 'e']).values();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#entries', function(){
    var iter;
    ok(typeof Set.prototype.entries === 'function', 'Is function');
    ok(/native code/.test(Set.prototype.entries), 'looks like native');
    iter = new Set(['q', 'w', 'e']).entries();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: ['q', 'q'],
      done: false
    });
    deq(iter.next(), {
      value: ['w', 'w'],
      done: false
    });
    deq(iter.next(), {
      value: ['e', 'e'],
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#@@iterator', function(){
    var iter;
    ok(typeof Set.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8] === 'function', 'Is function');
    ok(/native code/.test(Set.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]), 'looks like native');
    eq(Set.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8], Set.prototype.values);
    iter = new Set(['q', 'w', 'e'])[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'Set Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#codePointAt', function(){
    ok(toString$.call(String.prototype.codePointAt).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.codePointAt.length, 1, 'arity is 1');
    ok(/native code/.test(String.prototype.codePointAt), 'looks like native');
    if ('name' in String.prototype.codePointAt) {
      eq(String.prototype.codePointAt.name, 'codePointAt', 'name is "codePointAt"');
    }
    eq('abc\uD834\uDF06def'.codePointAt(''), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt('_'), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt(), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt(-Infinity), void 8);
    eq('abc\uD834\uDF06def'.codePointAt(-1), void 8);
    eq('abc\uD834\uDF06def'.codePointAt(-0), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt(0), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt(3), 0x1D306);
    eq('abc\uD834\uDF06def'.codePointAt(4), 0xDF06);
    eq('abc\uD834\uDF06def'.codePointAt(5), 0x64);
    eq('abc\uD834\uDF06def'.codePointAt(42), void 8);
    eq('abc\uD834\uDF06def'.codePointAt(Infinity), void 8);
    eq('abc\uD834\uDF06def'.codePointAt(Infinity), void 8);
    eq('abc\uD834\uDF06def'.codePointAt(NaN), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt(false), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt(null), 0x61);
    eq('abc\uD834\uDF06def'.codePointAt(void 8), 0x61);
    eq('\uD834\uDF06def'.codePointAt(''), 0x1D306);
    eq('\uD834\uDF06def'.codePointAt('1'), 0xDF06);
    eq('\uD834\uDF06def'.codePointAt('_'), 0x1D306);
    eq('\uD834\uDF06def'.codePointAt(), 0x1D306);
    eq('\uD834\uDF06def'.codePointAt(-1), void 8);
    eq('\uD834\uDF06def'.codePointAt(-0), 0x1D306);
    eq('\uD834\uDF06def'.codePointAt(0), 0x1D306);
    eq('\uD834\uDF06def'.codePointAt(1), 0xDF06);
    eq('\uD834\uDF06def'.codePointAt(42), void 8);
    eq('\uD834\uDF06def'.codePointAt(false), 0x1D306);
    eq('\uD834\uDF06def'.codePointAt(null), 0x1D306);
    eq('\uD834\uDF06def'.codePointAt(void 8), 0x1D306);
    eq('\uD834abc'.codePointAt(''), 0xD834);
    eq('\uD834abc'.codePointAt('_'), 0xD834);
    eq('\uD834abc'.codePointAt(), 0xD834);
    eq('\uD834abc'.codePointAt(-1), void 8);
    eq('\uD834abc'.codePointAt(-0), 0xD834);
    eq('\uD834abc'.codePointAt(0), 0xD834);
    eq('\uD834abc'.codePointAt(false), 0xD834);
    eq('\uD834abc'.codePointAt(NaN), 0xD834);
    eq('\uD834abc'.codePointAt(null), 0xD834);
    eq('\uD834abc'.codePointAt(void 8), 0xD834);
    eq('\uDF06abc'.codePointAt(''), 0xDF06);
    eq('\uDF06abc'.codePointAt('_'), 0xDF06);
    eq('\uDF06abc'.codePointAt(), 0xDF06);
    eq('\uDF06abc'.codePointAt(-1), void 8);
    eq('\uDF06abc'.codePointAt(-0), 0xDF06);
    eq('\uDF06abc'.codePointAt(0), 0xDF06);
    eq('\uDF06abc'.codePointAt(false), 0xDF06);
    eq('\uDF06abc'.codePointAt(NaN), 0xDF06);
    eq('\uDF06abc'.codePointAt(null), 0xDF06);
    eq('\uDF06abc'.codePointAt(void 8), 0xDF06);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.codePointAt.call(null, 0);
      }, TypeError);
      throws(function(){
        return String.prototype.codePointAt.call(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#endsWith', function(){
    ok(toString$.call(String.prototype.endsWith).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.endsWith.length, 1, 'arity is 1');
    ok(/native code/.test(String.prototype.endsWith), 'looks like native');
    if ('name' in String.prototype.endsWith) {
      eq(String.prototype.endsWith.name, 'endsWith', 'name is "endsWith"');
    }
    ok('undefined'.endsWith());
    ok(!'undefined'.endsWith(null));
    ok('abc'.endsWith(''));
    ok('abc'.endsWith('c'));
    ok('abc'.endsWith('bc'));
    ok(!'abc'.endsWith('ab'));
    ok('abc'.endsWith('', NaN));
    ok(!'abc'.endsWith('c', -1));
    ok('abc'.endsWith('a', 1));
    ok('abc'.endsWith('c', Infinity));
    ok('abc'.endsWith('a', true));
    ok(!'abc'.endsWith('c', 'x'));
    ok(!'abc'.endsWith('a', 'x'));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.endsWith.call(null, '.');
      }, TypeError);
      throws(function(){
        return String.prototype.endsWith.call(void 8, '.');
      }, TypeError);
    }
    throws(function(){
      return 'qwe'.endsWith(/./);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String.fromCodePoint', function(){
    var fromCodePoint, tmp, counter, result;
    fromCodePoint = String.fromCodePoint;
    ok(toString$.call(fromCodePoint).slice(8, -1) === 'Function', 'Is function');
    eq(fromCodePoint.length, 1, 'arity is 1');
    ok(/native code/.test(fromCodePoint), 'looks like native');
    if ('name' in fromCodePoint) {
      eq(fromCodePoint.name, 'fromCodePoint', 'name is "fromCodePoint"');
    }
    eq(fromCodePoint(''), '\0');
    eq(fromCodePoint(), '');
    eq(fromCodePoint(-0), '\0');
    eq(fromCodePoint(0), '\0');
    eq(fromCodePoint(0x1D306), '\uD834\uDF06');
    eq(fromCodePoint(0x1D306, 0x61, 0x1D307), '\uD834\uDF06a\uD834\uDF07');
    eq(fromCodePoint(0x61, 0x62, 0x1D307), 'ab\uD834\uDF07');
    eq(fromCodePoint(false), '\0');
    eq(fromCodePoint(null), '\0');
    throws(function(){
      return fromCodePoint('_');
    }, RangeError);
    throws(function(){
      return fromCodePoint('+Infinity');
    }, RangeError);
    throws(function(){
      return fromCodePoint('-Infinity');
    }, RangeError);
    throws(function(){
      return fromCodePoint(-1);
    }, RangeError);
    throws(function(){
      return fromCodePoint(0x10FFFF + 1);
    }, RangeError);
    throws(function(){
      return fromCodePoint(3.14);
    }, RangeError);
    throws(function(){
      return fromCodePoint(3e-2);
    }, RangeError);
    throws(function(){
      return fromCodePoint(-Infinity);
    }, RangeError);
    throws(function(){
      return fromCodePoint(Infinity);
    }, RangeError);
    throws(function(){
      return fromCodePoint(NaN);
    }, RangeError);
    throws(function(){
      return fromCodePoint(void 8);
    }, RangeError);
    throws(function(){
      return fromCodePoint({});
    }, RangeError);
    throws(function(){
      return fromCodePoint(/./);
    }, RangeError);
    tmp = 0x60;
    eq(fromCodePoint({
      valueOf: function(){
        return ++tmp;
      }
    }), 'a');
    eq(tmp, 0x61);
    counter = Math.pow(2, 15) * 3 / 2;
    result = [];
    while (--counter >= 0) {
      result.push(0);
    }
    fromCodePoint.apply(null, result);
    counter = Math.pow(2, 15) * 3 / 2;
    result = [];
    while (--counter >= 0) {
      result.push(0xFFFF + 1);
    }
    fromCodePoint.apply(null, result);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#includes', function(){
    ok(toString$.call(String.prototype.includes).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.includes.length, 1, 'arity is 1');
    ok(/native code/.test(String.prototype.includes), 'looks like native');
    if ('name' in String.prototype.includes) {
      eq(String.prototype.includes.name, 'includes', 'name is "includes"');
    }
    ok(!'abc'.includes());
    ok('aundefinedb'.includes());
    ok('abcd'.includes('b', 1));
    ok(!'abcd'.includes('b', 2));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.includes.call(null, '.');
      }, TypeError);
      throws(function(){
        return String.prototype.includes.call(void 8, '.');
      }, TypeError);
    }
    throws(function(){
      return 'foo[a-z]+(bar)?'.includes(/[a-z]+/);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, isFunction, isIterator, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  test('String#@@iterator', function(){
    var iter;
    ok(isFunction(String.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]), 'Is function');
    iter = 'qwe'[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]();
    ok(isIterator(iter), 'Return iterator');
    eq(iter[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'String Iterator');
    deq(iter.next(), {
      value: 'q',
      done: false
    });
    deq(iter.next(), {
      value: 'w',
      done: false
    });
    deq(iter.next(), {
      value: 'e',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
    eq(Array.from('𠮷𠮷𠮷').length, 3);
    iter = '𠮷𠮷𠮷'[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.iterator : void 8]();
    deq(iter.next(), {
      value: '𠮷',
      done: false
    });
    deq(iter.next(), {
      value: '𠮷',
      done: false
    });
    deq(iter.next(), {
      value: '𠮷',
      done: false
    });
    deq(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String.raw', function(){
    var raw;
    raw = String.raw;
    ok(toString$.call(raw).slice(8, -1) === 'Function', 'Is function');
    eq(raw.length, 1, 'arity is 1');
    ok(/native code/.test(raw), 'looks like native');
    if ('name' in raw) {
      eq(raw.name, 'raw', 'name is "raw"');
    }
    eq(raw({
      raw: ['Hi\\n', '!']
    }, 'Bob'), 'Hi\\nBob!', 'raw is array');
    eq(raw({
      raw: 'test'
    }, 0, 1, 2), 't0e1s2t', 'raw is string');
    eq(raw({
      raw: 'test'
    }, 0), 't0est', 'lacks substituting');
    throws(function(){
      return raw({});
    }, TypeError);
    throws(function(){
      return raw({
        raw: null
      });
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#repeat', function(){
    ok(toString$.call(String.prototype.repeat).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.repeat.length, 1, 'arity is 1');
    ok(/native code/.test(String.prototype.repeat), 'looks like native');
    if ('name' in String.prototype.repeat) {
      eq(String.prototype.repeat.name, 'repeat', 'name is "repeat"');
    }
    eq('qwe'.repeat(3), 'qweqweqwe');
    eq('qwe'.repeat(2.5), 'qweqwe');
    throws(function(){
      return 'qwe'.repeat(-1);
    }, RangeError);
    throws(function(){
      return 'qwe'.repeat(Infinity);
    }, RangeError);
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.repeat.call(null, 1);
      }, TypeError);
      throws(function(){
        return String.prototype.repeat.call(void 8, 1);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#startsWith', function(){
    ok(toString$.call(String.prototype.startsWith).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.startsWith.length, 1, 'arity is 1');
    ok(/native code/.test(String.prototype.startsWith), 'looks like native');
    if ('name' in String.prototype.startsWith) {
      eq(String.prototype.startsWith.name, 'startsWith', 'name is "startsWith"');
    }
    ok('undefined'.startsWith());
    ok(!'undefined'.startsWith(null));
    ok('abc'.startsWith(''));
    ok('abc'.startsWith('a'));
    ok('abc'.startsWith('ab'));
    ok(!'abc'.startsWith('bc'));
    ok('abc'.startsWith('', NaN));
    ok('abc'.startsWith('a', -1));
    ok(!'abc'.startsWith('a', 1));
    ok(!'abc'.startsWith('a', Infinity));
    ok('abc'.startsWith('b', true));
    ok('abc'.startsWith('a', 'x'));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.startsWith.call(null, '.');
      }, TypeError);
      throws(function(){
        return String.prototype.startsWith.call(void 8, '.');
      }, TypeError);
    }
    throws(function(){
      return 'qwe'.startsWith(/./);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  test('String#trim', function(){
    ok(toString$.call(''.trim).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.trim.length, 0, 'arity is 0');
    ok(/native code/.test(String.prototype.trim), 'looks like native');
    if ('name' in String.prototype.trim) {
      eq(String.prototype.trim.name, 'trim', 'name is "trim"');
    }
    eq(' \n  q w e \n  '.trim(), 'q w e', 'removes whitespaces at left & right side of string');
    eq('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'.trim(), '', 'removes all whitespaces');
    eq('\u200b\u0085'.trim(), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.trim.call(null, 0);
      }, TypeError);
      throws(function(){
        return String.prototype.trim.call(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, defineProperty, getOwnPropertyDescriptor, create, isFunction, isNative, descriptors, G, i$, ref$, len$, key, toString$ = {}.toString;
  QUnit.module('ES6');
  eq = strictEqual;
  deq = deepEqual;
  defineProperty = Object.defineProperty, getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor, create = Object.create;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isNative = function(it){
    return /\[native code\]\s*\}\s*$/.test(it);
  };
  descriptors = function(){
    try {
      return 2 === Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  G = (typeof global != 'undefined' && global !== null) && global || window;
  test('Symbol', function(){
    var s1, s2, O, count, i;
    ok(isFunction(Symbol), 'Is function');
    ok(/native code/.test(Symbol), 'looks like native');
    s1 = Symbol('foo');
    s2 = Symbol('foo');
    ok(s1 !== s2, 'Symbol("foo") !== Symbol("foo")');
    O = {};
    O[s1] = 42;
    ok(O[s1] === 42, 'Symbol() work as key');
    ok(O[s2] !== 42, 'Various symbols from one description are various keys');
    if (descriptors) {
      count = 0;
      for (i in O) {
        count++;
      }
      ok(count === 0, 'object[Symbol()] is not enumerable');
    }
  });
  test('Well-known Symbols', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = ['hasInstance', 'isConcatSpreadable', 'iterator', 'match', 'replace', 'search', 'species', 'split', 'toPrimitive', 'toStringTag', 'unscopables']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(x$ in Symbol, "Symbol." + x$ + " available");
      ok(Object(Symbol[x$]) instanceof Symbol, "Symbol." + x$ + " is symbol");
    }
  });
  test('Global symbol registry', function(){
    var symbol;
    ok(isFunction(Symbol['for']), 'Symbol.for is function');
    ok(isFunction(Symbol.keyFor), 'Symbol.keyFor is function');
    ok(/native code/.test(Symbol['for']), 'Symbol.for looks like native');
    ok(/native code/.test(Symbol.keyFor), 'Symbol.keyFor looks like native');
    symbol = Symbol['for']('foo');
    eq(Symbol['for']('foo'), symbol);
    eq(Symbol.keyFor(symbol), 'foo');
  });
  test('Symbol#@@toStringTag', function(){
    ok(Symbol.prototype[Symbol.toStringTag] === 'Symbol', 'Symbol::@@toStringTag is `Symbol`');
  });
  test('Object.getOwnPropertySymbols', function(){
    var getOwnPropertySymbols, getOwnPropertyNames, obj, foo, ref$;
    getOwnPropertySymbols = Object.getOwnPropertySymbols, getOwnPropertyNames = Object.getOwnPropertyNames;
    ok(isFunction(getOwnPropertySymbols), 'Is function');
    obj = {
      q: 1,
      w: 2,
      e: 3
    };
    obj[Symbol()] = 42;
    obj[Symbol()] = 43;
    deq(getOwnPropertyNames(obj).sort(), ['e', 'q', 'w']);
    eq(getOwnPropertySymbols(obj).length, 2);
    foo = (ref$ = clone$(obj), ref$.a = 1, ref$.s = 2, ref$.d = 3, ref$);
    foo[Symbol()] = 44;
    deq(getOwnPropertyNames(foo).sort(), ['a', 'd', 's']);
    eq(getOwnPropertySymbols(foo).length, 1);
  });
  if (typeof JSON != 'undefined' && JSON !== null) {
    test('Symbols & JSON.stringify', function(){
      var ref$;
      eq(JSON.stringify([1, Symbol('foo'), false, Symbol('bar'), {}]), '[1,null,false,null,{}]', 'array value');
      eq(JSON.stringify({
        foo: Symbol('foo')
      }), '{}', 'object value');
      if (descriptors) {
        eq(JSON.stringify((ref$ = {}, ref$[Symbol('foo')] = 1, ref$.bar = 2, ref$)), '{"bar":2}', 'object key');
      }
    });
  }
  if (descriptors) {
    test('Symbols & descriptors', function(){
      var create, defineProperty, getOwnPropertyDescriptor, keys, getOwnPropertyNames, getOwnPropertySymbols, d, e, f, i, j, proto, ref$, O, desc;
      create = Object.create, defineProperty = Object.defineProperty, getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor, keys = Object.keys, getOwnPropertyNames = Object.getOwnPropertyNames, getOwnPropertySymbols = Object.getOwnPropertySymbols;
      d = Symbol('d');
      e = Symbol('e');
      f = Symbol('f');
      i = Symbol('i');
      j = Symbol('j');
      proto = (ref$ = {
        g: 'g'
      }, ref$[i] = 'i', ref$);
      defineProperty(proto, 'h', {
        value: 'h'
      });
      defineProperty(proto, 'j', {
        value: 'j'
      });
      O = create(proto);
      O.a = 'a';
      O[d] = 'd';
      defineProperty(O, 'b', {
        value: 'b'
      });
      defineProperty(O, 'c', {
        value: 'c',
        enumerable: true
      });
      defineProperty(O, e, {
        configurable: true,
        writable: true,
        value: 'e'
      });
      desc = {
        value: 'f',
        enumerable: true
      };
      defineProperty(O, f, desc);
      eq(desc.enumerable, true, 'defineProperty not changes descriptor object');
      deq(getOwnPropertyDescriptor(O, 'a'), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'a'
      }, 'getOwnPropertyDescriptor a');
      deq(getOwnPropertyDescriptor(O, 'b'), {
        configurable: false,
        writable: false,
        enumerable: false,
        value: 'b'
      }, 'getOwnPropertyDescriptor b');
      deq(getOwnPropertyDescriptor(O, 'c'), {
        configurable: false,
        writable: false,
        enumerable: true,
        value: 'c'
      }, 'getOwnPropertyDescriptor c');
      deq(getOwnPropertyDescriptor(O, d), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'd'
      }, 'getOwnPropertyDescriptor d');
      deq(getOwnPropertyDescriptor(O, e), {
        configurable: true,
        writable: true,
        enumerable: false,
        value: 'e'
      }, 'getOwnPropertyDescriptor e');
      deq(getOwnPropertyDescriptor(O, f), {
        configurable: false,
        writable: false,
        enumerable: true,
        value: 'f'
      }, 'getOwnPropertyDescriptor f');
      eq(getOwnPropertyDescriptor(O, 'g'), void 8, 'getOwnPropertyDescriptor g');
      eq(getOwnPropertyDescriptor(O, 'h'), void 8, 'getOwnPropertyDescriptor h');
      eq(getOwnPropertyDescriptor(O, i), void 8, 'getOwnPropertyDescriptor i');
      eq(getOwnPropertyDescriptor(O, j), void 8, 'getOwnPropertyDescriptor j');
      eq(getOwnPropertyDescriptor(O, 'k'), void 8, 'getOwnPropertyDescriptor k');
      eq(O.propertyIsEnumerable('a'), true, 'propertyIsEnumerable a');
      eq(O.propertyIsEnumerable('b'), false, 'propertyIsEnumerable b');
      eq(O.propertyIsEnumerable('c'), true, 'propertyIsEnumerable c');
      eq(O.propertyIsEnumerable(d), true, 'propertyIsEnumerable d');
      eq(O.propertyIsEnumerable(e), false, 'propertyIsEnumerable e');
      eq(O.propertyIsEnumerable(f), true, 'propertyIsEnumerable f');
      eq(O.propertyIsEnumerable('g'), false, 'propertyIsEnumerable g');
      eq(O.propertyIsEnumerable('h'), false, 'propertyIsEnumerable h');
      eq(O.propertyIsEnumerable(i), false, 'propertyIsEnumerable i');
      eq(O.propertyIsEnumerable(j), false, 'propertyIsEnumerable j');
      eq(O.propertyIsEnumerable('k'), false, 'propertyIsEnumerable k');
      eq(keys(O).length, 2, 'Object.keys');
      eq(getOwnPropertyNames(O).length, 3, 'Object.getOwnPropertyNames');
      eq(getOwnPropertySymbols(O).length, 3, 'Object.getOwnPropertySymbols');
      eq(Reflect.ownKeys(O).length, 6, 'Reflect.ownKeys');
      delete O[e];
      O[e] = 'e';
      deq(getOwnPropertyDescriptor(O, e), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'e'
      }, 'redefined non-enum key');
    });
    test('Symbols & Object.defineProperties', function(){
      var defineProperty, defineProperties, c, d, D, ref$, O;
      defineProperty = Object.defineProperty, defineProperties = Object.defineProperties;
      c = Symbol('c');
      d = Symbol('d');
      D = (ref$ = {
        a: {
          value: 'a'
        }
      }, ref$[c] = {
        value: 'c'
      }, ref$);
      defineProperty(D, 'b', {
        value: {
          value: 'b'
        }
      });
      defineProperty(D, d, {
        value: {
          value: 'd'
        }
      });
      O = defineProperties({}, D);
      eq(O.a, 'a', 'a');
      eq(O.b, void 8, 'b');
      eq(O[c], 'c', 'c');
      eq(O[d], void 8, 'd');
    });
    test('Symbols & Object.create', function(){
      var defineProperty, create, c, d, D, ref$, O;
      defineProperty = Object.defineProperty, create = Object.create;
      c = Symbol('c');
      d = Symbol('d');
      D = (ref$ = {
        a: {
          value: 'a'
        }
      }, ref$[c] = {
        value: 'c'
      }, ref$);
      defineProperty(D, 'b', {
        value: {
          value: 'b'
        }
      });
      defineProperty(D, d, {
        value: {
          value: 'd'
        }
      });
      O = create(null, D);
      eq(O.a, 'a', 'a');
      eq(O.b, void 8, 'b');
      eq(O[c], 'c', 'c');
      eq(O[d], void 8, 'd');
    });
    for (i$ = 0, len$ = (ref$ = ['Array', 'RegExp', 'Map', 'Set', 'WeakMap', 'WeakSet', 'Promise']).length; i$ < len$; ++i$) {
      key = ref$[i$];
      test(key + "@@species", fn$);
    }
  }
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
  function fn$(){
    var C;
    eq(G[key][Symbol.species], G[key], key + "@@species === " + key);
    C = Object.create(G[key]);
    eq(C[Symbol.species], C, key + " sub");
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, freeze, iterator, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  freeze = Object.freeze;
  iterator = Symbol.iterator;
  eq = strictEqual;
  test('WeakMap', function(){
    var a, b, f, M, done, iter;
    ok(isFunction(WeakMap), 'Is function');
    ok(/native code/.test(WeakMap), 'looks like native');
    if ('name' in WeakMap) {
      eq(WeakMap.name, 'WeakMap', 'name is "WeakMap"');
    }
    eq(WeakMap.length, 0, 'length is 0');
    ok('delete' in WeakMap.prototype, 'delete in WeakMap.prototype');
    ok('get' in WeakMap.prototype, 'get in WeakMap.prototype');
    ok('has' in WeakMap.prototype, 'has in WeakMap.prototype');
    ok('set' in WeakMap.prototype, 'set in WeakMap.prototype');
    ok(new WeakMap instanceof WeakMap, 'new WeakMap instanceof WeakMap');
    eq(new WeakMap([[a = {}, b = {}]].values()).get(a), b, 'Init WeakMap from iterator #1');
    eq(new WeakMap(new Map([[a = {}, b = {}]])).get(a), b, 'Init WeakMap from iterator #2');
    eq(new WeakMap([[f = freeze({}), 42]]).get(f), 42, 'Support frozen objects');
    M = new WeakMap;
    M.set(freeze(f = {}), 42);
    eq(M.has(f), true);
    eq(M.get(f), 42);
    M['delete'](f);
    eq(M.has(f), false);
    eq(M.get(f), void 8);
    done = false;
    iter = [null, 1, 2].values();
    iter['return'] = function(){
      return done = true;
    };
    try {
      new WeakMap(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
    ok(!('clear' in WeakMap.prototype), 'should not contains `.clear` method');
    a = [];
    done = false;
    a[iterator] = function(){
      done = true;
      return [][iterator].call(this);
    };
    new WeakMap(a);
    ok(done);
  });
  test('WeakMap#delete', function(){
    var M, a, b;
    ok(isFunction(WeakMap.prototype['delete']), 'Is function');
    ok(/native code/.test(WeakMap.prototype['delete']), 'looks like native');
    M = new WeakMap().set(a = {}, 42).set(b = {}, 21);
    ok(M.has(a) && M.has(b), 'WeakMap has values before .delete()');
    M['delete'](a);
    ok(!M.has(a) && M.has(b), 'WeakMap hasn`t value after .delete()');
  });
  test('WeakMap#get', function(){
    var M, a;
    ok(isFunction(WeakMap.prototype.get), 'Is function');
    ok(/native code/.test(WeakMap.prototype.get), 'looks like native');
    M = new WeakMap();
    eq(M.get({}), void 8, 'WeakMap .get() before .set() return undefined');
    M.set(a = {}, 42);
    eq(M.get(a), 42, 'WeakMap .get() return value');
    M['delete'](a);
    eq(M.get(a), void 8, 'WeakMap .get() after .delete() return undefined');
  });
  test('WeakMap#has', function(){
    var M, a;
    ok(isFunction(WeakMap.prototype.has), 'Is function');
    ok(/native code/.test(WeakMap.prototype.has), 'looks like native');
    M = new WeakMap();
    ok(!M.has({}), 'WeakMap .has() before .set() return false');
    M.set(a = {}, 42);
    ok(M.has(a), 'WeakMap .has() return true');
    M['delete'](a);
    ok(!M.has(a), 'WeakMap .has() after .delete() return false');
  });
  test('WeakMap#set', function(){
    var a, e;
    ok(isFunction(WeakMap.prototype.set), 'Is function');
    ok(/native code/.test(WeakMap.prototype.set), 'looks like native');
    ok(new WeakMap().set(a = {}, 42), 'WeakMap.prototype.set works with object as keys');
    ok((function(){
      try {
        new WeakMap().set(42, 42);
        return false;
      } catch (e$) {
        e = e$;
        return true;
      }
    }()), 'WeakMap.prototype.set throw with primitive keys');
  });
  test('WeakMap#@@toStringTag', function(){
    eq(WeakMap.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'WeakMap', 'WeakMap::@@toStringTag is `WeakMap`');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, freeze, iterator, eq, toString$ = {}.toString;
  QUnit.module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  freeze = Object.freeze;
  iterator = Symbol.iterator;
  eq = strictEqual;
  test('WeakSet', function(){
    var a, f, S, done, iter;
    ok(isFunction(WeakSet), 'Is function');
    ok(/native code/.test(WeakSet), 'looks like native');
    if ('name' in WeakSet) {
      eq(WeakSet.name, 'WeakSet', 'name is "WeakSet"');
    }
    eq(WeakSet.length, 0, 'length is 0');
    ok('add' in WeakSet.prototype, 'add in WeakSet.prototype');
    ok('delete' in WeakSet.prototype, 'delete in WeakSet.prototype');
    ok('has' in WeakSet.prototype, 'has in WeakSet.prototype');
    ok(new WeakSet instanceof WeakSet, 'new WeakSet instanceof WeakSet');
    ok(new WeakSet([a = {}].values()).has(a), 'Init WeakSet from iterator #1');
    ok(new WeakSet([a = {}]).has(a), 'Init WeakSet from iterator #2');
    ok(new WeakSet([freeze(f = {})]).has(f), 'Support frozen objects');
    S = new WeakSet;
    S.add(freeze(f = {}));
    eq(S.has(f), true);
    S['delete'](f);
    eq(S.has(f), false);
    done = false;
    iter = [null, 1, 2].values();
    iter['return'] = function(){
      return done = true;
    };
    try {
      new WeakSet(iter);
    } catch (e$) {}
    ok(done, '.return #throw');
    ok(!('clear' in WeakSet.prototype), 'should not contains `.clear` method');
    a = [];
    done = false;
    a[iterator] = function(){
      done = true;
      return [][iterator].call(this);
    };
    new WeakSet(a);
    ok(done);
  });
  test('WeakSet#add', function(){
    var a, e;
    ok(isFunction(WeakSet.prototype.add), 'Is function');
    ok(/native code/.test(WeakSet.prototype.add), 'looks like native');
    ok(new WeakSet().add(a = {}), 'WeakSet.prototype.add works with object as keys');
    ok((function(){
      try {
        new WeakSet().add(42);
        return false;
      } catch (e$) {
        e = e$;
        return true;
      }
    }()), 'WeakSet.prototype.add throw with primitive keys');
  });
  test('WeakSet#delete', function(){
    var S, a, b;
    ok(isFunction(WeakSet.prototype['delete']), 'Is function');
    ok(/native code/.test(WeakSet.prototype['delete']), 'looks like native');
    S = new WeakSet().add(a = {}).add(b = {});
    ok(S.has(a) && S.has(b), 'WeakSet has values before .delete()');
    S['delete'](a);
    ok(!S.has(a) && S.has(b), 'WeakSet has`nt value after .delete()');
  });
  test('WeakSet#has', function(){
    var M, a;
    ok(isFunction(WeakSet.prototype.has), 'Is function');
    ok(/native code/.test(WeakSet.prototype.has), 'looks like native');
    M = new WeakSet();
    ok(!M.has({}), 'WeakSet has`nt value');
    M.add(a = {});
    ok(M.has(a), 'WeakSet has value after .add()');
    M['delete'](a);
    ok(!M.has(a), 'WeakSet has`nt value after .delete()');
  });
  test('WeakSet::@@toStringTag', function(){
    eq(WeakSet.prototype[typeof Symbol != 'undefined' && Symbol !== null ? Symbol.toStringTag : void 8], 'WeakSet', 'WeakSet::@@toStringTag is `WeakSet`');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var toString$ = {}.toString;
  QUnit.module('ES7');
  test('Array#includes', function(){
    var arr, o;
    ok(toString$.call(Array.prototype.includes).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(Array.prototype.includes), 'looks like native');
    arr = [1, 2, 3, -0, o = {}];
    ok(arr.includes(1));
    ok(arr.includes(-0));
    ok(arr.includes(0));
    ok(arr.includes(o));
    ok(!arr.includes(4));
    ok(!arr.includes(-0.5));
    ok(!arr.includes({}));
    ok(Array(1).includes(void 8));
    ok([NaN].includes(NaN));
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return Array.prototype.includes.call(null, 0);
      }, TypeError);
      throws(function(){
        return Array.prototype.includes.call(void 8, 0);
      }, TypeError);
    }
    ok('includes' in Array.prototype[Symbol.unscopables], 'In Array#@@unscopables');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES7');
  test('Map#toJSON', function(){
    ok(toString$.call(Map.prototype.toJSON).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(Map.prototype.toJSON), 'looks like native');
    if (typeof JSON != 'undefined' && JSON !== null) {
      strictEqual(JSON.stringify(new Map([['a', 'b'], ['c', 'd']])), '[["a","b"],["c","d"]]', 'Works');
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  deq = deepEqual;
  test('Object.entries', function(){
    var entries, create, assign;
    entries = Object.entries, create = Object.create, assign = Object.assign;
    ok(toString$.call(entries).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(entries), 'looks like native');
    eq(entries.length, 1, 'arity is 1');
    if ('name' in entries) {
      eq(entries.name, 'entries', 'name is "entries"');
    }
    deq(entries({
      q: 1,
      w: 2,
      e: 3
    }), [['q', 1], ['w', 2], ['e', 3]]);
    deq(entries(new String('qwe')), [['0', 'q'], ['1', 'w'], ['2', 'e']]);
    deq(entries(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    })), [['a', 4], ['s', 5], ['d', 6]]);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var descriptors, eq, create, toString$ = {}.toString;
  QUnit.module('ES7');
  descriptors = function(){
    try {
      return 2 === Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  eq = strictEqual;
  create = Object.create;
  test('Object.getOwnPropertyDescriptors', function(){
    var getOwnPropertyDescriptors, O, s, descs;
    getOwnPropertyDescriptors = Object.getOwnPropertyDescriptors;
    ok(toString$.call(getOwnPropertyDescriptors).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(getOwnPropertyDescriptors), 'looks like native');
    O = create({
      q: 1
    }, {
      e: {
        value: 3
      }
    });
    O.w = 2;
    s = Symbol('s');
    O[s] = 4;
    descs = getOwnPropertyDescriptors(O);
    eq(descs.q, void 8);
    deepEqual(descs.w, {
      enumerable: true,
      configurable: true,
      writable: true,
      value: 2
    });
    if (descriptors) {
      deepEqual(descs.e, {
        enumerable: false,
        configurable: false,
        writable: false,
        value: 3
      });
    } else {
      deepEqual(descs.e, {
        enumerable: true,
        configurable: true,
        writable: true,
        value: 3
      });
    }
    eq(descs[s].value, 4);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, deq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  deq = deepEqual;
  test('Object.values', function(){
    var values, create, assign;
    values = Object.values, create = Object.create, assign = Object.assign;
    ok(toString$.call(values).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(values), 'looks like native');
    eq(values.length, 1, 'arity is 1');
    if ('name' in values) {
      eq(values.name, 'values', 'name is "values"');
    }
    deq(values({
      q: 1,
      w: 2,
      e: 3
    }), [1, 2, 3]);
    deq(values(new String('qwe')), ['q', 'w', 'e']);
    deq(values(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    })), [4, 5, 6]);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('RegExp.escape', function(){
    var escape;
    escape = RegExp.escape;
    ok(toString$.call(escape).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(escape), 'looks like native');
    eq(escape.length, 1, 'arity is 1');
    if ('name' in escape) {
      eq(escape.name, 'escape', 'name is "escape"');
    }
    eq(escape('qwe asd'), 'qwe asd', "Don't change simple string");
    eq(escape('\\[]{}()*+?.^$|'), '\\\\\\[\\]\\{\\}\\(\\)\\*\\+\\?\\.\\^\\$\\|', 'Escape all RegExp special chars');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var toString$ = {}.toString;
  QUnit.module('ES7');
  test('Set#toJSON', function(){
    ok(toString$.call(Set.prototype.toJSON).slice(8, -1) === 'Function', 'Is function');
    ok(/native code/.test(Set.prototype.toJSON), 'looks like native');
    if (typeof JSON != 'undefined' && JSON !== null) {
      strictEqual(JSON.stringify(new Set([1, 2, 3, 2, 1])), '[1,2,3]', 'Works');
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#at', function(){
    var at;
    ok(toString$.call(String.prototype.at).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.at.length, 1, 'arity is 1');
    ok(/native code/.test(String.prototype.at), 'looks like native');
    if ('name' in String.prototype.at) {
      eq(String.prototype.at.name, 'at', 'name is "at"');
    }
    eq('abc\uD834\uDF06def'.at(-Infinity), '');
    eq('abc\uD834\uDF06def'.at(-1), '');
    eq('abc\uD834\uDF06def'.at(-0), 'a');
    eq('abc\uD834\uDF06def'.at(+0), 'a');
    eq('abc\uD834\uDF06def'.at(1), 'b');
    eq('abc\uD834\uDF06def'.at(3), '\uD834\uDF06');
    eq('abc\uD834\uDF06def'.at(4), '\uDF06');
    eq('abc\uD834\uDF06def'.at(5), 'd');
    eq('abc\uD834\uDF06def'.at(42), '');
    eq('abc\uD834\uDF06def'.at(Infinity), '');
    eq('abc\uD834\uDF06def'.at(null), 'a');
    eq('abc\uD834\uDF06def'.at(void 8), 'a');
    eq('abc\uD834\uDF06def'.at(), 'a');
    eq('abc\uD834\uDF06def'.at(false), 'a');
    eq('abc\uD834\uDF06def'.at(NaN), 'a');
    eq('abc\uD834\uDF06def'.at(''), 'a');
    eq('abc\uD834\uDF06def'.at('_'), 'a');
    eq('abc\uD834\uDF06def'.at('1'), 'b');
    eq('abc\uD834\uDF06def'.at([]), 'a');
    eq('abc\uD834\uDF06def'.at({}), 'a');
    eq('abc\uD834\uDF06def'.at(-0.9), 'a');
    eq('abc\uD834\uDF06def'.at(1.9), 'b');
    eq('abc\uD834\uDF06def'.at(7.9), 'f');
    eq('abc\uD834\uDF06def'.at(Math.pow(2, 32)), '');
    eq('\uD834\uDF06def'.at(-Infinity), '');
    eq('\uD834\uDF06def'.at(-1), '');
    eq('\uD834\uDF06def'.at(-0), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at(0), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at(1), '\uDF06');
    eq('\uD834\uDF06def'.at(2), 'd');
    eq('\uD834\uDF06def'.at(3), 'e');
    eq('\uD834\uDF06def'.at(4), 'f');
    eq('\uD834\uDF06def'.at(42), '');
    eq('\uD834\uDF06def'.at(Infinity), '');
    eq('\uD834\uDF06def'.at(null), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at(void 8), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at(), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at(false), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at(NaN), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at(''), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at('_'), '\uD834\uDF06');
    eq('\uD834\uDF06def'.at('1'), '\uDF06');
    eq('\uD834abc'.at(-Infinity), '');
    eq('\uD834abc'.at(-1), '');
    eq('\uD834abc'.at(-0), '\uD834');
    eq('\uD834abc'.at(0), '\uD834');
    eq('\uD834abc'.at(1), 'a');
    eq('\uD834abc'.at(42), '');
    eq('\uD834abc'.at(Infinity), '');
    eq('\uD834abc'.at(null), '\uD834');
    eq('\uD834abc'.at(void 8), '\uD834');
    eq('\uD834abc'.at(), '\uD834');
    eq('\uD834abc'.at(false), '\uD834');
    eq('\uD834abc'.at(NaN), '\uD834');
    eq('\uD834abc'.at(''), '\uD834');
    eq('\uD834abc'.at('_'), '\uD834');
    eq('\uD834abc'.at('1'), 'a');
    eq('\uDF06abc'.at(-Infinity), '');
    eq('\uDF06abc'.at(-1), '');
    eq('\uDF06abc'.at(-0), '\uDF06');
    eq('\uDF06abc'.at(0), '\uDF06');
    eq('\uDF06abc'.at(1), 'a');
    eq('\uDF06abc'.at(42), '');
    eq('\uDF06abc'.at(Infinity), '');
    eq('\uDF06abc'.at(null), '\uDF06');
    eq('\uDF06abc'.at(void 8), '\uDF06');
    eq('\uDF06abc'.at(), '\uDF06');
    eq('\uDF06abc'.at(false), '\uDF06');
    eq('\uDF06abc'.at(NaN), '\uDF06');
    eq('\uDF06abc'.at(''), '\uDF06');
    eq('\uDF06abc'.at('_'), '\uDF06');
    eq('\uDF06abc'.at('1'), 'a');
    at = String.prototype.at;
    eq(at.call(42, 0), '4');
    eq(at.call(42, 1), '2');
    eq(at.call({
      toString: function(){
        return 'abc';
      }
    }, 2), 'c');
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.at.call(null, 0);
      }, TypeError);
      throws(function(){
        return String.prototype.at.call(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#padLeft', function(){
    ok(toString$.call(String.prototype.padLeft).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.padLeft.length, 1, 'arity is 1');
    ok(/native code/.test(String.prototype.padLeft), 'looks like native');
    if ('name' in String.prototype.padLeft) {
      eq(String.prototype.padLeft.name, 'padLeft', 'name is "padLeft"');
    }
    eq('abc'.padLeft(5), '  abc');
    eq('abc'.padLeft(4, 'de'), 'eabc');
    eq('abc'.padLeft(), 'abc');
    eq('abc'.padLeft(5, '_'), '__abc');
    eq(''.padLeft(0), '');
    eq('foo'.padLeft(1), 'foo');
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.padLeft.call(null, 0);
      }, TypeError);
      throws(function(){
        return String.prototype.padLeft.call(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#padRight', function(){
    ok(toString$.call(String.prototype.padRight).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.padRight.length, 1, 'length is 1');
    ok(/native code/.test(String.prototype.padRight), 'looks like native');
    if ('name' in String.prototype.padRight) {
      eq(String.prototype.padRight.name, 'padRight', 'name is "padRight"');
    }
    eq('abc'.padRight(5), 'abc  ');
    eq('abc'.padRight(4, 'de'), 'abcd');
    eq('abc'.padRight(), 'abc');
    eq('abc'.padRight(5, '_'), 'abc__');
    eq(''.padRight(0), '');
    eq('foo'.padRight(1), 'foo');
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.padRight.call(null, 0);
      }, TypeError);
      throws(function(){
        return String.prototype.padRight.call(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#trimLeft', function(){
    ok(toString$.call(''.trimLeft).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.trimLeft.length, 0, 'arity is 0');
    ok(/native code/.test(String.prototype.trimLeft), 'looks like native');
    if ('name' in String.prototype.trimLeft) {
      eq(String.prototype.trimLeft.name, 'trimLeft', 'name is "trimLeft"');
    }
    eq(' \n  q w e \n  '.trimLeft(), 'q w e \n  ', 'removes whitespaces at left side of string');
    eq('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'.trimLeft(), '', 'removes all whitespaces');
    eq('\u200b\u0085'.trimLeft(), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.trimLeft.call(null, 0);
      }, TypeError);
      throws(function(){
        return String.prototype.trimLeft.call(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var eq, toString$ = {}.toString;
  QUnit.module('ES7');
  eq = strictEqual;
  test('String#trimRight', function(){
    ok(toString$.call(''.trimRight).slice(8, -1) === 'Function', 'Is function');
    eq(String.prototype.trimRight.length, 0, 'arity is 0');
    ok(/native code/.test(String.prototype.trimRight), 'looks like native');
    if ('name' in String.prototype.trimRight) {
      eq(String.prototype.trimRight.name, 'trimRight', 'name is "trimRight"');
    }
    eq(' \n  q w e \n  '.trimRight(), ' \n  q w e', 'removes whitespaces at right side of string');
    eq('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'.trimRight(), '', 'removes all whitespaces');
    eq('\u200b\u0085'.trimRight(), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      throws(function(){
        return String.prototype.trimRight.call(null, 0);
      }, TypeError);
      throws(function(){
        return String.prototype.trimRight.call(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, slice, toString$ = {}.toString;
  QUnit.module('Mozilla JavaScript Array statics');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  slice = Array.prototype.slice;
  test('are functions', function(){
    var i$, x$, ref$, len$;
    for (i$ = 0, len$ = (ref$ = ['concat', 'join', 'pop', 'push', 'reverse', 'shift', 'slice', 'sort', 'splice', 'unshift', 'indexOf', 'lastIndexOf', 'every', 'some', 'forEach', 'map', 'filter', 'reduce', 'reduceRight', 'copyWithin', 'fill', 'find', 'findIndex', 'keys', 'values', 'entries', 'includes']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      ok(isFunction(Array[x$]), "Array." + x$ + " is function");
    }
  });
  test('.join', function(){
    var join;
    join = Array.join;
    ok(join('123') === '1,2,3');
    ok(join('123', '|') === '1|2|3');
    ok(join(function(){
      return arguments;
    }(3, 2, 1), '|') === '3|2|1');
  });
  test('.pop', function(){
    var pop, args;
    pop = Array.pop;
    ok(pop(args = function(){
      return arguments;
    }(1, 2, 3)) === 3);
    deepEqual(args, function(){
      return arguments;
    }(1, 2));
  });
  test('.push', function(){
    var push, args;
    push = Array.push;
    push(args = function(){
      return arguments;
    }(1, 2, 3), 4, 5);
    deepEqual(slice.call(args), [1, 2, 3, 4, 5]);
  });
  test('.reverse', function(){
    var reverse;
    reverse = Array.reverse;
    deepEqual(reverse(function(){
      return arguments;
    }(1, 2, 3)), function(){
      return arguments;
    }(3, 2, 1));
  });
  test('.shift', function(){
    var shift, args;
    shift = Array.shift;
    ok(shift(args = function(){
      return arguments;
    }(1, 2, 3)) === 1);
    deepEqual(args, function(){
      return arguments;
    }(2, 3));
  });
  test('.unshift', function(){
    var unshift, args;
    unshift = Array.unshift;
    unshift(args = function(){
      return arguments;
    }(1, 2, 3), 4, 5);
    deepEqual(slice.call(args), [4, 5, 1, 2, 3]);
  });
  test('.slice', function(){
    var slice;
    slice = Array.slice;
    deepEqual(slice('123'), ['1', '2', '3']);
    deepEqual(slice('123', 1), ['2', '3']);
    deepEqual(slice('123', 1, 2), ['2']);
    deepEqual(slice('123', 1, -1), ['2']);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3)), [1, 2, 3]);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1), [2, 3]);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1, 2), [2]);
    deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1, -1), [2]);
  });
  test('.splice', function(){
    var splice, args;
    splice = Array.splice;
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 0, 4, 5);
    deepEqual(slice.call(args), [1, 4, 5, 2, 3]);
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 1, 4);
    deepEqual(slice.call(args), [1, 4, 3]);
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 1);
    deepEqual(slice.call(args), [1, 3]);
  });
  test('.sort', function(){
    var sort;
    sort = Array.sort;
    deepEqual(sort(function(){
      return arguments;
    }(2, 1, 3)), function(){
      return arguments;
    }(1, 2, 3));
    deepEqual(sort(function(){
      return arguments;
    }(11, 2, 3)), function(){
      return arguments;
    }(11, 2, 3));
    deepEqual(sort(function(){
      return arguments;
    }(11, 2, 3), function(a, b){
      return a - b;
    }), function(){
      return arguments;
    }(2, 3, 11));
  });
  test('.indexOf', function(){
    var indexOf;
    indexOf = Array.indexOf;
    ok(indexOf('111', '1') === 0);
    ok(indexOf('123', '1', 1) === -1);
    ok(indexOf('123', '2', 1) === 1);
    ok(indexOf(function(){
      return arguments;
    }(1, 1, 1), 1) === 0);
    ok(indexOf(function(){
      return arguments;
    }(1, 2, 3), 1, 1) === -1);
    ok(indexOf(function(){
      return arguments;
    }(1, 2, 3), 2, 1) === 1);
  });
  test('.lastIndexOf', function(){
    var lastIndexOf;
    lastIndexOf = Array.lastIndexOf;
    ok(lastIndexOf('111', '1') === 2);
    ok(lastIndexOf('123', '3', 1) === -1);
    ok(lastIndexOf('123', '2', 1) === 1);
    ok(lastIndexOf(function(){
      return arguments;
    }(1, 1, 1), 1) === 2);
    ok(lastIndexOf(function(){
      return arguments;
    }(1, 2, 3), 3, 1) === -1);
    ok(lastIndexOf(function(){
      return arguments;
    }(1, 2, 3), 2, 1) === 1);
  });
  test('.every', function(){
    var every, al, ctx;
    every = Array.every;
    every(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(every('123', function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(every('123', function(){
      return arguments[1] < 3;
    }));
    ok(!every('123', function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(!every('123', function(){
      return arguments[1] < 2;
    }));
    ok(every('123', function(){
      return arguments[2] == '123';
    }));
    ok(every(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('.some', function(){
    var some, al, ctx;
    some = Array.some;
    some(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(some('123', function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    ok(some('123', function(){
      return arguments[1] > 1;
    }));
    ok(!some('123', function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    ok(!some('123', function(){
      return arguments[1] > 3;
    }));
    ok(some('123', function(){
      return arguments[2] == '123';
    }));
    ok(some(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('.forEach', function(){
    var forEach, al, ctx, val;
    forEach = Array.forEach;
    forEach(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      ok(that === al);
    }, ctx = {});
    val = '';
    forEach('123', function(v, k, t){
      val += v + k + t;
    });
    ok(val === '101232112332123');
    val = '';
    forEach(function(){
      return arguments;
    }(1, 2, 3), function(v, k, t){
      val += v + k + t['2'];
    });
    ok(val === '468');
    val = '';
    forEach('123', function(v, k, t){
      val += v + k + t + this;
    }, 1);
    ok(val === '101231211231321231');
  });
  test('.map', function(){
    var map, al, ctx;
    map = Array.map;
    map(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    deepEqual(map('123', (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
    deepEqual(map(function(){
      return arguments;
    }(1, 2, 3), (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
  });
  test('.filter', function(){
    var filter, al, ctx;
    filter = Array.filter;
    filter(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    deepEqual(filter('123', function(it){
      return it > 1;
    }), ['2', '3']);
    deepEqual(filter(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return it < 3;
    }), [1, 2]);
    deepEqual(filter('123', function(){
      return arguments[1] !== 1;
    }), ['1', '3']);
  });
  test('.reduce', function(){
    var reduce, al, ctx;
    reduce = Array.reduce;
    reduce(al = function(){
      return arguments;
    }(1), function(memo, val, key, that){
      ok(memo === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    reduce(al = function(){
      return arguments;
    }(1, 2), function(memo){
      return ok(memo === 1);
    });
    ok(reduce('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }) === 6);
    ok(reduce(function(){
      return arguments;
    }(1, 2, 3), function(a, b){
      return '' + b * b + a;
    }) === '941');
    ok(reduce('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }, 1) === 7);
  });
  test('.reduceRight', function(){
    var reduceRight, al, ctx;
    reduceRight = Array.reduceRight;
    reduceRight(al = function(){
      return arguments;
    }(1), function(memo, val, key, that){
      ok(memo === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    reduceRight(al = function(){
      return arguments;
    }(1, 2), function(memo){
      return ok(memo === 2);
    });
    ok(reduceRight('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }) === 6);
    ok(reduceRight(function(){
      return arguments;
    }(1, 2, 3), function(a, b){
      return '' + b * b + a;
    }) === '143');
    ok(reduceRight('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }, 1) === 7);
  });
  test('.copyWithin', function(){
    var copyWithin, a;
    copyWithin = Array.copyWithin;
    ok(copyWithin(a = function(){
      return arguments;
    }(1, 2, 3), 0) === a);
    deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), -2), function(){
      return arguments;
    }(1, 1, 2));
    deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), 0, 1), function(){
      return arguments;
    }(2, 3, 3));
    deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), 0, 1, 2), function(){
      return arguments;
    }(2, 2, 3));
  });
  test('.fill', function(){
    var fill, a;
    fill = Array.fill;
    ok(fill(a = function(){
      return arguments;
    }(1, 2, 3), 0) === a);
    deepEqual(fill(Array(3), 5), [5, 5, 5]);
  });
  test('.find', function(){
    var find, al, ctx;
    find = Array.find;
    find(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(find(function(){
      return arguments;
    }(1, 3, NaN, 42, {}), (function(it){
      return it === 42;
    })) === 42);
    ok(find('123', (function(it){
      return it === '2';
    })) === '2');
    ok(find('123', (function(it){
      return it === '4';
    })) === void 8);
  });
  test('.findIndex', function(){
    var findIndex, al, ctx;
    findIndex = Array.findIndex;
    findIndex(al = function(){
      return arguments;
    }(1), function(val, key, that){
      ok(this === ctx);
      ok(val === 1);
      ok(key === 0);
      return ok(that === al);
    }, ctx = {});
    ok(findIndex(function(){
      return arguments;
    }(1, 3, NaN, 42, {}), (function(it){
      return it === 42;
    })) === 3);
    ok(findIndex('123', (function(it){
      return it === '2';
    })) === 1);
    ok(findIndex('123', (function(it){
      return it === '4';
    })) === -1);
  });
  test('.keys', function(){
    var keys, iter1, iter2;
    keys = Array.keys;
    ok(typeof keys === 'function', 'Is function');
    iter1 = keys(function(){
      return arguments;
    }('q', 'w', 'e'));
    ok(typeof iter1 === 'object', 'Iterator is object');
    ok(typeof iter1.next === 'function', 'Iterator has .next method');
    deepEqual(iter1.next(), {
      value: 0,
      done: false
    });
    deepEqual(iter1.next(), {
      value: 1,
      done: false
    });
    deepEqual(iter1.next(), {
      value: 2,
      done: false
    });
    deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = keys('qwe');
    deepEqual(iter2.next(), {
      value: 0,
      done: false
    });
    deepEqual(iter2.next(), {
      value: 1,
      done: false
    });
    deepEqual(iter2.next(), {
      value: 2,
      done: false
    });
    deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.values', function(){
    var values, iter1, iter2;
    values = Array.values;
    ok(typeof values === 'function', 'Is function');
    iter1 = values(function(){
      return arguments;
    }('q', 'w', 'e'));
    ok(typeof iter1 === 'object', 'Iterator is object');
    ok(typeof iter1.next === 'function', 'Iterator has .next method');
    deepEqual(iter1.next(), {
      value: 'q',
      done: false
    });
    deepEqual(iter1.next(), {
      value: 'w',
      done: false
    });
    deepEqual(iter1.next(), {
      value: 'e',
      done: false
    });
    deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = values('qwe');
    deepEqual(iter2.next(), {
      value: 'q',
      done: false
    });
    deepEqual(iter2.next(), {
      value: 'w',
      done: false
    });
    deepEqual(iter2.next(), {
      value: 'e',
      done: false
    });
    deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.entries', function(){
    var entries, iter1, iter2;
    entries = Array.entries;
    ok(typeof entries === 'function', 'Is function');
    iter1 = entries(function(){
      return arguments;
    }('q', 'w', 'e'));
    ok(typeof iter1 === 'object', 'Iterator is object');
    ok(typeof iter1.next === 'function', 'Iterator has .next method');
    deepEqual(iter1.next(), {
      value: [0, 'q'],
      done: false
    });
    deepEqual(iter1.next(), {
      value: [1, 'w'],
      done: false
    });
    deepEqual(iter1.next(), {
      value: [2, 'e'],
      done: false
    });
    deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = entries('qwe');
    deepEqual(iter2.next(), {
      value: [0, 'q'],
      done: false
    });
    deepEqual(iter2.next(), {
      value: [1, 'w'],
      done: false
    });
    deepEqual(iter2.next(), {
      value: [2, 'e'],
      done: false
    });
    deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.includes', function(){
    var includes, args, o, str;
    includes = Array.includes;
    ok(isFunction(includes), 'Is function');
    args = function(){
      return arguments;
    }(1, 2, 3, -0, NaN, o = {});
    ok(includes(args, 1));
    ok(includes(args, -0));
    ok(includes(args, 0));
    ok(includes(args, NaN));
    ok(includes(args, o));
    ok(!includes(args, 4));
    ok(!includes(args, -0.5));
    ok(!includes(args, {}));
    str = 'qwe';
    ok(includes(str, 'q'));
    ok(!includes(str, 'r'));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, toString$ = {}.toString;
  QUnit.module('DOM iterable');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  if ((typeof NodeList != 'undefined' && NodeList !== null) && ((typeof document != 'undefined' && document !== null) && document.querySelectorAll) && document.querySelectorAll('div') instanceof NodeList) {
    test('NodeList.prototype@@iterator', function(){
      ok(isFunction(document.querySelectorAll('div')[Symbol.iterator]), 'Is function');
    });
  }
  if ((typeof HTMLCollection != 'undefined' && HTMLCollection !== null) && ((typeof document != 'undefined' && document !== null) && document.getElementsByTagName) && document.getElementsByTagName('div') instanceof HTMLCollection) {
    test('HTMLCollection.prototype@@iterator', function(){
      ok(isFunction(document.getElementsByTagName('div')[Symbol.iterator]), 'Is function');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var isFunction, eq, timeLimitedPromise, toString$ = {}.toString;
  QUnit.module('Immediate');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  eq = strictEqual;
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  test('setImmediate / clearImmediate', function(it){
    var def;
    it.expect(10);
    ok(isFunction(setImmediate), 'setImmediate is function');
    ok(isFunction(clearImmediate), 'clearImmediate is function');
    ok(/native code/.test(setImmediate), 'setImmediate looks like native');
    ok(/native code/.test(clearImmediate), 'clearImmediate looks like native');
    eq(setImmediate.name, 'setImmediate', 'setImmediate.name is "setImmediate"');
    eq(clearImmediate.name, 'clearImmediate', 'clearImmediate.name is "clearImmediate"');
    timeLimitedPromise(1e3, function(res){
      return setImmediate(function(){
        def = 'a';
        return res();
      });
    }).then(function(){
      return ok(true, 'setImmediate works');
    })['catch'](function(){
      return ok(false, 'setImmediate works');
    }).then(it.async());
    eq(def, void 8, 'setImmediate is async');
    timeLimitedPromise(1e3, function(res){
      return setImmediate(function(a, b){
        return res(a + b);
      }, 'a', 'b');
    }).then(function(it){
      return eq(it, 'ab', 'setImmediate works with additional args');
    })['catch'](function(){
      return ok(false, 'setImmediate works with additional args');
    }).then(it.async());
    timeLimitedPromise(50, function(res){
      return clearImmediate(setImmediate(res));
    }).then(function(){
      return ok(false, 'clearImmediate works');
    })['catch'](function(){
      return ok(true, 'clearImmediate works');
    }).then(it.async());
  });
  (function(it){
    if (typeof window != 'undefined' && window !== null) {
      return window.onload = it;
    } else {
      return it();
    }
  })(function(){
    return setTimeout(function(){
      var x, now, inc;
      x = 0;
      now = Date.now();
      return (inc = function(){
        return setImmediate(function(){
          x = x + 1;
          if (Date.now() - now < 5e3) {
            return inc();
          } else {
            return typeof console != 'undefined' && console !== null ? console.log("setImmediate: " + x / 5 + " per second") : void 8;
          }
        });
      })();
    }, 5e3);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var eq, timeLimitedPromise, global;
  QUnit.module('Timers');
  eq = strictEqual;
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  global = Function('return this')();
  test('setTimeout / clearTimeout', function(it){
    it.expect(2);
    timeLimitedPromise(1e3, function(res){
      return global.setTimeout(function(a, b){
        return res(a + b);
      }, 10, 'a', 'b');
    }).then(function(it){
      return eq(it, 'ab', 'setTimeout works with additional args');
    })['catch'](function(){
      return ok(false, 'setTimeout works with additional args');
    }).then(it.async());
    timeLimitedPromise(50, function(res){
      return clearTimeout(setTimeout(res, 10));
    }).then(function(){
      return ok(false, 'clearImmediate works with wraped setTimeout');
    })['catch'](function(){
      return ok(true, 'clearImmediate works with wraped setTimeout');
    }).then(it.async());
  });
  test('setInterval / clearInterval', function(it){
    var i;
    it.expect(1);
    i = 0;
    timeLimitedPromise(1e4, function(res, rej){
      var interval;
      return interval = global.setInterval(function(a, b){
        if (a + b !== 'ab' || i > 2) {
          rej({
            a: a,
            b: b,
            i: i
          });
        }
        if (i++ === 2) {
          global.clearInterval(interval);
          return global.setTimeout(res, 30);
        }
      }, 5, 'a', 'b');
    }).then(function(){
      return ok(true, 'setInterval & clearInterval works with additional args');
    })['catch'](function(arg$){
      var ref$, a, b, i;
      ref$ = arg$ != null
        ? arg$
        : {}, a = ref$.a, b = ref$.b, i = ref$.i;
      return ok(false, "setInterval & clearInterval works with additional args: " + a + ", " + b + ", times: " + i);
    }).then(it.async());
  });
}).call(this);
